SystemOrganization addCategory: 'Orbeon'!

!Date class methodsFor: '*orbeon' stamp: 'BrunoBB 02/13/2014 04:34'!
fromMySqlString: aString
	| newDateString |

	newDateString := (aString subStrings: '-') third.
	newDateString := newDateString, '/', (aString subStrings: '-') second.
	newDateString := newDateString, '/', (aString subStrings: '-') first.

	^Date fromString: newDateString! !

!Date methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:14'!
printMySqlString

	^self year printString, '-', self monthIndex printString , '-', self dayOfMonth printString! !

AppFieldValueHolder subclass: #OrbeonFieldValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!TimeStamp class methodsFor: '*orbeon' stamp: 'BrunoBB 12/23/2013 04:57'!
fromMySqlString: aString
	| dateString timeString newDateString |

	aString isEmpty ifTrue: [^nil].
	dateString := (aString subStrings: ' ') first.
	timeString := (aString subStrings: ' ') second.
	newDateString := (dateString subStrings: '-') second, '/'.
	newDateString := newDateString, (dateString subStrings: '-') third, '/'.
	newDateString := newDateString, (dateString subStrings: '-') first.

	^self fromString: newDateString, ' ', timeString! !

!TimeStamp methodsFor: '*orbeon' stamp: 'BrunoBB 10/15/2015 14:24'!
asOrbeonDateTimeString
	"yyyy-mm-ddThh:mm:ss+zzzz"
	| string offsetHours offsetMinutes |
	string := self asStringUsingFormat: #(3 2 1 $- 1 1 $: true true false).
	string at: 11 put: $T.
	string add: $..
	offset := offset abs // 60.
	offsetHours := offset // 60.
	offsetMinutes := offset \\ 60.
	offsetHours < 10 ifTrue: [string add: $0].
	string addAll: offsetHours printString.
	offsetMinutes < 10 ifTrue: [string add: $0].
	string addAll: offsetMinutes printString.
	^string.! !

!TimeStamp methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:16'!
printMySqlString

	^self date year printString, '-', 
		self date monthIndex printString, '-', 
		self date day printString, ' ', 
		self time printString! !

!DateTime class methodsFor: '*orbeon' stamp: 'BrunoBB 10/15/2015 13:56'!
fromMySqlString: aString
	| dateString timeString newDateString |

	dateString := (aString subStrings: ' ') first.
	timeString := ((aString subStrings: ' ') second subStrings: '.') first.
	newDateString := (dateString subStrings: '-') third, '/'.
	newDateString := newDateString, (dateString subStrings: '-') second, '/'.
	newDateString := newDateString, (dateString subStrings: '-') first.

	^DateTime fromString: newDateString, ' ', timeString! !

!DateTime methodsFor: '*orbeon' stamp: 'BrunoBB 08/06/2015 10:12'!
asOrbeonDateTimeString
	"yyyy-mm-ddThh:mm:ss+zzzz"

	| string offset offsetHours offsetMinutes |
	string := self asStringUsingFormat: #(3 2 1 $- 1 1 $: true true false).
	string at: 11 put: $T.
	offset := timeZone offsetAtLocal: self.
	string add: $..
	offset := offset abs // 60.
	offsetHours := offset // 60.
	offsetMinutes := offset \\ 60.
	offsetHours < 10 ifTrue: [string add: $0].
	string addAll: offsetHours printString.
	offsetMinutes < 10 ifTrue: [string add: $0].
	string addAll: offsetMinutes printString.
	^string.! !

!DateTime methodsFor: '*orbeon' stamp: 'BrunoBB 10/15/2015 14:02'!
printMySqlString

	"^self asDate printMySqlString, ' ', self asTime printMySqlString"

	^self asDateAndTime asTimeStamp printMySqlString! !

Object subclass: #FormComparator
	instanceVariableNames: 'formOne formTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormComparator class methodsFor: 'other' stamp: 'BrunoBB 02/11/2015 05:54'!
formOne: anOrbeonFormInstance

	^super new initialize
		formOne: anOrbeonFormInstance;
		yourself! !

!FormComparator class methodsFor: 'other' stamp: 'BrunoBB 02/11/2015 05:54'!
formOne: anOrbeonFormInstance formTwo: formInstance

	^super new initialize
		formOne: anOrbeonFormInstance;
		formTwo: formInstance;
		yourself! !

!FormComparator methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2015 05:54'!
formOne

   "Return the value of the instance variable 'formOne'."
   ^formOne! !

!FormComparator methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2015 05:54'!
formOne: newValue

   "Modify the value of the instance variable 'formOne'."
   formOne := newValue! !

!FormComparator methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2015 05:54'!
formTwo

   "Return the value of the instance variable 'formTwo'."
   ^formTwo! !

!FormComparator methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2015 05:54'!
formTwo: newValue

   "Modify the value of the instance variable 'formTwo'."
   formTwo := newValue! !

FormComparator subclass: #FormDefinitionComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormDefinitionComparator commentStamp: '' prior: 0!
This class compare two OrbeonFormDefinition and answer a collection with the differences.

It is used when an Orbeon Definition in the database (MySQL) has been updated. 

If the comparison IS Empty then the forms are equal and there is NO need to create another version.

If the comparison is NOT Empty then the forms are NOT equal and we should create another version.

This is an automatic process.!

!FormDefinitionComparator methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 09:02'!
compare
	"The receiver compare <formOne> and <formTwo> and answer a collection with the differences"
	| difference sectionsOne sectionsTwo |

	difference := OrderedCollection new.
	
	sectionsOne := formOne sectionDefinitions. 
	sectionsTwo := formTwo sectionDefinitions.

	sectionsOne do: [:each | | eachTwoIndex sectionTwo | "compare sections one by one in formOne and formTwo"
		sectionTwo := sectionsTwo at: each name 
			ifAbsent: [difference add: (SectionDoesNotExist form: formOne object: each). nil].
		"here we compare the tree structure between the two forms"
		sectionTwo ifNotNil: [self compareSection: each with: sectionTwo on: difference]]. 

	^difference! !

!FormDefinitionComparator methodsFor: 'other' stamp: 'BrunoBB 02/13/2015 15:54'!
compareNames: formOneNames with: formTwoNames on: anOrderedCollection differenceClass: difClass
	"Compares the names contained in <formOneNames> with the names in <formTwoNames>.
	If a difference is found then store it in <anOrderedCollection> using the class <difClass> to create the difference object"

	(formOneNames difference: formTwoNames) do: [:each | anOrderedCollection add: (difClass form: formOne object: each)].

	(formTwoNames difference: formOneNames) do: [:each | anOrderedCollection add: (difClass form: formTwo object: each)].
	
	^anOrderedCollection! !

!FormDefinitionComparator methodsFor: 'other' stamp: 'BrunoBB 02/13/2015 15:56'!
compareSection: aSectionDefinitionOne with: aSectionDefinitionTwo on: anOrderedCollection
	"The receiver recursively compare section <aSectionDefinitionOne> with section <aSectionDefinitionTwo> structures.
	The comparison also includes the fields of each section. Append differences to the argument <anOrderedCollection>"
	| subSectionsOne |

	"comparing fields contained in sections <aSectionDefinitionOne> and <aSectionDefinitionTwo>"
	self compareNames: aSectionDefinitionOne fieldNames with: aSectionDefinitionTwo fieldNames on: anOrderedCollection differenceClass: FieldDoesNotExist.

	aSectionDefinitionOne hasSubSections ifFalse: [^anOrderedCollection]. "recursive HALT"

	subSectionsOne := aSectionDefinitionOne subSections.
	"comparing the tree structure of the sections <aSectionDefinitionOne> and <aSectionDefinitionTwo>"
	subSectionsOne do: [:each | | subSectionsTwo eachTwoIndex subSectionTwo |
		subSectionsTwo := aSectionDefinitionTwo subSections.
		eachTwoIndex := subSectionsOne indexOf: each.
		subSectionTwo := subSectionsTwo at: eachTwoIndex.
		self compareSection: each with: subSectionTwo on: anOrderedCollection]. "recursive CALL"

	^anOrderedCollection! !

!FormDefinitionComparator methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 08:58'!
shouldCreateAnotherVersion
	"Answer wheter or not <formOne> and <formTwo> should be different versions"

	^self compare notEmpty! !

FormComparator subclass: #FormInstanceComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
buildSummaryWith: aDictionary
	"Compare the receiver <formOne> with the dictionary of fields <aDictionary>. Answer matching and mismatching fields values.
	Check each key of <aDictionary> with the field names of <formOne>. 
	If the key and field name match then compare the value of the <aDictionary> for that key with the field value of <formOne>"
	| comparision |

	comparision := OrderedCollection new.
	aDictionary keysAndValuesDo: [:key :value |
		(formOne fields includesKey: key) "<formOne> has this field named <key> ???"
		ifFalse: [comparision add: (FieldDoesNotExist form: formOne fieldName: key)] "field in <formOne> doed NOT exist"
		ifTrue: [(value = (formOne valueAt: key)) 
					ifFalse: [comparision 
									add: ((FieldValueNotEqual form: formOne fieldName: key) "field in <formOne> doed exist but NOT equal value"
											valueOne: value;
											valueTwo: (formOne valueAt: key);
											yourself).]
					ifTrue: [comparision 
									add: ((FieldValueEqual form: formOne fieldName: key) "field in <formOne> doed exist with equal value"
											valueOne: value;
											yourself)] ]].
	^comparision! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
compare
	"Compare the receiver <formOne> with <formTwo>. ONLY answer differences at field value level.
	Check each field name of <formOne> is included in <formTwo>. 
	If the field name exist then compare the value of the <formOne> field with <formTwo> field value"
	| difference |

	difference := OrderedCollection new.
	formOne fields keysAndValuesDo: [:key :value |
		(formTwo hasFieldNamed: key) "<formTwo> has the field name <key> of <formOne> ???"
		ifFalse: [difference add: (FieldDoesNotExist form: formTwo fieldName: key)] "field does NOT exist in <formTwo> "
		ifTrue: [(value = (formTwo valueAt: key)) 
					ifFalse: [difference 
									add: ((FieldValueNotEqual form: formTwo fieldName: key) "field exist but value is different"
											valueOne: value;
											valueTwo: (formTwo valueAt: key);
											yourself).
					] 	]  ].
	^difference! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
compareWith: aDictionary
	"Compare the receiver <formOne> with the dictionary of fields <aDictionary>.ONLY answer mismatching fields values.
	Check field names of <formOne> with each key of <aDictionary>. 
	If the key and field name match then compare the value of the <aDictionary> for that key with the field value of <formOne>"
	| difference |

	difference := OrderedCollection new.
	formOne fields keysAndValuesDo: [:key :value |
		(aDictionary includesKey: key)
		ifFalse: [difference add: (FieldDoesNotExist form: nil fieldName: key)] "<aDictionary> does NOT include <formOne> field"
		ifTrue: [(value = (aDictionary at: key)) "<aDictionary> VALUE does is equal to <formOne> field value ???"
					ifFalse: [difference 
									add: ((FieldValueNotEqual form: nil fieldName: key) "value is different"
											valueOne: value;
											valueTwo: (aDictionary at: key);
											yourself).
					] 	]  ].
	^difference! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 11:49'!
showFieldDoesNotExist
	"The receiver answer a collection of difference of type <FieldDoesNotExist>"

	^self compare select: [:each | each class == FieldDoesNotExist]! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 03/14/2015 11:49'!
showFieldDoesNotExistWith: aDictionary
	"The receiver answer a collection of difference with <aDictionary> of type <FieldDoesNotExist>"

	^(self compareWith: aDictionary) select: [:each | each class == FieldDoesNotExist]! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
showSummaryWith: aDictionary
	| summary |

	summary := ''.

	(self buildSummaryWith: aDictionary) do: [:each | summary := summary, each printResume, String lf].

	^summary! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
showValueNotEqual

	^self compare select: [:each | each class == FieldValueNotEqual]! !

!FormInstanceComparator methodsFor: 'other' stamp: 'BrunoBB 02/06/2015 14:14'!
showValueNotEqualWith: aDictionary

	^(self compareWith: aDictionary) select: [:each | each class == FieldValueNotEqual]! !

Object subclass: #FormDifference
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

FormDifference subclass: #FieldDifference
	instanceVariableNames: 'field'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FieldDifference class methodsFor: 'other' stamp: 'BrunoBB 09/27/2014 12:33'!
form: anOrbeonFormInstance

	^super new initialize
		form: anOrbeonFormInstance;
		yourself! !

!FieldDifference class methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 03:21'!
form: anOrbeonForm fieldName: fieldName

	^super new initialize
		form: anOrbeonForm;
		field: fieldName;
		yourself! !

!FieldDifference class methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 03:20'!
form: anOrbeonForm object: anObject

	^self form: anOrbeonForm fieldName: anObject! !

!FieldDifference methodsFor: 'Accessing' stamp: 'BrunoBB 09/27/2014 12:33'!
field

   "Return the value of the instance variable 'field'."
   ^field! !

!FieldDifference methodsFor: 'Updating' stamp: 'BrunoBB 09/27/2014 12:33'!
field: newValue

   "Modify the value of the instance variable 'field'."
   field := newValue! !

!FieldDifference methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 13:46'!
isEqual
	^false! !

!FieldDifference methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 13:46'!
isNotEqual
	^false! !

!FieldDifference methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 12:14'!
printResume

	^self subclassResponsibility! !

FieldDifference subclass: #FieldDoesNotExist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FieldDoesNotExist methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 12:15'!
printResume

	^field, ' does not exist'! !

FieldDifference subclass: #FieldTypeNotEqual
	instanceVariableNames: 'typeOne typeTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FieldTypeNotEqual class methodsFor: 'other' stamp: 'BrunoBB 02/09/2015 11:59'!
form: anOrbeonFormDefinition typeOne: typeOne typeTwo: typeTwo

	^super new initialize
		form: anOrbeonFormDefinition;
		typeOne: typeOne;
		typeTwo: typeTwo;
		yourself! !

!FieldTypeNotEqual methodsFor: 'Accessing' stamp: 'BrunoBB 02/09/2015 11:47'!
typeOne

   "Return the value of the instance variable 'typeOne'."
   ^typeOne! !

!FieldTypeNotEqual methodsFor: 'Updating' stamp: 'BrunoBB 02/09/2015 11:47'!
typeOne: newValue

   "Modify the value of the instance variable 'typeOne'."
   typeOne := newValue! !

!FieldTypeNotEqual methodsFor: 'Accessing' stamp: 'BrunoBB 02/09/2015 11:47'!
typeTwo

   "Return the value of the instance variable 'typeTwo'."
   ^typeTwo! !

!FieldTypeNotEqual methodsFor: 'Updating' stamp: 'BrunoBB 02/09/2015 11:47'!
typeTwo: newValue

   "Modify the value of the instance variable 'typeTwo'."
   typeTwo := newValue! !

FieldDifference subclass: #FieldValueEqual
	instanceVariableNames: 'valueOne'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FieldValueEqual methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 13:46'!
isEqual
	^true! !

!FieldValueEqual methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 14:01'!
printResume

	^(form labelAt: field), String lf, valueOne, ', [OK]'! !

!FieldValueEqual methodsFor: 'Accessing' stamp: 'BrunoBB 09/28/2014 12:10'!
valueOne

   "Return the value of the instance variable 'valueOne'."
   ^valueOne! !

!FieldValueEqual methodsFor: 'Updating' stamp: 'BrunoBB 09/28/2014 12:10'!
valueOne: newValue

   "Modify the value of the instance variable 'valueOne'."
   valueOne := newValue! !

FieldDifference subclass: #FieldValueNotEqual
	instanceVariableNames: 'valueOne valueTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FieldValueNotEqual methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 13:46'!
isNotEqual
	^true! !

!FieldValueNotEqual methodsFor: 'other' stamp: 'BrunoBB 09/28/2014 13:29'!
printResume

	^field, String lf, valueOne, ' <> ' , valueTwo, ', [Error]'! !

!FieldValueNotEqual methodsFor: 'Accessing' stamp: 'BrunoBB 09/27/2014 12:43'!
valueOne

   "Return the value of the instance variable 'valueOne'."
   ^valueOne! !

!FieldValueNotEqual methodsFor: 'Updating' stamp: 'BrunoBB 09/27/2014 12:43'!
valueOne: newValue

   "Modify the value of the instance variable 'valueOne'."
   valueOne := newValue! !

!FieldValueNotEqual methodsFor: 'Accessing' stamp: 'BrunoBB 09/27/2014 12:43'!
valueTwo

   "Return the value of the instance variable 'valueTwo'."
   ^valueTwo! !

!FieldValueNotEqual methodsFor: 'Updating' stamp: 'BrunoBB 09/27/2014 12:43'!
valueTwo: newValue

   "Modify the value of the instance variable 'valueTwo'."
   valueTwo := newValue! !

!FormDifference class methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 03:20'!
form: anOrbeonFormInstance object: anObject

	self subclassResponsibility! !

!FormDifference methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2015 05:54'!
form

   "Return the value of the instance variable 'form'."
   ^form! !

!FormDifference methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2015 05:54'!
form: newValue

   "Modify the value of the instance variable 'form'."
   form := newValue! !

FormDifference subclass: #FormSectionDifference
	instanceVariableNames: 'section'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormSectionDifference class methodsFor: 'other' stamp: 'BrunoBB 02/12/2015 03:21'!
form: anOrbeonForm object: anObject

	^self form: anOrbeonForm sectionName: anObject! !

!FormSectionDifference class methodsFor: 'other' stamp: 'BrunoBB 02/09/2015 11:46'!
form: anOrbeonFormDefinition sectionName: sectionName

	^super new initialize
		form: anOrbeonFormDefinition;
		section: sectionName;
		yourself! !

!FormSectionDifference methodsFor: 'Accessing' stamp: 'BrunoBB 02/09/2015 11:48'!
section

   "Return the value of the instance variable 'section'."
   ^section! !

!FormSectionDifference methodsFor: 'Updating' stamp: 'BrunoBB 02/09/2015 11:48'!
section: newValue

   "Modify the value of the instance variable 'section'."
   section := newValue! !

FormSectionDifference subclass: #SectionDoesNotExist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

FormSectionDifference subclass: #SectionStructureMismatch
	instanceVariableNames: 'structureDifferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!SectionStructureMismatch methodsFor: 'other' stamp: 'BrunoBB 02/07/2015 15:09'!
addMismatch: aSectionDoesNotExist

	^structureDifferences add: aSectionDoesNotExist! !

!SectionStructureMismatch methodsFor: 'other' stamp: 'BrunoBB 02/07/2015 15:08'!
initialize

	super initialize.

	structureDifferences := OrderedCollection new.! !

!SectionStructureMismatch methodsFor: 'Accessing' stamp: 'BrunoBB 02/07/2015 15:08'!
structureDifferences

   "Return the value of the instance variable 'structureDifferences'."
   ^structureDifferences! !

!SectionStructureMismatch methodsFor: 'Updating' stamp: 'BrunoBB 02/07/2015 15:08'!
structureDifferences: newValue

   "Modify the value of the instance variable 'structureDifferences'."
   structureDifferences := newValue! !

Object subclass: #FormExportProcess
	instanceVariableNames: 'definition formsCollection printArray lineNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormExportProcess class methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
definition: anOrbeonFormDefinition formsCollection: anOrderedCollection

	^super new initialize
		definition: anOrbeonFormDefinition;
		formsCollection: anOrderedCollection;
		yourself! !

!FormExportProcess methodsFor: 'export' stamp: 'BrunoBB 04/14/2015 16:05'!
currentInfo
	| info |

	info := (printArray at: lineNumber ifAbsent: [^'']) at: 2 "info" ifAbsent: [''].

	info ifNil: [^''].

	^info! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
definition

   "Return the value of the instance variable 'definition'."
   ^definition! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
definition: newValue

   "Modify the value of the instance variable 'definition'."
   definition := newValue! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
formsCollection

   "Return the value of the instance variable 'formsCollection'."
   ^formsCollection! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
formsCollection: newValue

   "Modify the value of the instance variable 'formsCollection'."
   formsCollection := newValue! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:04'!
initialize

	super initialize.

	printArray := Array new.
	lineNumber := 0.! !

!FormExportProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/14/2015 16:02'!
lineNumber
	^lineNumber! !

!FormExportProcess methodsFor: 'Updating' stamp: 'BrunoBB 04/14/2015 16:02'!
lineNumber: newValue
	lineNumber := newValue! !

!FormExportProcess methodsFor: 'other' stamp: 'BrunoBB 04/14/2015 16:02'!
numberOfFields
	"Answer the number of fields of the OrbeonFormDefinition <definition>.
	Plus 2 is used to add 2 extra columns, one for form <id> and another to insert extra data"

	^definition fieldDefinitions size + 2! !

!FormExportProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/14/2015 16:02'!
printArray
	^printArray! !

!FormExportProcess methodsFor: 'Updating' stamp: 'BrunoBB 04/14/2015 16:02'!
printArray: newValue
	printArray := newValue! !

!FormExportProcess methodsFor: 'export' stamp: 'BrunoBB 04/14/2015 16:05'!
printMatrix
	"Print the export structure to a PrintStream"
	| stream |

	stream := PrintStream on: String new.

	self printMatrixToStream: stream.

	^stream! !

!FormExportProcess methodsFor: 'export' stamp: 'BrunoBB 04/15/2015 05:46'!
printMatrixToStream: aStream
	"The receiver iterate over structure <printArray> and put it's content on <aStream>"

	printArray do: [:columnArray | "row iteration"
		columnArray do: [:columnValue |  "column iteration"
			columnValue 
			ifNotNil: [aStream nextPutAll: columnValue; nextPutAll: String tab] 
			ifNil: [aStream nextPutAll: String tab].
		].
		aStream nextPutAll: String lf.
	].

	^aStream! !

!FormExportProcess methodsFor: 'export' stamp: 'BrunoBB 04/14/2015 16:06'!
printMatrixToWriteStream
	| stream |

	stream := WriteStream on: String new.

	self printMatrixToStream: stream.

	^stream! !

!FormExportProcess methodsFor: 'export' stamp: 'BrunoBB 04/14/2015 16:06'!
printToFile: pathFile
	| stream |

	stream := FileStream write: pathFile.

	self printMatrixToStream: stream.

	stream flush; close.! !

FormExportProcess subclass: #RecursiveFormExport
	instanceVariableNames: 'fieldPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

RecursiveFormExport subclass: #MultilineRecursiveFormExport
	instanceVariableNames: 'columnNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!MultilineRecursiveFormExport methodsFor: 'Accessing' stamp: 'BrunoBB 05/10/2015 15:47'!
columnNumber

   "Return the value of the instance variable 'columnNumber'."
   ^columnNumber! !

!MultilineRecursiveFormExport methodsFor: 'Updating' stamp: 'BrunoBB 05/10/2015 15:47'!
columnNumber: newValue

   "Modify the value of the instance variable 'columnNumber'."
   columnNumber := newValue! !

!MultilineRecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 02/10/2016 10:58'!
generatePrintArray
	"The receiver creates anArray with values to export to a CSV file"

	fieldPositions at: 'id' put: 1. "the first column is the <id> of the form"
	fieldPositions at: 'info' put: 2. "the secon column is for extra information"

	definition getFieldsNames keysAndValuesDo: [:index :fieldName | "from 2nd column we put the name of the fields"
		fieldPositions at: fieldName put: (index + 2). 
		printArray at: index put: Array new. "<printArray> is an Array of Arrays."].

	"at: 1 put the names of the fields"
	printArray at: 1 put: (fieldPositions asSortedArray collect: [:index | fieldPositions keyAtValue: index ifAbsent: [nil]]).
	"at: 2 put the labels of the fields"

	printArray at: 2 put: Array new. "in the row below of field names we set the fields label"
	(printArray at: 1) keysAndValuesDo: [:index :fieldName | | label |
		label := (definition labelAt: fieldName) copyWithoutAll: String lf.
		(printArray at: 2) at: index put: label].

	lineNumber := 3. "the actual data is put from row 3 ..."

	formsCollection do: [:each | self printInstance: each.]! !

!MultilineRecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 05/10/2015 15:50'!
initialize

	super initialize.

	columnNumber := 0.! !

!MultilineRecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 05/10/2015 15:51'!
insert: fieldName value: fieldValue
	"The receiver insert in Array <valueArray> at <column> the value <fieldValue>. 
	<column> is the row index of the field <fieldName>
	<valueArray>  is <printArray> at <lineNumber>"
	| column valueArray |

	column := fieldPositions at: fieldName. "get the column of <fieldName>"
	valueArray := printArray at: lineNumber. "get the current row"
	valueArray at: column put: fieldValue. "insert the value"! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printFormSectionInstance: aFormSectionInstance
	"The receiver map the section instance <aFormSectionInstance> to <printArray>"

	aFormSectionInstance isRepeatable  "if repeatable then print all iterations in <printArray>"
	ifTrue: [^aFormSectionInstance iterationsDo: [:each | self printFormSectionInstance: each]].

	"initialize all Row Array"
	1 to: self numberOfFields do: [:each | printArray at: lineNumber put: (Array new: self numberOfFields)].

	(printArray at: lineNumber) at: 1 "id" put: aFormSectionInstance id.

	self printInstancesFieldsOf: aFormSectionInstance. "print top fields of <aFormSectionInstance>"

	self printInstancesGridsOf: aFormSectionInstance. "print top grids of <aFormSectionInstance>"

	"print subsections of <aFormSectionInstance>"
	^aFormSectionInstance getSectionsToExport do: [:each | self printFormSectionInstance: each].! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printInfoForFormFieldsOf: aFormSectionInstance

	(printArray at: lineNumber) at: 2 "info" put: self currentInfo, '-', aFormSectionInstance name, '-', aFormSectionInstance printExportType.! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printInfoForGrid: aFormGridInstance

	(printArray at: lineNumber) at: 2 "info" put: self currentInfo, '-', aFormGridInstance sectionName, '-',aFormGridInstance name.! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printInstance: anOrbeonFormInstance

	anOrbeonFormInstance getSectionsToExport do: [:each | self printFormSectionInstance: each].! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printInstancesFieldsOf: aFormSectionInstance
	"The receiver print the top fields of <aFormSectionInstance> in <printArray>"

	self printInfoForFormFieldsOf: aFormSectionInstance. "put info of the section <aFormSectionInstance> in the second column"
	
	aFormSectionInstance fields keysAndValuesDo: [:fieldName :fieldValue |
		
		self insert: fieldName value: fieldValue. "for each field insert in <printArray> field name and value"
	].

	(aFormSectionInstance fields notEmpty) ifTrue: [lineNumber := lineNumber + 1.]. "new row if the fields where not empty"! !

!MultilineRecursiveFormExport methodsFor: 'export' stamp: 'BrunoBB 05/10/2015 15:47'!
printInstancesGridsOf: aFormSectionInstance
	"The receiver print the top grids of <aFormSectionInstance> in <printArray>"

	aFormSectionInstance grids do: [:eachGrid | 
		eachGrid gridIterations do: [:eachDictionary | "initialize array for each grid iteration"
			1 to: self numberOfFields do: [:each | printArray at: lineNumber put: (Array new: self numberOfFields)].

			self printInfoForGrid: eachGrid. "print in the 2 column info about the grid"

			(printArray at: lineNumber) at: 1 "id" put: aFormSectionInstance id.

			eachDictionary keysAndValuesDo: [:fieldName :fieldValue |
				
				self insert: fieldName value: fieldValue]. "for each field insert in <printArray> field name and value"

			lineNumber := lineNumber + 1.
		]
	].! !

!RecursiveFormExport methodsFor: 'Accessing' stamp: 'BrunoBB 05/10/2015 15:51'!
fieldPositions
	^fieldPositions! !

!RecursiveFormExport methodsFor: 'Updating' stamp: 'BrunoBB 05/10/2015 15:51'!
fieldPositions: newValue
	fieldPositions := newValue! !

!RecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 05/10/2015 15:50'!
initialize

	super initialize.

	fieldPositions := Dictionary new.! !

RecursiveFormExport subclass: #SinglelineRecursiveFormExport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!SinglelineRecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 02/10/2016 11:00'!
generatePrintArray
	"The receiver creates anArray with values to export to a CSV file"
	| fieldSpace previousColumunShift firsElement |

	fieldSpace := self getFieldsNameSpace. "aDictionary fieldName-->columunShift"
	lineNumber := 3.
	previousColumunShift := 1.
	printArray at: 1 put: (Array new: 500).
	printArray at: 2 put: (Array new: 500).
	printArray at: 3 put: Array new.
	firsElement := formsCollection isEmpty ifTrue: [nil] ifFalse: [formsCollection first].
	fieldSpace keysAndValuesDo: [:fieldName :columunShift | | label |
		(printArray at: 1) at: previousColumunShift put: fieldName.
		label := (firsElement labelAt: fieldName) copyWithoutAll: String lf.
		(printArray at: 2) at: previousColumunShift put: label.
		previousColumunShift := previousColumunShift + columunShift].

	formsCollection do: [:eachForm | | newArray columnNumber |
		newArray := Array new: 500.
		columnNumber := 0.
		eachForm getAllFields keysAndValuesDo: [:fieldName :valueCollection | 
			newArray addAll: valueCollection afterIndex: columnNumber.
			columnNumber := columnNumber + (fieldSpace at: fieldName).
		].
		printArray at: lineNumber put: newArray.	
		lineNumber := 	lineNumber + 1.	
	].! !

!SinglelineRecursiveFormExport methodsFor: 'other' stamp: 'BrunoBB 05/11/2015 05:22'!
getFieldsNameSpace
	| fieldSpace |

	fieldSpace := Dictionary new.
	formsCollection do: [:eachForm |
		eachForm getAllFields keysAndValuesDo: [:fieldName :valueCollection |
			(fieldSpace includesKey: fieldName)
			ifTrue: [fieldSpace at: fieldName put: ((fieldSpace at: fieldName) max: valueCollection size).]
			ifFalse: [fieldSpace at: fieldName put: valueCollection size].		
		].
	].

	^fieldSpace! !

FormExportProcess subclass: #SinglelineSimpleFormExport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!SinglelineSimpleFormExport methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 10:50'!
generatePrintArray

	printArray at: 1 put: (Array with: 'ID').
	printArray at: 2 put: (Array with: 'ID').

	definition getFieldsNames keysAndValuesDo: [:index :fieldName |  
		(printArray at: 1) at: index + 1 put: fieldName. 
		(printArray at: 2) at: index + 1 put: (self getLabelOf: fieldName)].

	lineNumber := 3. "the actual data is put from row 3 ..."

	formsCollection do: [:each | 
		printArray at: lineNumber put: (Array with: each id).
		self printInstance: each.
		lineNumber := lineNumber + 1].! !

!SinglelineSimpleFormExport methodsFor: 'other' stamp: 'BrunoBB 02/10/2016 11:01'!
getLabelOf: fieldName
	| label |

	label := ((GRCodec forEncoding: 'utf-8') decode: (definition labelAt: fieldName)) asString.

	label := (definition labelAt: fieldName) copyWithoutAll: String lf.

	^label! !

!SinglelineSimpleFormExport methodsFor: 'other' stamp: 'BrunoBB 05/10/2015 15:26'!
printInstance: anOrbeonFormInstance

	definition getFieldsNames keysAndValuesDo: [:index :fieldName |  
		(printArray at: lineNumber) at: index + 1 put: (anOrbeonFormInstance valueAt: fieldName)].! !

Object subclass: #FormImportReport
	instanceVariableNames: 'app form numberOfForms warnings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormImportReport commentStamp: '' prior: 0!
This class used after importing Forms from Orbeon (Jave) application into in GemStone.

Instances of this class has detailed information of the import process.

Is a NON persistent class.!

!FormImportReport class methodsFor: 'other' stamp: 'BrunoBB 03/04/2015 08:11'!
app: appName form: formName

	^super new initialize
		app: appName;
		form: formName;
		yourself! !

!FormImportReport methodsFor: 'other' stamp: 'BrunoBB 03/04/2015 13:37'!
addWarning: aFormImportWarning

	aFormImportWarning report: self.

	^warnings add: aFormImportWarning! !

!FormImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 08:13'!
app

   "Return the value of the instance variable 'app'."
   ^app! !

!FormImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 08:13'!
app: newValue

   "Modify the value of the instance variable 'app'."
   app := newValue! !

!FormImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 08:13'!
form

   "Return the value of the instance variable 'form'."
   ^form! !

!FormImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 08:13'!
form: newValue

   "Modify the value of the instance variable 'form'."
   form := newValue! !

!FormImportReport methodsFor: 'other' stamp: 'BrunoBB 03/04/2015 09:16'!
hasWarnings

	^warnings notEmpty! !

!FormImportReport methodsFor: 'other' stamp: 'BrunoBB 03/04/2015 08:00'!
initialize

	super initialize.

	app := ''.
	form := ''.
	numberOfForms := 0.
	warnings := OrderedCollection new.! !

!FormImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 08:13'!
numberOfForms

   "Return the value of the instance variable 'numberOfForms'."
   ^numberOfForms! !

!FormImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 08:13'!
numberOfForms: newValue

   "Modify the value of the instance variable 'numberOfForms'."
   numberOfForms := newValue! !

!FormImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 08:13'!
warnings

   "Return the value of the instance variable 'warnings'."
   ^warnings! !

!FormImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 08:13'!
warnings: newValue

   "Modify the value of the instance variable 'warnings'."
   warnings := newValue! !

Object subclass: #FormImportWarning
	instanceVariableNames: 'report field warning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormImportWarning class methodsFor: 'other' stamp: 'BrunoBB 03/04/2015 13:38'!
report: aFormImportReport fieldName: fieldName

	^super new initialize
		report: aFormImportReport;
		field: fieldName;
		yourself! !

!FormImportWarning methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 13:36'!
field

   "Return the value of the instance variable 'field'."
   ^field! !

!FormImportWarning methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 13:36'!
field: newValue

   "Modify the value of the instance variable 'field'."
   field := newValue! !

!FormImportWarning methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 13:36'!
report

   "Return the value of the instance variable 'report'."
   ^report! !

!FormImportWarning methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 13:36'!
report: newValue

   "Modify the value of the instance variable 'report'."
   report := newValue! !

!FormImportWarning methodsFor: 'Accessing' stamp: 'BrunoBB 03/04/2015 13:36'!
warning

   "Return the value of the instance variable 'warning'."
   ^warning! !

!FormImportWarning methodsFor: 'Updating' stamp: 'BrunoBB 03/04/2015 14:14'!
warningDetails: newValue

   "Modify the value of the instance variable 'warning'."
   warning := newValue! !

!Object class methodsFor: '*orbeon' stamp: 'BrunoBB 02/08/2016 11:11'!
getOrbeonApplicationCache
	"The receiver answer the cache of OrbeonApplication "

	^self getOrbeonApplicationClass cache! !

!Object class methodsFor: '*orbeon' stamp: 'BrunoBB 02/08/2016 11:09'!
getOrbeonApplicationClass
	"The receiver answer the class used as Orbeon applications holder"

	^OrbeonApplication! !

!Object class methodsFor: '*orbeon' stamp: 'BrunoBB 02/26/2016 13:46'!
getOrbeonCache

	^AbstractApplication getOrbeonCache! !

!Object methodsFor: '*orbeon' stamp: 'BrunoBB 02/08/2016 11:12'!
getOrbeonApplicationCache
	"The receiver answer the cache of OrbeonApplication "

	^self class getOrbeonApplicationCache! !

!Object methodsFor: '*orbeon' stamp: 'BrunoBB 02/08/2016 11:08'!
getOrbeonApplicationClass
	"The receiver answer the class used as Orbeon applications holder"

	^self class getOrbeonApplicationClass! !

!Object methodsFor: '*orbeon' stamp: 'BrunoBB 02/26/2016 13:47'!
getOrbeonCache

	^self class getOrbeonCache! !

Object subclass: #OrbeonDatabaseMigrator
	instanceVariableNames: 'application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonDatabaseMigrator class methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:07'!
forApplicationNamed: appName

	^super new initialize
		setApplicationNamed: appName;
		yourself! !

!OrbeonDatabaseMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 17:24'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!OrbeonDatabaseMigrator methodsFor: 'Accessing' stamp: 'BrunoBB 10/14/2015 14:07'!
application
	^application! !

!OrbeonDatabaseMigrator methodsFor: 'Updating' stamp: 'BrunoBB 10/14/2015 14:07'!
application: newValue
	application := newValue! !

!OrbeonDatabaseMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:00'!
defaultDatabaseReaderClass

	^self subclassResponsibility! !

!OrbeonDatabaseMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:12'!
getOrbeonHandler

	^OrbeonHandler default! !

!OrbeonDatabaseMigrator methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:49'!
setApplicationNamed: appName

	application := self getOrbeonApplicationClass 
							applicationNamed: appName 
							ifNone: [self getOrbeonApplicationClass new applicationName: appName; addToCache; yourself].! !

OrbeonDatabaseMigrator subclass: #OrbeonDB2Migrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonDB2Migrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:02'!
defaultDatabaseReaderClass

	^OrbeonDB2Reader! !

OrbeonDatabaseMigrator subclass: #OrbeonMySQLMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonMySQLMigrator commentStamp: 'BrunoBB 10/18/2015 11:44' prior: 0!
This class perform a migration from MySQL to GemStone/S.

- Migrate Form Published Definitions (saved but not published are not included)
- Migrate Form Instances (drafts are not included)

To Perform the Migration:
1- Publish all saved forms
2- Save as final all available drafts
3- Perform the migration!

!OrbeonMySQLMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:02'!
defaultDatabaseReaderClass

	^Orbeon46MySQL! !

!OrbeonMySQLMigrator methodsFor: 'other' stamp: 'BrunoBB 10/16/2015 19:42'!
migrateDefinitionAttachmentsOf: anOrbeonFormDefinition
	"The receiver export all attachments of <anOrbeonFormDefinition> to the file system.
	This is done directly from MySql via: select file_content INTO DUMPFILE 'fileName'.
	Note: the files are stored in MySql host. If MySql and GemStone/S are in different host a manual file copy must be performed from MySql host to GemStone/S host.
	The MySql host must mimic the file structure where the Orbeon attachments are stored in GemStone/S:
	../temp
	../drafts
	../instances
	../definitions/saved
	../definitions/published"

	anOrbeonFormDefinition attachments do: [:defIdfileId | | gsFile path fileId definitionId |
			path := self apiConfiguration getSavedDefinitionsPathFor: anOrbeonFormDefinition form in: anOrbeonFormDefinition app.
			definitionId := (defIdfileId subStrings: '-') first.
			fileId := (defIdfileId subStrings: '-') last.
			self getOrbeonHandler fileoutDefinitionAttachmentOn: path defintionId: definitionId fileId: fileId version: anOrbeonFormDefinition version.
		].! !

!OrbeonMySQLMigrator methodsFor: 'other' stamp: 'BrunoBB 10/16/2015 19:42'!
migrateDefinitionCustomAttachmentOf: anOrbeonFormDefinition
	"The receiver export all attachments of <anOrbeonFormDefinition> to the file system.
	This is done directly from MySql via: select file_content INTO DUMPFILE 'fileName'.
	Note: the files are stored in MySql host. If MySql and GemStone/S are in different host a manual file copy must be performed from MySql host to GemStone/S host.
	The MySql host must mimic the file structure where the Orbeon attachments are stored in GemStone/S:
	../temp
	../drafts
	../instances
	../definitions/saved
	../definitions/published"

	anOrbeonFormDefinition customAttachment ifNotNil: [ | gsFile path definitionId fileId |
			path := self apiConfiguration getSavedDefinitionsPathFor: anOrbeonFormDefinition form in: anOrbeonFormDefinition app.
			definitionId := (anOrbeonFormDefinition printCompleteCustomAttachmentId subStrings: '-') first.
			fileId := (anOrbeonFormDefinition printCompleteCustomAttachmentId subStrings: '-') last.
			self getOrbeonHandler fileoutDefinitionAttachmentOn: path defintionId: definitionId fileId: fileId version: anOrbeonFormDefinition version.
		].! !

!OrbeonMySQLMigrator methodsFor: 'migration api' stamp: 'BrunoBB 02/08/2016 12:45'!
migrateFormDefinitionNamed: aString
	"The receiver migrate ALL VERSIONS (from MySQL to GemStone) of the form definition named <aString>."

	^(self getOrbeonHandler getAllVersionsNumberOf: aString in: application applicationName)
		do: [:eachVersion | self migrateFormDefinitionNamed: aString version: eachVersion]! !

!OrbeonMySQLMigrator methodsFor: 'migration api' stamp: 'BrunoBB 02/08/2016 12:45'!
migrateFormDefinitionNamed: aString version: version
	"The receiver migrate (from MySQL to GemStone) the form definition named <aString> with version <version>.
	An OrbeonFormDefinition will be create inside OrbeonApplication <application>"
	| definition instanceDefinition dbString |

	definition := self getOrbeonHandler importFormDefinitionNamed: aString version: version in: application applicationName addToApp: true.
	definition setMetadata.
	dbString := self getOrbeonHandler getDBStringForInstanceDefinitionWithId: definition id version: version.
	"it could be a form definition with version = 2, but NO form instance definition with version 2 (it was never save after being published) --> we get the last"
	dbString isEmpty ifTrue: [dbString := self getOrbeonHandler getDBStringForInstanceDefinitionWithId: definition id].

	instanceDefinition := self getOrbeonHandler generateFormInstanceDefinition: aString app: application applicationName from: dbString.
	instanceDefinition setMetadata.
	definition instanceDefinition: instanceDefinition.
	instanceDefinition definition: definition.
	application addSavedDefinition: instanceDefinition.

	self getOrbeonHandler importDataFromScratchOf: definition. "import data <OrbeonFormInstance> filtered by <definition> version"

	self migrateDefinitionCustomAttachmentOf: definition.
	self migrateDefinitionAttachmentsOf: definition.

	self migrateInstanceAttachmentsOf: definition.! !

!OrbeonMySQLMigrator methodsFor: 'other' stamp: 'BrunoBB 10/16/2015 20:55'!
migrateInstanceAttachmentsOf: anOrbeonFormDefinition
	"The receiver export all attachments of <anOrbeonFormDefinition> instances to the file system.
	This is done directly from MySql via: select file_content INTO DUMPFILE 'fileName'.
	Note: the files are stored in MySql host. If MySql and GemStone/S are in different host a manual file copy must be performed from MySql host to GemStone/S host.
	The MySql host must mimic the file structure where the Orbeon attachments are stored in GemStone/S:
	../temp
	../drafts
	../instances
	../definitions/saved
	../definitions/published"

	anOrbeonFormDefinition instances do:[:eachInstance |
		eachInstance getAttachmentIds do: [:instIdFileId | | path instanceId fileId |
			path := self apiConfiguration getInstancesPathFor: anOrbeonFormDefinition form in: anOrbeonFormDefinition app.
			instanceId := (instIdFileId subStrings: '-') first.
			fileId := (instIdFileId subStrings: '-') last.
			self getOrbeonHandler fileoutInstanceAttachmentOn: path defintionId: instanceId fileId: fileId version: anOrbeonFormDefinition version.
		]
	].! !

OrbeonDatabaseMigrator subclass: #OrbeonOracleMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonOracleMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:02'!
defaultDatabaseReaderClass

	^OrbeonOracleReader! !

OrbeonDatabaseMigrator subclass: #OrbeonPostgreSQLMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonPostgreSQLMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:02'!
defaultDatabaseReaderClass

	^OrbeonPostgreReader! !

OrbeonDatabaseMigrator subclass: #OrbeonSQLServerMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonSQLServerMigrator methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 14:03'!
defaultDatabaseReaderClass

	^OrbeonSQLServerReader! !

Object subclass: #OrbeonDatabaseReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonDatabaseReader subclass: #OrbeonDB2Reader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonDatabaseReader subclass: #OrbeonMySQLReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonMySQLReader subclass: #Orbeon46MySQL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/14/2015 14:48'!
selectAllVersionOf: formNamed in: appName
	"Answer a SQL sentence with all versions of the form definition named <formNamed> in application <appName>"

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select form_version from orbeon.orbeon_form_definition where app = ''', appName, ''' and form = ''', formNamed, ''' group by form_version " '! !

!Orbeon46MySQL methodsFor: 'attachments' stamp: 'BrunoBB 10/16/2015 13:59'!
sqlDumpFileDefinitionAttachmentOn: path definitionId: definitionId fileId: fileId version: version

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select file_content INTO DUMPFILE ''', path, definitionId, '-', fileId, ''' from orbeon.orbeon_form_definition_attach where file_name = ''', fileId , ''' and form_version = ', version printString, ' " '! !

!Orbeon46MySQL methodsFor: 'attachments' stamp: 'BrunoBB 10/16/2015 20:21'!
sqlDumpFileInstanceAttachmentOn: path definitionId: definitionId fileId: fileId version: version

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select file_content INTO DUMPFILE ''', path, definitionId, '-', fileId, ''' from orbeon.orbeon_form_data_attach where file_name = ''', fileId , ''' and form_version = ', version printString, ' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 05/26/2015 05:50'!
sqlFormDataWithId: formId

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and document_id = ''', formId, '''  order by last_modified_time desc limit 1" '! !

!Orbeon46MySQL methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 17:13'!
sqlFormDefinitionLastUpdateFor: app form: formName

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select last_modified_time from orbeon.orbeon_form_definition where app = ''', app , ''' and form = ''', formName , ''' and xml is not null order by last_modified_time desc" '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 11/19/2014 03:34'!
sqlGetAllDocumentIdsFrom: form of: app
	"Answer all document_id of the form in <orbeon_form_data> for the form <form> in the application <app>"

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select  document_id  from orbeon.orbeon_form_data where xml is not null and app = ''', app, ''' and form =''', form, '''  " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/14/2015 14:25'!
sqlGetAllDocumentIdsFrom: form of: app version: version
	"Answer all document_id of the form in <orbeon_form_data> for the form <form> in the application <app> with version <version>"

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select  document_id  from orbeon.orbeon_form_data where xml is not null and app = ''', app, ''' and form =''', form, ''' and form_version = ', version printString, ' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 11/18/2014 09:12'!
sqlGetAllFormsData: form of: app

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and app = ''', app, ''' and form =''', form, '  " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 17:12'!
sqlGetAllFormsData: form of: app after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and app = ''', app, ''' and form =''', form, ''' and last_modified_time > ''',  timeStampString, ''' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 11/18/2014 05:06'!
sqlGetAllFormsData: form of: app after: timeStampString limit: stringLimit

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and app = ''', app, ''' and form =''', form, ''' and last_modified_time > ''',  timeStampString, ''' ', stringLimit, ' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 03/29/2015 13:33'!
sqlGetAllFormsData: form version: version of: app after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where app = ''', app, ''' and form =''', form, ''' and form_version = ', version ,' and  xml is not null and last_modified_time > ''',  timeStampString, ''' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 17:12'!
sqlGetAllFormsDataAfter: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select * from orbeon.orbeon_form_data where xml is not null and last_modified_time > ',  timeStampString, ' " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 11/19/2014 03:25'!
sqlGetAllFormsWithId: documentId
	"Answer all stored versions of the form with id <documentId>"

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and document_id = ''', documentId, ''' " '! !

!Orbeon46MySQL methodsFor: 'instance definition' stamp: 'BrunoBB 10/15/2015 11:19'!
sqlGetAllInstanceDefinitions

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, document_id, lastMod, user, nameofgroup ,xml from (SELECT created, last_modified_time, document_id, concat(''_'', last_modified_by) lastMod, concat(''_'', username) user, concat(''_'', groupname) nameofgroup, xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' order by last_modified_time desc) lastDef group by document_id; " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 17:13'!
sqlGetAllInstancesOf: formName in: appName 

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, last_modified_by, document_id, deleted, username, groupname from orbeon.orbeon_form_data where xml is not null and app=''', appName, ''' and form=''', formName,'''  order by last_modified_time desc" '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 17:14'!
sqlGetAllLastFormInstances

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select * from (select * from orbeon.orbeon_form_data where xml is not null order by last_modified_time desc) lastDef group by document_id" '! !

!Orbeon46MySQL methodsFor: 'attachments' stamp: 'BrunoBB 10/14/2015 12:17'!
sqlGetDataAttachmentContentFor: formId fileId: fileId

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select file_content from orbeon.orbeon_form_data_attach where document_id = ''', formId , ''' and file_name = ''', fileId, ''' " '! !

!Orbeon46MySQL methodsFor: 'attachments' stamp: 'BrunoBB 10/14/2015 12:17'!
sqlGetDataAttachmentsFor: formId

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select document_id, file_name from orbeon.orbeon_form_data_attach where document_id = ''', formId , ''' " '! !

!Orbeon46MySQL methodsFor: 'attachments' stamp: 'BrunoBB 10/16/2015 12:33'!
sqlGetDefinitionAttachmentContentFor: fileId version: version

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select file_content from orbeon.orbeon_form_definition_attach where file_name = ''', fileId , ''' and form_version = ', version printString, ' " '! !

!Orbeon46MySQL methodsFor: 'definitions' stamp: 'BrunoBB 03/29/2015 13:47'!
sqlGetFormDefinition: form version: version of: app after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,
	' -N -B -e "select * from (select created, last_modified_time, concat(''_'', last_modified_by), app, form, deleted, form_version ,xml from orbeon.orbeon_form_definition where app = ''', 
		app, ''' and form= ''', form, '''', ' and form_version = ', version printString,' and last_modified_time > ''',  timeStampString, ''' and deleted=''N'' order by last_modified_time desc) lastDef group by form " '! !

!Orbeon46MySQL methodsFor: 'instance' stamp: 'BrunoBB 11/19/2014 03:31'!
sqlGetFormWithId: documentId
	"Answer the last stored versions of the form with id <documentId>"

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where xml is not null and document_id = ''', documentId, ''' order by last_modified_time desc limit 1 " '! !

!Orbeon46MySQL methodsFor: 'instance definition' stamp: 'BrunoBB 10/15/2015 14:06'!
sqlGetInstanceDefinitionTimeStamp: definitionTimeStamp
	"Answer a register from MySQL Orbeon.Data that represent a FormDefinition."
	| lowerTimeStamp |

	lowerTimeStamp := definitionTimeStamp minusSeconds: 60.
	"lowerTimeStamp := definitionTimeStamp subtractSeconds: 60."

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select last_modified_time, document_id, xml from (SELECT last_modified_time, document_id, xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' and last_modified_time <= ''', definitionTimeStamp printMySqlString, ''' and last_modified_time >= ''', lowerTimeStamp printMySqlString, ''' order by last_modified_time desc) lastDef group by document_id; " '! !

!Orbeon46MySQL methodsFor: 'instance definition' stamp: 'BrunoBB 10/15/2015 12:34'!
sqlGetInstanceDefinitionWithId: id

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, document_id, lastMod, user, nameofgroup, xml from (SELECT created, last_modified_time, document_id, concat(''_'', last_modified_by) lastMod, concat(''_'', username) user, concat(''_'', groupname) nameofgroup, xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' and document_id = ''', id, ''' order by last_modified_time desc) lastDef limit 1; " '! !

!Orbeon46MySQL methodsFor: 'instance definition' stamp: 'BrunoBB 10/15/2015 12:35'!
sqlGetInstanceDefinitionWithId: id version: version

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, document_id, lastMod, user, nameofgroup, xml from (SELECT created, last_modified_time, document_id, concat(''_'', last_modified_by) lastMod, concat(''_'', username) user, concat(''_'', groupname) nameofgroup, xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' and document_id = ''', id, ''' and form_version = ', version printString, ' order by last_modified_time desc) lastDef limit 1; " '! !

!Orbeon46MySQL methodsFor: 'instance definition' stamp: 'BrunoBB 10/16/2015 07:59'!
sqlGetXMLInstanceDefinitionWithId: id

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select xml from (SELECT xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' and document_id = ''', id, ''' order by last_modified_time desc) lastDef limit 1; " '! !

!OrbeonMySQLReader methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 08:58'!
databaseIP

	^self getOrbeonDatabaseConfiguration databaseIP! !

!OrbeonMySQLReader methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 08:58'!
databasePassword

	^self getOrbeonDatabaseConfiguration databasePassword! !

!OrbeonMySQLReader methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 08:58'!
databaseUser

	^self getOrbeonDatabaseConfiguration databaseUser! !

!OrbeonMySQLReader methodsFor: 'other' stamp: 'BrunoBB 10/31/2014 16:58'!
initialize

	super initialize.! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlFormDefinitionLastUpdateFor: app form: formName

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select last_modified_time from orbeon.orbeon_form_definition where app = ''', app , ''' and form = ''', formName , ''' order by last_modified_time desc" '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 04/01/2015 07:42'!
sqlFormDefinitionLastUpdateFor: app form: formName version: version

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select last_modified_time from orbeon.orbeon_form_definition where app = ''', app , ''' and form = ''', formName , ''' and form_version = ', version, ' order by last_modified_time desc" '! !

!OrbeonMySQLReader methodsFor: 'application' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllApplications

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select distinct app from orbeon.orbeon_form_definition " '! !

!OrbeonMySQLReader methodsFor: 'application' stamp: 'BrunoBB 03/29/2015 12:48'!
sqlGetAllApplicationWithDefinitions

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select app, form from orbeon.orbeon_form_definition group by app, form " '! !

!OrbeonMySQLReader methodsFor: 'application' stamp: 'BrunoBB 03/29/2015 12:48'!
sqlGetAllApplicationWithDefinitionVersions

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select app, form, form_version from orbeon.orbeon_form_definition
group by app, form, form_version " '! !

!OrbeonMySQLReader methodsFor: 'application' stamp: 'BrunoBB 04/01/2015 08:00'!
sqlGetAllDefinitionVersionsOf: appName

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select app, form, form_version from orbeon.orbeon_form_definition where app = ''', appName , ''' group by app, form, form_version " '! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllFormsData: form of: app after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, concat(''_'', last_modified_by), app, form, document_id, deleted, xml, concat(''_'', username), concat(''_'', groupname), form_version from orbeon.orbeon_form_data where app = ''', app, ''' and form =''', form, ''' and last_modified_time > ''',  timeStampString, ''' " '! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllFormsDataAfter: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select * from orbeon.orbeon_form_data where last_modified_time > ',  timeStampString, ' " '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllFormsDefinition

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select * from orbeon.orbeon_form_definition " '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllFormsDefinition: fileName

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select * from orbeon.orbeon_form_definition " > ', fileName! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 03/29/2015 12:48'!
sqlGetAllFormsDefinition: form of: app after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,
	' -N -B -e "select * from (select created, last_modified_time, concat(''_'', last_modified_by), app, form, deleted, form_version ,xml from orbeon.orbeon_form_definition where app = ''', 
		app, ''' and form= ''', form, ''' and last_modified_time > ''',  timeStampString, ''' and deleted=''N'' 
		order by last_modified_time desc) lastDef group by form " '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 04/02/2015 14:48'!
sqlGetAllFormsDefinition: form of: app version: version after: timeStampString

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,
	' -N -B -e "select * from (select created, last_modified_time, concat(''_'', last_modified_by), app, form, deleted, form_version ,xml from orbeon.orbeon_form_definition where app = ''', 
		app, ''' and form= ''', form, ''' and form_version = ', version ,' and last_modified_time > ''',  timeStampString, ''' and deleted=''N'' 
		order by last_modified_time desc) lastDef group by form " '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllFormsDefinitionOf: appName

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select * from (select form from orbeon.orbeon_form_definition where app=''', appName, ''' and deleted=''N'' order by last_modified_time) lastDef group by form "'! !

!OrbeonMySQLReader methodsFor: 'instance definition' stamp: 'BrunoBB 10/15/2015 11:20'!
sqlGetAllInstanceDefinitions

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, document_id, lastMod, user, nameofgroup ,xml from (SELECT created, last_modified_time, document_id, concat(''_'', last_modified_by) lastMod, concat(''_'', username) user, concat(''_'', groupname) nameofgroup, xml FROM orbeon.orbeon_form_data where xml is not null and app=''orbeon'' and form=''builder'' order by last_modified_time desc) lastDef group by document_id; " '! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllInstancesOf: formName in: appName 

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select created, last_modified_time, last_modified_by, document_id, deleted, username, groupname from orbeon.orbeon_form_data where app=''', appName, ''' and form=''', formName,'''  order by last_modified_time desc" '! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllInstancesOf: formName in: appName writeTo: fileName

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select xml from orbeon.orbeon_form_data where app=''', appName, ''' and form=''', formName,'''  order by last_modified_time desc" > ', fileName! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllLastFormDefinitions

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select * from (select * from orbeon.orbeon_form_definition order by last_modified_time desc) lastDef group by app, form" '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllLastFormDefinitions: fileName

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select * from (select * from orbeon.orbeon_form_definition order by last_modified_time desc) lastDef group by app, form" > ', fileName! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllLastFormInstances

	^'mysql -h ', self databaseIP,' -u ', self databaseUser,' -p', self databasePassword,' -N -B -e "select * from (select * from orbeon.orbeon_form_data order by last_modified_time desc) lastDef group by document_id" '! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllLastFormInstances: fileName

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select * from (select * from orbeon.orbeon_form_data order by last_modified_time desc) lastDef group by document_id" > ', fileName! !

!OrbeonMySQLReader methodsFor: 'instance' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetAllLastInstances: fileName

	^'mysql -h ', self databaseIP,' -u ', self databaseUser,' -p', self databasePassword,' -N -B -e "select * from orbeon.orbeon_form_data " > ', fileName! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 03/29/2015 12:48'!
sqlGetFormDefinitionsVersionsOf: form in: app

	^'mysql -h ', self databaseIP,' -u ',self databaseUser,' -p', self databasePassword,' -N -B -e "select app, form, form_version from (select app, form, form_version from orbeon.orbeon_form_definition where app = ''', app,''' and form = ''', form ,''' order by last_modified_time desc) lastDef group by app, form, form_version" '! !

!OrbeonMySQLReader methodsFor: 'instance definition' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetInstanceDefinitionTimeStamp: definitionTimeStamp
	"Answer a register from MySQL Orbeon.Data that represent a FormDefinition."
	| lowerTimeStamp |

	lowerTimeStamp := definitionTimeStamp minusSeconds: 60.

	^'mysql -h ',self databaseIP,' -u ', self databaseUser,' -p',self databasePassword,' -N -B -e "select last_modified_time, document_id, xml from (SELECT last_modified_time, document_id, xml FROM orbeon.orbeon_form_data where app=''orbeon'' and form=''builder'' and last_modified_time <= ''', definitionTimeStamp printMySqlString, ''' and last_modified_time >= ''', lowerTimeStamp printMySqlString, ''' order by last_modified_time desc) lastDef group by document_id; " '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetLastDefinitionOf: formName in: appName

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select xml from orbeon.orbeon_form_definition where app=''', appName, ''' and form=''', formName,'''  order by last_modified_time desc limit 1" '! !

!OrbeonMySQLReader methodsFor: 'definitions' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlGetLastDefinitionOf: formName in: appName writeTo: fileName

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "select xml from orbeon.orbeon_form_definition where app=''', appName, ''' and form=''', formName,'''  order by last_modified_time desc limit 1" > ', fileName! !

!OrbeonMySQLReader methodsFor: 'insert' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlInsertFieldDefinition: aFormFieldDefinition id: fieldId

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "INSERT INTO orbeon_metadata.field_definition (field_id, form_definition_id, name, isSummary, isSearch, label, field_type, repeat_name) VALUES (''', fieldId printString, ''',', '''',aFormFieldDefinition definition id, ''',', '''', aFormFieldDefinition name, ''',', '''', aFormFieldDefinition isSummary asSqlString, ''',', '''', aFormFieldDefinition isSearch asSqlString, ''',', '''', aFormFieldDefinition label, ''',', '''', aFormFieldDefinition type, ''',', '''no repeat name''', ')"'! !

!OrbeonMySQLReader methodsFor: 'insert' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlInsertFieldValue: aFieldValue id: fieldId valueField: valueField

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "INSERT INTO orbeon_metadata.field_value (field_id, form_instance_id, name, type, ',valueField, ', original_value, error_string) VALUES (''', fieldId printString, ''',', '''', aFieldValue instanceId, ''',', '''', aFieldValue name, ''',', '''', aFieldValue typeName, ''',', '''', aFieldValue value printMySqlString, ''',', '''', aFieldValue originalValue, ''',', '''', aFieldValue errorString printString, '''', ')"'! !

!OrbeonMySQLReader methodsFor: 'insert' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlInsertOrbeonDefinition: anOrbeonFormDefinition

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "INSERT INTO orbeon_metadata.orbeon_form_definition (orbeon_id, form_name, app, version, created_time, modified_time, deleted, isPublished) VALUES (''', anOrbeonFormDefinition id, ''',', '''',anOrbeonFormDefinition form, ''',', '''', anOrbeonFormDefinition app, ''',','''01'',', '''',anOrbeonFormDefinition createdTime printMySqlString, ''',', '''', anOrbeonFormDefinition modifiedTime printMySqlString, ''',', '''N'',', '''S''', ')"'! !

!OrbeonMySQLReader methodsFor: 'insert' stamp: 'BrunoBB 10/31/2014 16:58'!
sqlInsertOrbeonInstance: anOrbeonFormInstance

	^'mysql -h ',self databaseIP,' -u ',self databaseUser,' -p',self databasePassword,' -N -B -e "INSERT INTO orbeon_metadata.orbeon_form_instance (orbeon_instance_id, form_definition_id, form, app, created_time, modified_time, modified_user, username, groupname, deleted) VALUES (''', anOrbeonFormInstance id, ''',', '''',anOrbeonFormInstance definitionId, ''',' ,'''',anOrbeonFormInstance form, ''',', '''', anOrbeonFormInstance app, ''',', '''',anOrbeonFormInstance createdTime printMySqlString, ''',', '''',anOrbeonFormInstance modifiedTime printMySqlString, ''',', '''',anOrbeonFormInstance modifiedUser, ''',', '''',anOrbeonFormInstance username, ''',', '''',anOrbeonFormInstance groupname, ''',' ,'''N''', ')"'! !

OrbeonDatabaseReader subclass: #OrbeonOracleReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonDatabaseReader subclass: #OrbeonPostgreReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonDatabaseReader subclass: #OrbeonSQLServerReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

Object subclass: #OrbeonFormReader
	instanceVariableNames: 'xmlDefinition xmlDocument xmlInstanceDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 11/23/2013 11:26'!
definitionExample

	^'<xh:html xmlns:xh="http://www.w3.org/1999/xhtml" xmlns:xf="http://www.w3.org/2002/xforms"
         xmlns:xs="http://www.w3.org/2001/XMLSchema"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:ev="http://www.w3.org/2001/xml-events"
         xmlns:xi="http://www.w3.org/2001/XInclude"
         xmlns:xxi="http://orbeon.org/oxf/xml/xinclude"
         xmlns:xxf="http://orbeon.org/oxf/xml/xforms"
         xmlns:exf="http://www.exforms.org/exf/1-0"
         xmlns:fr="http://orbeon.org/oxf/xml/form-runner"
         xmlns:saxon="http://saxon.sf.net/"
         xmlns:sql="http://orbeon.org/oxf/xml/sql"
         xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"
         xmlns:fb="http://orbeon.org/oxf/xml/form-builder">
    <xh:head>
        <xh:title>FORMULARIO PARA REALIZAR DENUNCIAS ANTE LA UNIDAD REGULADORA Y DE CONTROL DE DATOS PERSONALES</xh:title>
        <xf:model id="fr-form-model" xxf:expose-xpath-types="true">

            <!!-- Main instance -->
            <xf:instance id="fr-form-instance">
                <form>
                    <section-1>
                        <montevideo/>
                        <fechaActual/>
                        
                    </section-1>
                    <section-4>
                        <nombreDenunciante/>
                        <cedulaDenunciante/>
                        <direccionDenunciante/>
                        <ciudadDenunciante/>
                        <deptoDenunciante/>
                        <telDenunciante/>
                        <correoDenunciante/>
                    </section-4>
                    <section-5>
                        <nombreDenunciado/>
                        <cedulaDenunciado/>
                        <direccionDenunciado/>
                        <ciudadDenunciado/>
                        <deptoDenunciado/>
                        <telefonoDenunciado/>
                        <correoDenunciado/>
                    </section-5>
                    <section-21>
                        <detalleDenuncia/>
                    </section-21>
                    <section-7>
                        <firma/>
                        <confirmacionDenuncia/>
                    </section-7>
                </form>
            </xf:instance>

            <!!-- Bindings -->
            <xf:bind xmlns:dataModel="java:org.orbeon.oxf.fb.DataModel" id="fr-form-binds"
                     ref="instance(''fr-form-instance'')">
                <xf:bind id="section-1-bind" name="section-1" ref="section-1">
                    <xf:bind name="montevideo" id="montevideo-bind" ref="montevideo" readonly="true()"/>
                    <xf:bind name="fechaActual" id="fechaActual-bind" ref="fechaActual" type="xf:date"
                             readonly="true()"
                             xxf:default="current-date()"/>
                    
                </xf:bind>
                <xf:bind name="section-4" id="section-4-bind" ref="section-4">
                    <xf:bind name="cedulaDenunciante" id="cedulaDenunciante-bind" ref="cedulaDenunciante"/>
                    <xf:bind name="direccionDenunciante" id="direccionDenunciante-bind"
                             ref="direccionDenunciante"/>
                    <xf:bind name="ciudadDenunciante" id="ciudadDenunciante-bind" ref="ciudadDenunciante"/>
                    <xf:bind name="deptoDenunciante" id="deptoDenunciante-bind" ref="deptoDenunciante"/>
                    <xf:bind name="telDenunciante" id="telDenunciante-bind" ref="telDenunciante"/>
                    <xf:bind name="correoDenunciante" id="correoDenunciante-bind" ref="correoDenunciante"/>
                    <xf:bind name="nombreDenunciante" id="nombreDenunciante-bind" ref="nombreDenunciante"/>
                </xf:bind>
                <xf:bind name="section-5" id="section-5-bind" ref="section-5">
                    <xf:bind name="nombreDenunciado" id="nombreDenunciado-bind" ref="nombreDenunciado"/>
                    <xf:bind name="cedulaDenunciado" id="cedulaDenunciado-bind" ref="cedulaDenunciado"/>
                    <xf:bind name="direccionDenunciado" id="direccionDenunciado-bind"
                             ref="direccionDenunciado"/>
                    <xf:bind name="ciudadDenunciado" id="ciudadDenunciado-bind" ref="ciudadDenunciado"/>
                    <xf:bind name="deptoDenunciado" id="deptoDenunciado-bind" ref="deptoDenunciado"/>
                    <xf:bind name="telefonoDenunciado" id="telefonoDenunciado-bind" ref="telefonoDenunciado"/>
                    <xf:bind name="correoDenunciado" id="correoDenunciado-bind" ref="correoDenunciado"/>
                </xf:bind>
                <xf:bind name="section-7" id="section-7-bind" ref="section-7">
                    <xf:bind name="firma" id="firma-bind" ref="firma" readonly="true()"/>
                    <xf:bind name="confirmacionDenuncia" id="confirmacionDenuncia-bind"
                             ref="confirmacionDenuncia"
                             type="xs:boolean"
                             required="true()"/>
                </xf:bind>
                <xf:bind name="section-21" id="section-21-bind" ref="section-21">
                    <xf:bind name="detalleDenuncia" id="detalleDenuncia-bind" ref="detalleDenuncia"/>
                </xf:bind>
            </xf:bind>

            <!!-- Metadata -->
            <xf:instance xxf:readonly="true" id="fr-form-metadata">
                <metadata>
                    <application-name>URCDP</application-name>
                    <form-name>Denuncias</form-name>
                    <title xml:lang="en">FORMULARIO PARA REALIZAR DENUNCIAS ANTE LA UNIDAD REGULADORA Y DE CONTROL DE DATOS PERSONALES</title>
                    <description xml:lang="en">Formulario para el ingreso de denuncias de violacin de datos personales</description>
                </metadata>
            </xf:instance>

            <!!-- Attachments -->
            <xf:instance id="fr-form-attachments">
                <attachments>
                    <css mediatype="text/css" filename="" size=""/>
                    <pdf mediatype="application/pdf" filename="" size=""/>
                </attachments>
            </xf:instance>

            <!!-- All form resources -->
            <!!-- Dont make readonly by default in case a service modifies the resources -->
            <xf:instance id="fr-form-resources" xxf:readonly="false">
                <resources>
                    <resource xml:lang="en">
                        <firma>
                            <label>Por lo expuesto, SOLICITO se inicien las actuaciones administrativas correspondientes con el objeto de determinar la existencia de una eventual violacin a las disposiciones de la Ley N 18.331 y tomar las medidas que correspondan a derecho.</label>
                            <hint/>
                            <help/>
                            <alert/>
                        </firma>
                        <confirmacionDenuncia>
                            <label>Seleccione esta opcin para confirmar la denuncia</label>
                            <hint>Seleccione para confirmar</hint>
                            <help/>
                            <alert/>
                        </confirmacionDenuncia>
                        <detalleDenuncia>
                            <label>De acuerdo con lo previsto en el artculo 34 literal A) de la Ley N 18.331, de 11 de agosto de 2008 y normas concordantes, pongo en conocimiento de la Unidad Reguladora y de Control de Datos Personales, los siguientes HECHOS:</label>
                            <hint>Ingrese detalle de la denuncia</hint>
                            <help/>
                            <alert/>
                        </detalleDenuncia>
                        <nombreDenunciante>
                            <label>Sr/Sra</label>
                            <hint>Ingrese nombre del denunciante</hint>
                            <help/>
                            <alert/>
                        </nombreDenunciante>
                        <nombreDenunciado>
                            <label>Sr/Sra</label>
                            <hint>Ingrese nombre del denunciado</hint>
                            <help/>
                            <alert/>
                        </nombreDenunciado>
                        <cedulaDenunciado>
                            <label>Cedula de Identidad</label>
                            <hint>Ingrese cedula del denunciado</hint>
                            <help/>
                            <alert/>
                        </cedulaDenunciado>
                        <direccionDenunciado>
                            <label>Direccin</label>
                            <hint>Ingrese direccin del denunciado</hint>
                            <help/>
                            <alert/>
                        </direccionDenunciado>
                        <ciudadDenunciado>
                            <label>Ciudad</label>
                            <hint>Ingrese ciudad del denunciado</hint>
                            <help/>
                            <alert/>
                        </ciudadDenunciado>
                        <deptoDenunciado>
                            <label>Departamento</label>
                            <hint>Seleccione Departamento del denunciado</hint>
                            <help/>
                            <alert/>
                            <item>
                                <label>Montevideo</label>
                                <value>montevideo</value>
                            </item>
                            <item>
                                <label>Artigas</label>
                                <value>artigas</value>
                            </item>
                            <item>
                                <label>Canelones</label>
                                <value>canelones</value>
                            </item>
                            <item>                  
                                <label>Cerro Largo</label>
                                <value>cerro-largo</value>
                            </item>
                            <item>                  
                                <label>Colonia</label>
                                <value>colonia</value>
                            </item>
                            <item>                  
                                <label>Durazno</label>
                                <value>durazno</value>
                            </item>
                            <item>                  
                                <label>Flores</label>
                                <value>flores</value>
                            </item>
                            <item>                  
                                <label>Florida</label>
                                <value>florida</value>
                            </item>
                            <item>                  
                                <label>Lavalleja</label>
                                <value>lavalleja</value>
                            </item>
                            <item>                  
                                <label>Maldonado</label>
                                <value>maldonado</value>
                            </item>
                            <item>                  
                                <label>Paysand</label>
                                <value>paysandu</value>
                            </item>
                            <item>                  
                                <label>Ro Negro</label>
                                <value>rio-negro</value>
                            </item>
                            <item>                  
                                <label>Rivera</label>
                                <value>rivera</value>
                            </item>
                            <item>                  
                                <label>Rocha</label>
                                <value>rocha</value>
                            </item>
                            <item>                  
                                <label>Salto</label>
                                <value>salto</value>
                            </item>
                            <item>                  
                                <label>San Jos</label>
                                <value>san-jose</value>
                            </item>
                            <item>                  
                                <label>Soriano</label>
                                <value>soriano</value>
                            </item>
                            <item>                  
                                <label>Tacuaremb</label>
                                <value>tacuarembo</value>
                            </item>
                            <item>                  
                                <label>Treinta y Tres</label>
                                <value>treinta-y-tres</value>
                            </item>
                        </deptoDenunciado>
                        <telefonoDenunciado>
                            <label>Telfono</label>
                            <hint>Ingrese telfono del denunciado</hint>
                            <help/>
                            <alert/>
                        </telefonoDenunciado>
                        <correoDenunciado>
                            <label>Correo Electrnico</label>
                            <hint>Ingrese correo electrnico del denunciado</hint>
                            <help/>
                            <alert/>
                        </correoDenunciado>
                        <cedulaDenunciante>
                            <label>Cedula de Identidad</label>
                            <hint>Ingrese cedula del denunciante</hint>
                            <help/>
                            <alert/>
                        </cedulaDenunciante>
                        <direccionDenunciante>
                            <label>Direccin</label>
                            <hint>Ingrese direccin del denunciante</hint>
                            <help/>
                            <alert/>
                        </direccionDenunciante>
                        <ciudadDenunciante>
                            <label>Ciudad</label>
                            <hint>Ingrese ciudad del denunciante</hint>
                            <help/>
                            <alert/>
                        </ciudadDenunciante>
                        <deptoDenunciante>
                            <label>Departamento</label>
                            <hint>Seleccione Departamento del denunciante</hint>
                            <help/>
                            <alert/>
                            <item>
                                <label>Montevideo</label>
                                <value>montevideo</value>
                            </item>
                            <item>
                                <label>Artigas</label>
                                <value>artigas</value>
                            </item>
                            <item>
                                <label>Canelones</label>
                                <value>canelones</value>
                            </item>
                            <item>                  
                                <label>Cerro Largo</label>
                                <value>cerro-largo</value>
                            </item>
                            <item>                  
                                <label>Colonia</label>
                                <value>colonia</value>
                            </item>
                            <item>                  
                                <label>Durazno</label>
                                <value>durazno</value>
                            </item>
                            <item>                  
                                <label>Flores</label>
                                <value>flores</value>
                            </item>
                            <item>                  
                                <label>Florida</label>
                                <value>florida</value>
                            </item>
                            <item>                  
                                <label>Lavalleja</label>
                                <value>lavalleja</value>
                            </item>
                            <item>                  
                                <label>Maldonado</label>
                                <value>maldonado</value>
                            </item>
                            <item>                  
                                <label>Paysand</label>
                                <value>paysandu</value>
                            </item>
                            <item>                  
                                <label>Ro Negro</label>
                                <value>rio-negro</value>
                            </item>
                            <item>                  
                                <label>Rivera</label>
                                <value>rivera</value>
                            </item>
                            <item>                  
                                <label>Rocha</label>
                                <value>rocha</value>
                            </item>
                            <item>                  
                                <label>Salto</label>
                                <value>salto</value>
                            </item>
                            <item>                  
                                <label>San Jos</label>
                                <value>san-jose</value>
                            </item>
                            <item>                  
                                <label>Soriano</label>
                                <value>soriano</value>
                            </item>
                            <item>                  
                                <label>Tacuaremb</label>
                                <value>tacuarembo</value>
                            </item>
                            <item>                  
                                <label>Treinta y Tres</label>
                                <value>treinta-y-tres</value>
                            </item>
                        </deptoDenunciante>
                        <telDenunciante>
                            <label>Telfono</label>
                            <hint>Ingrese telfono del denunciante</hint>
                            <help/>
                            <alert/>
                        </telDenunciante>
                        <correoDenunciante>
                            <label>Correo Electrnico</label>
                            <hint>Ingrese correo electrnico del denunciante</hint>
                            <help/>
                            <alert/>
                        </correoDenunciante>
                        <montevideo>
                            <label>Montevideo</label>
                            <hint>Ciudad de Montevideo</hint>
                            <help/>
                            <alert/>
                        </montevideo>
                        <fechaActual>
                            <label>Fecha Actual</label>
                            <hint>Fecha Actual</hint>
                            <help/>
                            <alert/>
                        </fechaActual>
                        <section-1>
                            <label>Fecha de Ingreso</label>
                            <help/>
                        </section-1>
                        <section-4>
                            <label>Datos del Denunciante</label>
                            <help/>
                        </section-4>
                        <section-5>
                            <label>Datos del Denunciado</label>
                            <help/>
                        </section-5>
                        <section-21>
                            <label>Detalle de la Denuncia</label>
                            <help/>
                        </section-21>
                        <section-7>
                            <label>Firma</label>
                            <help/>
                        </section-7>
                        
                    </resource>
                </resources>
            </xf:instance>

            <!!-- Utility instances for services -->
            <xf:instance id="fr-service-request-instance" xxf:exclude-result-prefixes="#all">
                <request/>
            </xf:instance>

            <xf:instance id="fr-service-response-instance" xxf:exclude-result-prefixes="#all">
                <response/>
            </xf:instance>

        </xf:model>
    </xh:head>
    <xh:body>
        <fr:view>
            <fr:body xmlns:xbl="http://www.w3.org/ns/xbl"
                     xmlns:dataModel="java:org.orbeon.oxf.fb.DataModel"
                     xmlns:oxf="http://www.orbeon.com/oxf/processors"
                     xmlns:p="http://www.orbeon.com/oxf/pipeline">
                <fr:section id="section-1-control" bind="section-1-bind">
                    <xf:label ref="$form-resources/section-1/label"/>
                    <xf:help ref="$form-resources/section-1/help"/>
                    <fr:grid>
                        <xh:tr>
                            
                            <xh:td>
                                <xf:output id="montevideo-control" bind="montevideo-bind">
                                    <xf:label ref="$form-resources/montevideo/label"/>
                                    <xf:hint ref="$form-resources/montevideo/hint"/>
                                    <xf:help ref="$form-resources/montevideo/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:output>
                            </xh:td>
                            <xh:td>
                                <xf:input id="fechaActual-control" bind="fechaActual-bind">
                                    <xf:label ref="$form-resources/fechaActual/label"/>
                                    <xf:hint ref="$form-resources/fechaActual/hint"/>
                                    <xf:help ref="$form-resources/fechaActual/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="section-4-control" bind="section-4-bind">
                    <xf:label ref="$form-resources/section-4/label"/>
                    <xf:help ref="$form-resources/section-4/help"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="nombreDenunciante-control" bind="nombreDenunciante-bind">
                                    <xf:label ref="$form-resources/nombreDenunciante/label"/>
                                    <xf:hint ref="$form-resources/nombreDenunciante/hint"/>
                                    <xf:help ref="$form-resources/nombreDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="cedulaDenunciante-control" bind="cedulaDenunciante-bind">
                                    <xf:label ref="$form-resources/cedulaDenunciante/label"/>
                                    <xf:hint ref="$form-resources/cedulaDenunciante/hint"/>
                                    <xf:help ref="$form-resources/cedulaDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="direccionDenunciante-control" bind="direccionDenunciante-bind">
                                    <xf:label ref="$form-resources/direccionDenunciante/label"/>
                                    <xf:hint ref="$form-resources/direccionDenunciante/hint"/>
                                    <xf:help ref="$form-resources/direccionDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td/>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="ciudadDenunciante-control" bind="ciudadDenunciante-bind">
                                    <xf:label ref="$form-resources/ciudadDenunciante/label"/>
                                    <xf:hint ref="$form-resources/ciudadDenunciante/hint"/>
                                    <xf:help ref="$form-resources/ciudadDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:select1 id="deptoDenunciante-control" appearance="minimal" bind="deptoDenunciante-bind">
                                    <xf:label ref="$form-resources/deptoDenunciante/label"/>
                                    <xf:hint ref="$form-resources/deptoDenunciante/hint"/>
                                    <xf:help ref="$form-resources/deptoDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    <xf:item>
                                        <xf:label>[Select...]</xf:label>
                                        <xf:value/>
                                    </xf:item>
                                    <xf:itemset ref="$form-resources/deptoDenunciante/item">
                                        <xf:label ref="label"/>
                                        <xf:value ref="value"/>
                                    </xf:itemset>
                                </xf:select1>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="telDenunciante-control" bind="telDenunciante-bind">
                                    <xf:label ref="$form-resources/telDenunciante/label"/>
                                    <xf:hint ref="$form-resources/telDenunciante/hint"/>
                                    <xf:help ref="$form-resources/telDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="correoDenunciante-control" bind="correoDenunciante-bind">
                                    <xf:label ref="$form-resources/correoDenunciante/label"/>
                                    <xf:hint ref="$form-resources/correoDenunciante/hint"/>
                                    <xf:help ref="$form-resources/correoDenunciante/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="section-5-control" bind="section-5-bind">
                    <xf:label ref="$form-resources/section-5/label"/>
                    <xf:help ref="$form-resources/section-5/help"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="nombreDenunciado-control" bind="nombreDenunciado-bind">
                                    <xf:label ref="$form-resources/nombreDenunciado/label"/>
                                    <xf:hint ref="$form-resources/nombreDenunciado/hint"/>
                                    <xf:help ref="$form-resources/nombreDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="cedulaDenunciado-control" bind="cedulaDenunciado-bind">
                                    <xf:label ref="$form-resources/cedulaDenunciado/label"/>
                                    <xf:hint ref="$form-resources/cedulaDenunciado/hint"/>
                                    <xf:help ref="$form-resources/cedulaDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="direccionDenunciado-control" bind="direccionDenunciado-bind">
                                    <xf:label ref="$form-resources/direccionDenunciado/label"/>
                                    <xf:hint ref="$form-resources/direccionDenunciado/hint"/>
                                    <xf:help ref="$form-resources/direccionDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td/>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="ciudadDenunciado-control" bind="ciudadDenunciado-bind">
                                    <xf:label ref="$form-resources/ciudadDenunciado/label"/>
                                    <xf:hint ref="$form-resources/ciudadDenunciado/hint"/>
                                    <xf:help ref="$form-resources/ciudadDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:select1 id="deptoDenunciado-control" appearance="minimal" bind="deptoDenunciado-bind">
                                    <xf:label ref="$form-resources/deptoDenunciado/label"/>
                                    <xf:hint ref="$form-resources/deptoDenunciado/hint"/>
                                    <xf:help ref="$form-resources/deptoDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                    <xf:item>
                                        <xf:label>[Select...]</xf:label>
                                        <xf:value/>
                                    </xf:item>
                                    <xf:itemset ref="$form-resources/deptoDenunciado/item">
                                        <xf:label ref="label"/>
                                        <xf:value ref="value"/>
                                    </xf:itemset>
                                </xf:select1>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="telefonoDenunciado-control" bind="telefonoDenunciado-bind">
                                    <xf:label ref="$form-resources/telefonoDenunciado/label"/>
                                    <xf:hint ref="$form-resources/telefonoDenunciado/hint"/>
                                    <xf:help ref="$form-resources/telefonoDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td>
                                <xf:input id="correoDenunciado-control" bind="correoDenunciado-bind">
                                    <xf:label ref="$form-resources/correoDenunciado/label"/>
                                    <xf:hint ref="$form-resources/correoDenunciado/hint"/>
                                    <xf:help ref="$form-resources/correoDenunciado/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="section-21-control" bind="section-21-bind">
                    <xf:label ref="$form-resources/section-21/label"/>
                    <xf:help ref="$form-resources/section-21/help"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:textarea id="detalleDenuncia-control" bind="detalleDenuncia-bind">
                                    <xf:label ref="$form-resources/detalleDenuncia/label"/>
                                    <xf:hint ref="$form-resources/detalleDenuncia/hint"/>
                                    <xf:help ref="$form-resources/detalleDenuncia/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:textarea>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
                <fr:section id="section-7-control" bind="section-7-bind">
                    <xf:label ref="$form-resources/section-7/label"/>
                    <xf:help ref="$form-resources/section-7/help"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:output id="firma-control" bind="firma-bind">
                                    <xf:label ref="$form-resources/firma/label"/>
                                    <xf:hint ref="$form-resources/firma/hint"/>
                                    <xf:help ref="$form-resources/firma/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:output>
                            </xh:td>
                        </xh:tr>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="confirmacionDenuncia-control" bind="confirmacionDenuncia-bind">
                                    <xf:label ref="$form-resources/confirmacionDenuncia/label"/>
                                    <xf:hint ref="$form-resources/confirmacionDenuncia/hint"/>
                                    <xf:help ref="$form-resources/confirmacionDenuncia/help"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
            </fr:body>
        </fr:view>
    </xh:body>
</xh:html>'! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 11/23/2013 11:26'!
example1

	^self for: (FileStream fileNamed: '/opt/encuesta-ute2.xml') contents.! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 11/23/2013 11:26'!
example2
 "
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute2.xml') contents with: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents.
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents
" 

	^self for: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents.! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 08/03/2014 14:16'!
example3
 "
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute2.xml') contents with: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents.
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents
" 

	^self for: (FileStream fileNamed: '/opt/definition-orbeon46.xml') contents.! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 08/04/2014 15:59'!
example4
 "
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute2.xml') contents with: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents.
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents
" 

	^self for: (FileStream fileNamed: '/opt/orbeon-def46.xml') contents.! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 08/04/2014 10:17'!
example5
 "
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute2.xml') contents with: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents.
OrbeonFormReader for: (FileStream fileNamed: '/opt/encuesta-ute-form.xml') contents
" 

	^self for: (FileStream fileNamed: '/opt/orbeon-def46.xml') contents 
			with: (FileStream fileNamed: '/opt/instance-orbeon46.xml') contents! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 11/23/2013 11:26'!
for: xmlOrbeonFormDefinition

	^super new initialize
		xmlDefinition: xmlOrbeonFormDefinition;
		parseXMLDefinition;
		yourself! !

!OrbeonFormReader class methodsFor: 'other' stamp: 'BrunoBB 11/23/2013 11:26'!
for: xmlOrbeonFormDefinition with: xmlOrbeonInstance

	^super new initialize
		xmlDefinition: xmlOrbeonFormDefinition;
		parseXMLDefinition;
		setXmlInstanceDocument: xmlOrbeonInstance;
		yourself! !

!OrbeonFormReader methodsFor: 'permissions' stamp: 'BrunoBB 03/18/2016 10:33'!
addAnyOnePermissionTo: permissions fromString: stringOperations
	"The receiver add permissions to OrbeonPermissions <permissions> took from string <stringOperations>.
	<stringOperations> format: 'read update delete' "

	(stringOperations subStrings: ' ') do: [:oper | permissions add: oper to: 'anyone']! !

!OrbeonFormReader methodsFor: 'permissions' stamp: 'BrunoBB 03/18/2016 10:44'!
addPermissionTo: permissions fromString: stringOperations using: permissionNode
	"The receiver add permission to OrbeonPermissions <permissions> to roles in node <permissionNode> with grant <stringOperations>"
	| subNode |

	subNode := permissionNode nodes first.
	
	(stringOperations subStrings: ' ') do: [:oper | 
		(subNode name = 'user-role')
		ifFalse: [permissions add: oper to: subNode name] "for group-members and owner"
		"for specific roles. -any-of- can have more than one role"
		ifTrue: [((subNode attributeAt: 'any-of') subStrings: ' ') do: [:rol | permissions add: oper to: rol]] 
	].! !

!OrbeonFormReader methodsFor: 'recursive section 2' stamp: 'BrunoBB 04/02/2016 10:34'!
createFieldsInstancesFor: aFormSectionInstance xmlSegment: xmlInstanceSegment
	"The receiver iterate over <aFormSectionInstance> fields names to get the values of each one contained in <xmlInstanceSegment>.
	Store each value in <aFormSectionInstance>"

	aFormSectionInstance fieldNames do: [:fieldName | | node value |

		node := xmlInstanceSegment elementAt: fieldName. "get xml field node"

		value := (node isNil or: [node hasChildren not]) ifTrue: [''] ifFalse: [self getValueFrom: node]. "get field value"

		aFormSectionInstance fieldAt: fieldName put: value.  "store the field value in the form instance <aFormSectionInstance>"

		"values at: fieldName put: (FormFieldValure for: value)." ].! !

!OrbeonFormReader methodsFor: 'output' stamp: 'BrunoBB 08/06/2014 11:40'!
createGridsFor: aFormSectionInstance with: aDictionary
	| sectionDefinition sectionGridsNames |

	sectionDefinition := aFormSectionInstance sectionDefinition.

	sectionGridsNames := aDictionary keys select: [:eachKey | sectionDefinition includesGridDefinitionNamed: eachKey].

	sectionGridsNames do: [:gridName | | gridDefinition grid |
		gridDefinition := sectionDefinition getGridDefinitionNamed: gridName.
		grid := FormGridInstance name: gridName definition: gridDefinition.
		grid gridIterations: (aDictionary at: gridName).
		aFormSectionInstance addGrid: grid.
		].! !

!OrbeonFormReader methodsFor: 'recursive section 2' stamp: 'BrunoBB 09/04/2015 11:11'!
createGridsFor: aFormSectionInstance xmlSegment: xmlSubSegment
	"Creates and store FormGridInstance on the form instance <aFormSectionInstance> getting values from xml node <xmlSubSegment>"
	| sectionDefinition |

	sectionDefinition := aFormSectionInstance sectionDefinition.
	"iteration over grid definitions of the <FormSectionDefinition> sectionDefinition "
	sectionDefinition gridNames do: [:gridName | | gridDefinition grid xmlGrid |

		gridDefinition := sectionDefinition getGridDefinitionNamed: gridName. "get the actual grid definition"
		grid := FormGridInstance name: gridName definition: gridDefinition. "create the grid instance"
		"iterate over each grid iterations. Each Grid Iteration is a Dictionary where the key is the field name and the value is the field value "
		xmlGrid := xmlSubSegment elementsAt: gridName do: [:xmlGridIteration | | iteration |
			iteration := Dictionary new.
			"iterate over fields of the current grid iteration to get field names and values"
			gridDefinition fieldDefinitions do: [:fieldDefinition | | fieldValue |
				fieldValue := xmlGridIteration elementAt: fieldDefinition name.
				fieldValue := (fieldValue isNil or: [fieldValue hasChildren not]) ifTrue: [''] ifFalse: [self getValueFrom: fieldValue].
				iteration at: fieldDefinition name put: fieldValue].

			grid addIteration: iteration]. "store the iteration in the grid instance"

		aFormSectionInstance addGrid: grid.]. "store the grid instance in the section instance"! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 04/03/2016 14:23'!
createInnerElementsOf: aFormSectionInstance basedOn: aFormSectionDefinition xmlSegment: xmlSegment
	"Creates the inner elements of <aFormSectionInstance> based on the definition <aFormSectionDefinition> using the xml <xmlSegment>.
	1- If <aFormSectionInstance> is repeatable call the repeatable method.
	2- If <aFormSectionInstance> is repeatable then creates the field instances and grid instances in the goes to sub sections in a recursive fashion"

	aFormSectionInstance isRepeatable 
	ifFalse: [
		"iterate over <section> fields names to get the values from <xmlSubSegment>"
		self createFieldsInstancesFor: aFormSectionInstance xmlSegment: xmlSegment.
		"create grid instances for the current section definition"
		aFormSectionDefinition gridDefinitions do: [:gridDefnition | self createGridsFor: aFormSectionInstance xmlSegment: xmlSegment.]. 
		"this is the recursive call to create sub sections"
		aFormSectionDefinition subSections do: [:subSectionDef |
			aFormSectionInstance addSubSection: (self createSubSectionsWith: subSectionDef xmlSegment: xmlSegment)].]
	ifTrue: [self createRepeatableSubSectionsInstancesWith: aFormSectionDefinition 
						instance: aFormSectionInstance 
						xmlSegment: xmlSegment].! !

!OrbeonFormReader methodsFor: 'recursive section 2' stamp: 'BrunoBB 04/03/2016 18:22'!
createInnerStructureOf: aFormSectionInstance basedOn: aFormSectionDefinition xmlSegment: xmlSegment
	"The receiver create the inner structure of section <aFormSectionInstance> with definition <aFormSectionDefinition> taking data from xml node <xmlSegment>"

	"create Fields Instances and Grid Instances"
	self createSimpleComponentsOf: aFormSectionInstance basedOn: aFormSectionDefinition xmlSegment: xmlSegment.

	"create the recursive subsections of the receiver"
	aFormSectionDefinition subSections do: [:subSectionDef | | sections |
		sections := (xmlSegment xPath: subSectionDef name)
								ifNotEmpty: [:collection | collection] 
								ifEmpty: [OrbeonInvalidXMLException signal: 'Invalid Subsections Structure'].

		sections do: [:xmlSection | | subSection |
			subSection := NormalSectionInstance	name: subSectionDef name definition: subSectionDef.
			aFormSectionInstance addSubSection: subSection.
			self createInnerStructureOf: subSection basedOn: subSectionDef xmlSegment: xmlSection].
	].! !

!OrbeonFormReader methodsFor: 'recursive section 2' stamp: 'BrunoBB 04/03/2016 18:27'!
createMainSectionInstancesWith: anOrbeonFormDefinition xmlSegment: xmlInstanceSegment
	"The receiver answer anOrderedCollection of FormSectionInstance based on form definition <anOrbeonFormDefinition> using the xml node <xmlInstanceSegment>.
	Iterate over Main Sections definitions of <anOrbeonFormDefinition> and recursively creates the sub sections.
	1. Create field instances. 2- Create grid instances. 3- Recursively create sub sections"
	| sectionsInstances |

	sectionsInstances := OrderedCollection new.
	anOrbeonFormDefinition sectionDefinitions do:[:section | | xmlSubSegments |
		xmlSubSegments := section isRepeatable
			ifTrue: [OrderedCollection withAll: (xmlInstanceSegment xPath: ('/form/', section getXmlterationName))]
			ifFalse: [OrderedCollection with: (xmlInstanceSegment elementAt: section name)].

		xmlSubSegments do: [:xmlSegment | | sectionInst |
			sectionInst := NormalSectionInstance name: section name definition: section.
			sectionsInstances add: sectionInst. "store the section instance in the dictionary collector"
			"if <xmlSubSegment> is NIL then the definition <anOrbeonFormDefinition> does NOT MATCH with the xml <xmlInstanceSegment>.
			This could be the case when in Orbeon a field is added/removed/renamed and the definition is saved with the same version"
			"if <xmlSubSegment> is NOT NIL then creates the inner (recursive) elements of <sectionInst> as defined in <section>"
			self createInnerStructureOf: sectionInst basedOn: section xmlSegment: xmlSegment.
		].
	].
	^sectionsInstances "a dictionary of FormSectionInstance"! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 03/07/2015 07:27'!
createRepeatableSubSectionsInstancesWith: aFormSectionDefinition instance: aFormSectionInstance xmlSegment: xmlSection
	"The receiver creates field instances, grid instances and sub sections of current repeatable section <aFormSectionInstance> based on the definition <aFormSectionDefinition>.
	The section data is the xml node <xmlSection>"

	"iterate over xml iteration nodes of the repeatable section <aFormSectionInstance>.
	each section iteration is in a xml node with the name <[setcionName]'-interation'>. 
	it get all section iterations and for each iteration 
	1- create field instances, 2- create grid instances, 3- add the iteration to the repeatble section"
	xmlSection elementsAt: (aFormSectionDefinition getXmlterationName) do: [:eachIteration | | sectionIteration |
		sectionIteration := NormalSectionInstance name: aFormSectionDefinition name definition: aFormSectionDefinition.
		self createFieldsInstancesFor: sectionIteration xmlSegment: eachIteration.
		aFormSectionDefinition gridDefinitions do: [:gridDefnition | self createGridsFor: sectionIteration xmlSegment: eachIteration.].
		aFormSectionInstance addSectionIteration: sectionIteration.
	].
	"recursive call to following embedded sub sections. 
	Note that the recursive call is on method #createSubSectionsWith:xmlSegment: , because embedded sub section could be normal or repetable section"
	aFormSectionDefinition subSections do: [:subSectionDef | 
		aFormSectionInstance addSubSection: (self createSubSectionsWith: subSectionDef xmlSegment: xmlSection).]. 

	^aFormSectionInstance! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 04/03/2016 15:15'!
createSectionsInstancesWith: anOrbeonFormDefinition
	"The receiver answer anOrderedCollection of FormSectionInstance. 
	The instances are created based in the definition parameter <anOrbeonFormDefinition> starting in the xml node 'form' "

	"^self createSectionsInstancesWith: anOrbeonFormDefinition xmlSegment: (xmlInstanceDocument elementAt: 'form')"

	^self createMainSectionInstancesWith: anOrbeonFormDefinition xmlSegment: (xmlInstanceDocument elementAt: 'form')! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 04/03/2016 13:56'!
createSectionsInstancesWith: anOrbeonFormDefinition xmlSegment: xmlInstanceSegment
	"The receiver answer anOrderedCollection of FormSectionInstance based on form definition <anOrbeonFormDefinition> using the xml node <xmlInstanceSegment>.
	Iterate over Main Sections definitions of <anOrbeonFormDefinition> and recursively creates the sub sections.
	1. Create field instances. 2- Create grid instances. 3- Recursively create sub sections"
	| sectionsInstances |

	sectionsInstances := OrderedCollection new.
	anOrbeonFormDefinition sectionDefinitions do:[:section | | sectionInst xmlSubSegment |
		xmlSubSegment := xmlInstanceSegment elementAt: section name. "xml that represent the current Section Instance"
		sectionInst := (section isRepeatable ifTrue: ["RepeatSectionInstance"NormalSectionInstance] ifFalse: [NormalSectionInstance]) name: section name definition: section.
		sectionsInstances add: sectionInst. "store the section instance in the dictionary collector"
		"if <xmlSubSegment> is NIL then the definition <anOrbeonFormDefinition> does NOT MATCH with the xml <xmlInstanceSegment>.
		This could be the case when in Orbeon a field is added/removed/renamed and the definition is saved with the same version"
		"if <xmlSubSegment> is NOT NIL then creates the inner (recursive) elements of <sectionInst> as defined in <section>"
		xmlSubSegment ifNotNil: [self createInnerElementsOf: sectionInst basedOn: section xmlSegment: xmlSubSegment].
	].
	^sectionsInstances "a dictionary of FormSectionInstance"! !

!OrbeonFormReader methodsFor: 'recursive section 2' stamp: 'BrunoBB 04/03/2016 18:29'!
createSimpleComponentsOf: aFormSectionInstance basedOn: aFormSectionDefinition xmlSegment: xmlSegment
	"The receiver create the simple components of section <aFormSectionInstance> with definition <aFormSectionDefinition> taking data from xml node <xmlSegment>"

	"iterate over <section> fields names to get the values from <xmlSubSegment>"
	self createFieldsInstancesFor: aFormSectionInstance xmlSegment: xmlSegment.

	"create grid instances for the current section definition"
	aFormSectionDefinition gridDefinitions do: [:gridDefnition | self createGridsFor: aFormSectionInstance xmlSegment: xmlSegment].! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 02/23/2015 04:19'!
createSubSectionsInstancesWith: aFormSectionDefinition instance: aFormSectionInstance xmlSegment: xmlSection
	"The receiver creates field instances, grid instances and sub sections of current section <aFormSectionInstance> based on the definition <aFormSectionDefinition>.
	The section data is the xml node <xmlSection>"

	"create field instance for <aFormSectionInstance> getting data from <xmlSection>"
	self createFieldsInstancesFor: aFormSectionInstance xmlSegment: xmlSection. 

	"create section grids for <aFormSectionInstance> getting data from <xmlSection>"
	aFormSectionDefinition gridDefinitions do: [:gridDefnition | self createGridsFor: aFormSectionInstance xmlSegment: xmlSection.]. 

	"recursive call to following embedded sub sections. 
	Note that the recursive call is on method #createSubSectionsWith:xmlSegment: , because embedded sub section could be normal or repetable section"

	aFormSectionDefinition subSections do: [:subSectionDef | 
		aFormSectionInstance addSubSection: (self createSubSectionsWith: subSectionDef xmlSegment: xmlSection).].

	^aFormSectionInstance! !

!OrbeonFormReader methodsFor: 'recursive section' stamp: 'BrunoBB 04/03/2016 13:56'!
createSubSectionsWith: aFormSectionDefinition xmlSegment: xmlInstanceSegment
	"Answer a <FormSectionInstance> with all sub sections included in it.
	The receiver recursively iterate over <aFormSectionDefinition> sub sections to recreate the XML structure of the form's sections.
	The recursive call depends on section property <isRepeatable>"
	| sectionInst xmlSection xpath |

	xpath := aFormSectionDefinition parentSectionIsRepeatable 
		ifTrue: [aFormSectionDefinition parentSection getXmlterationName, '/', aFormSectionDefinition name] "it must access the iteration node first then the xml section"
		ifFalse: [aFormSectionDefinition name]. "access the xml node directly"

	xmlSection := (xmlInstanceSegment xPath: xpath) ifNotEmpty: [:collection | collection last] ifEmpty: [OrbeonInvalidXMLException signal: 'Invalid Subsections Structure'].

	aFormSectionDefinition isRepeatable 
		ifFalse: [sectionInst := NormalSectionInstance	name: aFormSectionDefinition name definition: aFormSectionDefinition.
					self createSubSectionsInstancesWith: aFormSectionDefinition instance: sectionInst xmlSegment: xmlSection] 

		ifTrue: [sectionInst := "RepeatSectionInstance"NormalSectionInstance	name: aFormSectionDefinition name definition: aFormSectionDefinition.
					self createRepeatableSubSectionsInstancesWith: aFormSectionDefinition instance: sectionInst xmlSegment: xmlSection].

	^sectionInst! !

!OrbeonFormReader methodsFor: 'query xml' stamp: 'BrunoBB 02/19/2014 06:13'!
defaultNonPermissions

	^Dictionary new
		at: 'create' put: (OrderedCollection with: 'all');
		at: 'read' put: (OrderedCollection with: 'all');
		at: 'read' put: (OrderedCollection with: 'all');
		at: 'read' put: (OrderedCollection with: 'all');
		at: 'update' put: (OrderedCollection with: 'all');
		at: 'update' put: (OrderedCollection with: 'all');
		at: 'delete' put: (OrderedCollection with: 'all');
		at: 'export' put: (OrderedCollection with: 'all');
		at: 'sync' put: (OrderedCollection with: 'all');
		yourself! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 09/13/2015 15:55'!
formFieldsIn: xmlSection
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>. Components inside -repeat element- are NOT listed.
	The forms field are defined in the XForms after:    
		<xh:body> <fr:view>  tags"
	| fields collectableFields |

	collectableFields := self orbeonCollectableFieldsTags.
	fields := OrderedCollection new.
	xmlSection elementsAt: 'fr:grid' do: [:eachGrid | (eachGrid includesAttribute: 'repeat') 
		ifFalse: [collectableFields do:[:nodeName | eachGrid allElementsNamed: nodeName do: [:eachField | fields add: eachField]]]].
	^fields! !

!OrbeonFormReader methodsFor: 'orbeon fields' stamp: 'BrunoBB 07/16/2015 12:15'!
formFieldsLabels
	"The receiver answer a Dictionary with all fields label of all components of the form <xmlDocument>"
	| fieldsLabels labelNode |

	fieldsLabels := Dictionary new.
	labelNode := xmlDocument allElementsNamed: 'xf:instance' do: [:each | ((each includesAttribute: 'id') and: [(each attributeAt: 'id') = 'fr-form-resources']) ifTrue: [labelNode := each]]. "the node where labels are in '/xf:instance/resources/resource' "

	(labelNode findElementNamed: 'resource') elementsDo: [:each |  | originalLabel textNode |
		textNode := each elementAt: 'label' ifAbsent: [nil].
		originalLabel := textNode ifNil: ['No Label'] 
			ifNotNil: [textNode stringNodes isEmpty 
							ifTrue:['No Label'] 
							ifFalse:[textNode stringNodes first string]].
		fieldsLabels at: each name put: originalLabel].

	^fieldsLabels! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 02/19/2015 04:21'!
formGridComponentsIn: xmlSection
	"The receiver get the repeat component of Orbeon Form Definition <xmlDefinition>"
	| grids |

	grids := OrderedCollection new.
	xmlSection elementsAt: 'fr:grid' do: [:eachGrid | (eachGrid includesAttribute: 'repeat') 
		ifTrue: [grids add: eachGrid]].
	^grids! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 02/02/2015 14:33'!
formGridFieldsIn: xmlGrid
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed.
	The forms field are defined in the XForms after:    
		<xh:body> <fr:view>  tags"
	| fields collectableFields|

	collectableFields := self orbeonCollectableFieldsTags.
	fields := OrderedCollection new.
	xmlGrid elementsDo: [:eachGrid | (eachGrid includesAttribute: 'repeat') 
		ifFalse: [collectableFields do:[:nodeName | eachGrid allElementsNamed: nodeName do: [:eachField | fields add: eachField]]]].
	^fields! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/16/2016 10:40'!
formGridFieldsNameIn: xmlGrid
	"The receiver get the name od the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed "

	^(self formGridFieldsIn: xmlGrid) collect: [:each | self getNameFrom: each]! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 06/22/2015 13:36'!
formMainSections
	| element |

	element := xmlDocument elementsAt: 'xh:html'.
	element := element isEmpty ifFalse: [element last] ifTrue: [^OrbeonInvalidXMLException signal: 'Bad format - No <xh:html> element'].

	element := element elementsAt: 'xh:body'.
	element := element isEmpty ifFalse: [element last] ifTrue: [^OrbeonInvalidXMLException signal: 'Bad format - No <xh:body> element'].

	element := element elementsAt: 'fr:view'.
	element := element isEmpty ifFalse: [element last] ifTrue: [^OrbeonInvalidXMLException signal: 'Bad format - No <fr:view> element'].

	element := element elementsAt: 'fr:body'.
	element := element isEmpty ifFalse: [element last] ifTrue: [^OrbeonInvalidXMLException signal: 'Bad format - No <fr:body> element'].

	^(element elementsAt: 'fr:section') asOrderedCollection! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 02/05/2015 04:10'!
formMainSectionsRepeatable: aBoolean

	aBoolean ifFalse: [^self formMainSections reject: [:eachSection | (eachSection includesAttribute: 'repeat')]].

	^self formMainSections select: [:eachSection | (eachSection includesAttribute: 'repeat')]! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 02/19/2015 04:05'!
formSubSectionsOf: xmlElement
	| subSections |

	subSections := OrderedCollection new.
	xmlElement elementsAt: 'fr:section' do: [:eachSection | subSections add: eachSection].
	^subSections! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 10:26'!
getAllFormFieldsIn: xmlNode
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>.
	The forms field are defined in the XForms after:    
		<xh:body> <fr:view>  tags"
	| fields collectableFields |

	collectableFields := self orbeonCollectableFieldsTags.
	fields := OrderedCollection new.
	collectableFields do:[:nodeName | xmlNode allElementsNamed: nodeName do: [:eachField | fields add: eachField]].

	^fields! !

!OrbeonFormReader methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:13'!
getApplicationName

	^(xmlDocument findElementNamed: 'application-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: [''] ifFalse: [value strings last]]
		ifNil: [''].! !

!OrbeonFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/20/2016 15:51'!
getAttachmentIdsFrom: anOrbeonFormDefinition
	"The receiver collect all attachment's id of the form definition <anOrbeonFormDefinition>"
	| ids modelNode formNode |

	modelNode := (xmlDocument findElementNamed: 'xf:model') ifNotNil: [:value | value] ifNil: [^#()].
	formNode := (modelNode findElementNamed: 'form') ifNotNil: [:value | value] ifNil: [^#()].
	ids := OrderedCollection new.
	"iterate over attachment fields #getAttachmentFields"
	anOrbeonFormDefinition getAttachmentFields do: [:each |
		(formNode findElementNamed: each name) 
		ifNotNil: [:attachNode | (self getValueFrom: attachNode) ifNotNil: [:value | ids add: value]].
	].
	"the file name format is: <definitionId>-<fileId>"
	^ids collect: [:each | | macIndex attachmentId |
			macIndex := each findString: 'mac='.
			macIndex ifNil: [^OrbeonInvalidXMLException signal: 'No "mac=" sentence in attachment value'].
			attachmentId := each copyFrom: macIndex + 4 to: each size.
			anOrbeonFormDefinition getId, '-', attachmentId]! !

!OrbeonFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/18/2016 10:54'!
getCustomAttachmentId
	"The receiver answer the id of the Custom PDF attachment. This custom PDF is used to create the PDF of the Form"
	| attachNode pdfNode |

	attachNode := xmlDocument findElementNamed: 'attachments'.
	attachNode ifNil: [^nil].
	pdfNode := attachNode findElementNamed: 'pdf'.
	pdfNode ifNil: [^nil].

	pdfNode stringNodes isEmpty ifTrue: [^nil].

	^(pdfNode stringNodes last string subStrings: '=') last! !

!OrbeonFormReader methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:14'!
getDescription

	^(xmlDocument findElementNamed: 'description')
		ifNotNil: [:value | value strings isEmpty ifTrue: [''] ifFalse: [value strings last]]
		ifNil: [''].! !

!OrbeonFormReader methodsFor: 'query xml' stamp: 'BrunoBB 03/26/2015 07:00'!
getFieldTypes
	"Answer aDictionary with all fields types. The <key> is the name of the field and the <value> is name of the type"
	| fieldTypes |

	fieldTypes := Dictionary new.
	xmlDocument allElementsNamed: 'xf:bind' do: [:eachBindNode | 
			fieldTypes at: (eachBindNode attributeAt: 'name') 
							put: (self getTypeFrom: eachBindNode)].
	^fieldTypes! !

!OrbeonFormReader methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:13'!
getFormName

	^(xmlDocument findElementNamed: 'form-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: [''] ifFalse: [value strings last]]
		ifNil: [''].! !

!OrbeonFormReader methodsFor: 'orbeon fields' stamp: 'BrunoBB 09/04/2015 11:06'!
getNameFrom: xmlNode
	| fieldName |

	fieldName := xmlNode attributeAt: 'id'.
	(fieldName size <= 8) ifTrue: [^OrbeonControlSizeException signal: 'No "-control" word found in field''s name'].
	fieldName := fieldName allButLast: 8. "remove <-control> word from original id"
	^fieldName! !

!OrbeonFormReader methodsFor: 'permissions' stamp: 'BrunoBB 03/18/2016 10:33'!
getPermissions
	"The receiver answer aOrbeonPermissions instances with all permissions in <xmlDocument>"
	| permissions permissionNodes |

	permissions := OrbeonPermissions new.
	permissionNodes := xmlDocument allElementsNamed: 'permission'.

	permissionNodes do: [:node |
		node hasContentNodes " -anyone- role does not have content (is an empty node)"
		ifTrue: [self addPermissionTo: permissions fromString: (node attributeAt: 'operations') using: node]
		ifFalse: [self addAnyOnePermissionTo: permissions fromString: (node attributeAt: 'operations')] 
	].

	^permissions! !

!OrbeonFormReader methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:13'!
getTitle

	^(xmlDocument findElementNamed: 'title')
		ifNotNil: [:value | value strings isEmpty ifTrue: [''] ifFalse: [value strings last]]
		ifNil: [''].! !

!OrbeonFormReader methodsFor: 'query xml' stamp: 'BrunoBB 03/26/2015 07:02'!
getTypeFrom: eachBindNode
	"This method HAS TO BE IMPROVED. Get the type from the XML node <eachBindNode> "

	(eachBindNode includesAttribute: 'type') ifTrue: [^eachBindNode attributeAt: 'type']. "has the attribute -type-"

	^'xf:string'! !

!OrbeonFormReader methodsFor: 'output' stamp: 'BrunoBB 09/05/2015 14:08'!
getValueFrom: node

	^self getValueFrom: node ifNone: [nil]! !

!OrbeonFormReader methodsFor: 'output' stamp: 'BrunoBB 09/05/2015 14:06'!
getValueFrom: node ifNone: aBlock

	node stringNodes isEmpty ifTrue: [^aBlock value].

	^node stringNodes last string! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 02/04/2015 14:21'!
hasSubSections: xmlElement
	"Answer whether or not <xmlElement> has sub sections"

	^(xmlElement elementsAt: 'fr:section') notEmpty! !

!OrbeonFormReader methodsFor: 'orbeon fields' stamp: 'BrunoBB 10/14/2015 16:41'!
isAttachmentField: fieldNode

	^((fieldNode localName = 'attachment') "regular attachments - the attachment can be removed from form instance"
			or: [fieldNode localName = 'image-attachment']) "image attachments - the attachment can be removed from form instance"
				or: [(fieldNode attributeAt: 'class' ifAbsent: [^false]) includesSubstring: 'fb-attachment'] "fixed image attachments - attachment can NOT be removed from form instance"! !

!OrbeonFormReader methodsFor: 'orbeon fields' stamp: 'BrunoBB 03/16/2016 16:34'!
orbeonCollectableFieldsTags
	"Answer a collection of Orbeon tags designed to represent components in a XForms definition.
	At render time Orbeon transform each of these tags to an HMTL tag."

	^#('xf:input' 'xf:select1' 'xf:textarea' 'fr:number' 'xf:select' 'fr:dropdown-date' 'xf:secret' 'fr:tinymce' 'us:phone' 'fr:currency' 'fr:fields-date' 'fr:date-picker' 'fr:box-select' 'fr:databound-select1' 'fr:autocomplete' 'xf:output' 'fr:image-attachment' 'fr:attachment' 'fr:wpaint' 'fr:dropdown-select1' 'fr:us-phone')! !

!OrbeonFormReader methodsFor: 'parsing' stamp: 'BrunoBB 06/22/2015 05:45'!
parseXMLDefinition
	"Creates a new instance of the receiver for a file named <aString>"

	xmlDocument := XMLDOMParser parse: xmlDefinition.
	^xmlDocument! !

!OrbeonFormReader methodsFor: 'parsing' stamp: 'BrunoBB 02/10/2016 11:28'!
parseXMLInstance: orbeonXMLInstance
	"Parse the xml orbeon instnace of the receiver "

	xmlInstanceDocument := XMLDOMParser parse: orbeonXMLInstance.
	^xmlInstanceDocument! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 10:25'!
searchFormFieldsIn: xmlSection
	"The receiver answer a collection with the field definitions in Form Section <xmlSection> that are field search"

	^(self getAllFormFieldsIn: xmlSection) select: [:each | ((each attributeAt: 'class') findString: 'fr-search' startingAt: 1) ~= 0]! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 09/04/2015 11:22'!
searchFormFieldsNameIn: xmlSection
	"The receiver get the name od the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed "

	^(self searchFormFieldsIn: xmlSection) collect: [:each | self getNameFrom: each]! !

!OrbeonFormReader methodsFor: 'parsing' stamp: 'BrunoBB 09/09/2015 15:04'!
setXmlInstanceDocument: xmlOrbeonInstance
	"Parse the XML Form instance from xml string <xmlOrbeonInstance>"

	"self parseXMLInstance: (self workAroundBugForXML: xmlOrbeonInstance)"

	self parseXMLInstance: xmlOrbeonInstance! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 13:57'!
summaryFormFieldsIn: xmlSection
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed "
	
	^(self getAllFormFieldsIn: xmlSection) select: [:each | ((each attributeAt: 'class') findString:  'fr-summary' startingAt: 1) ~= 0]! !

!OrbeonFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 09/04/2015 11:22'!
summaryFormFieldsNameIn: xmlSection
	"The receiver get the name od the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed "

	^(self summaryFormFieldsIn: xmlSection) collect: [:each | self getNameFrom: each]! !

!OrbeonFormReader methodsFor: 'bug' stamp: 'BrunoBB 02/06/2014 14:06'!
workAroundBugForXML: newValue
   "This is a workaround for GemStone XMLParser with -xml:lang- tag"
	| valueWithoutBug |

	valueWithoutBug := self workAroundBugForXML: newValue bugString: 'xml:lang="es"'.

	^self workAroundBugForXML: valueWithoutBug bugString: 'xml:lang="en"'! !

!OrbeonFormReader methodsFor: 'bug' stamp: 'BrunoBB 11/29/2013 16:16'!
workAroundBugForXML: newValue bugString: bugString
   "Modify the value of the instance variable 'xmlDefinition'."
	| valueWithoutBug index |

	valueWithoutBug := newValue.
	index := 0.
   [index := (valueWithoutBug findString: bugString startingAt: 1). index ~= 0] 
		whileTrue: [valueWithoutBug replaceFrom: index to: (index + 12) with: '             '].
	^valueWithoutBug! !

!OrbeonFormReader methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2013 11:26'!
xmlDefinition

   "Return the value of the instance variable 'xmlDefinition'."
   ^xmlDefinition! !

!OrbeonFormReader methodsFor: 'bug' stamp: 'BrunoBB 09/09/2015 15:01'!
xmlDefinition: newValue
   "Modify the value of the instance variable 'xmlDefinition'."

	"xmlDefinition := self workAroundBugForXML: newValue."

	xmlDefinition := newValue! !

!OrbeonFormReader methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2013 11:26'!
xmlDocument

   "Return the value of the instance variable 'xmlDocument'."
   ^xmlDocument! !

!OrbeonFormReader methodsFor: 'Updating' stamp: 'BrunoBB 11/23/2013 11:26'!
xmlDocument: newValue

   "Modify the value of the instance variable 'xmlDocument'."
   xmlDocument := newValue! !

!OrbeonFormReader methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2013 11:26'!
xmlInstanceDocument

   "Return the value of the instance variable 'xmlInstanceDocument'."
   ^xmlInstanceDocument! !

!OrbeonFormReader methodsFor: 'Updating' stamp: 'BrunoBB 11/23/2013 11:26'!
xmlInstanceDocument: newValue

   "Modify the value of the instance variable 'xmlInstanceDocument'."
   xmlInstanceDocument := newValue! !

OrbeonFormReader subclass: #OrbeonXPathFormReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 10:33'!
formFieldsIn: xmlSection
	"The receiver answer a collection with all fields in Section <xmlSection> excluding Repeatable Sections.
	Fields inside Repeatable GRIDS [fr:grid] are also ingnored"
	| fields |

	fields := OrderedCollection new.
	(xmlSection xPath: 'fr:grid[not(@repeat)]') "does NOT contain attribute <repeat>"
		do: [:eachGrid | 
			(eachGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''fr:'')]') addAllTo: fields.
			(eachGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''us:'')]') addAllTo: fields.
			(eachGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''xf:'')]') addAllTo: fields.].

	^fields! !

!OrbeonXPathFormReader methodsFor: 'orbeon fields' stamp: 'BrunoBB 03/15/2016 17:45'!
formFieldsLabels
	"The receiver answer a Dictionary with all fields label of all components of the form <xmlDocument>"
	| fieldsLabels |

	fieldsLabels := Dictionary new.

	(xmlDocument xPath: '//xf:instance[@id=''fr-form-resources'']/resources//resource/*') do: [:each |  | originalLabel textNode |
		textNode := each elementAt: 'label' ifAbsent: [nil].
		originalLabel := textNode ifNil: ['No Label'] 
			ifNotNil: [textNode stringNodes isEmpty 
							ifTrue:['No Label'] 
							ifFalse:[textNode stringNodes first string]].
		fieldsLabels at: each name put: originalLabel].

	^fieldsLabels! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 12:13'!
formGridComponentsIn: xmlSection
	"The receiver get the repeat component of Orbeon Form Definition <xmlDefinition>"
	| grids |

	grids := OrderedCollection new.

	"includes attribute -repeat-"
	(xmlSection xPath: 'fr:grid[@repeat]') addAllTo: grids. 
	
	^grids! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/16/2016 11:03'!
formGridFieldsIn: xmlGrid
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed.
	The forms field are defined in the XForms after:    
		<xh:body> <fr:view>  tags"
	| fields |

	fields := OrderedCollection new.

	(xmlGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''fr:'')]') addAllTo: fields.
	(xmlGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''us:'')]') addAllTo: fields.
	(xmlGrid xPath: 'xh:tr/xh:td/*[starts-with(name(), ''xf:'')]') addAllTo: fields.

	^fields! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/16/2016 11:12'!
formMainSections

	"check for the existence of the structure"
	(xmlDocument xPath: 'boolean(xh:html/xh:body/fr:view/fr:body)') 
	ifFalse: [^OrbeonInvalidXMLException signal: 'Bad format - No <xh:html> element'].

	^(xmlDocument xPath: 'xh:html/xh:body/fr:view/fr:body/fr:section') asOrderedCollection! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/16/2016 12:28'!
formSubSectionsOf: xmlElement
	"Answer a collection with the subsection of <xmlElement>"

	^(xmlElement xPath: 'fr:section') asOrderedCollection! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 10:47'!
getAllFormFieldsIn: xmlNode
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>.
	The forms field are defined in the XForms after:    
		<xh:body> <fr:view>  tags"
	| fields |

	fields := OrderedCollection new.
	(xmlNode xPath: './/fr:grid/xh:tr/xh:td/*[starts-with(name(), ''fr:'')]') addAllTo: fields.
	(xmlNode xPath: './/fr:grid/xh:tr/xh:td/*[starts-with(name(), ''us:'')]') addAllTo: fields.
	(xmlNode xPath: './/fr:grid/xh:tr/xh:td/*[starts-with(name(), ''xf:'')]') addAllTo: fields.

	^fields! !

!OrbeonXPathFormReader methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 12:44'!
getApplicationName

	^(xmlDocument xPath: '//metadata/application-name')
		ifEmpty: [OrbeonInvalidXMLException signal: 'Application node missing'] 
		ifNotEmpty: [:collection | 
			collection first strings isEmpty 
				ifTrue: [''] 
				ifFalse: [collection first strings last]]! !

!OrbeonXPathFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/20/2016 15:50'!
getAttachmentIdsFrom: anOrbeonFormDefinition
	"The receiver collect all attachment's id of the form definition <anOrbeonFormDefinition>.
	Each attachment has an associated file. 
	Empty Attachment field definition (without file in the Form Definition) are NOT listed in this method"
	| ids nativeOrbeonIds nodes formNode |

	nodes := xmlDocument xPath: '//xf:instance/form'.
	(nodes size = 1) ifFalse: [^OrbeonInvalidXMLException signal: 'Only one [form] node is allowed'].
	formNode  := nodes last.
	nativeOrbeonIds := Dictionary new.
	ids := Dictionary new.
	"iterate over attachment fields #getAttachmentFields"
	anOrbeonFormDefinition getAttachmentFields do: [:each |
		(formNode xPath: './/',each name) 
		ifNotEmpty: [:collection | | attachNode |
			attachNode := collection last.
			(self getValueFrom: attachNode) ifNotNil: [:value | nativeOrbeonIds at: each name put: value]]
	].
	"the file name format is: <definitionId>-<fileId>"
	nativeOrbeonIds keysAndValuesDo: [:key :value |  | macIndex attachmentId |
		macIndex := value findString: 'mac='.
		macIndex ifNil: [^OrbeonInvalidXMLException signal: 'No "mac=" sentence in attachment value'].
		attachmentId := value copyFrom: macIndex + 4 to: value size.
		ids at: key put: (anOrbeonFormDefinition getId, '-', attachmentId)].

	^ids! !

!OrbeonXPathFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/19/2016 13:03'!
getAttachmentsFields

	^(xmlDocument xPath: '//fr:view//fr:attachment') , 
		(xmlDocument xPath: '//fr:view//fr:image-attachment'),
		(xmlDocument xPath: '//fr:view//contains[@class, ''fb-attachment'']')! !

!OrbeonXPathFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/18/2016 11:10'!
getCustomAttachmentId
	"The receiver answer the id of the Custom PDF attachment. This custom PDF is used to create the PDF of the Form"
	| pdfQueryNode pdfNode |

	pdfQueryNode := xmlDocument xPath: '//xf:instance/attachments/pdf'.
	pdfQueryNode ifEmpty: [^nil].

	pdfNode := pdfQueryNode last.
	pdfNode stringNodes ifEmpty: [^nil].

	^(pdfNode stringNodes last string subStrings: '=') last! !

!OrbeonXPathFormReader methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 12:44'!
getDescription

	^(xmlDocument xPath: '//metadata/description')
		ifEmpty: [OrbeonInvalidXMLException signal: 'Description node missing'] 
		ifNotEmpty: [:collection | 
			collection first strings isEmpty 
				ifTrue: [''] 
				ifFalse: [collection first strings last]]! !

!OrbeonXPathFormReader methodsFor: 'query xml' stamp: 'BrunoBB 03/16/2016 15:10'!
getFieldTypes
	"Answer aDictionary with all fields types. The <key> is the name of the field and the <value> is name of the type"
	| fieldTypes |

	fieldTypes := Dictionary new.

	(xmlDocument xPath: '//xf:bind') do: [:eachBindNode |  
		fieldTypes at: (eachBindNode attributeAt: 'name') put: (self getTypeFrom: eachBindNode)].

	^fieldTypes.! !

!OrbeonXPathFormReader methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 12:45'!
getFormName

	^(xmlDocument xPath: '//metadata/form-name')
		ifEmpty: [OrbeonInvalidXMLException signal: 'Form-Name node missing'] 
		ifNotEmpty: [:collection | 
			collection first strings isEmpty 
				ifTrue: [''] 
				ifFalse: [collection first strings last]]! !

!OrbeonXPathFormReader methodsFor: 'query xml' stamp: 'BrunoBB 03/16/2016 15:16'!
getPermissions
	"The receiver answer aOrbeonPermissions instances with all permissions in <xmlDocument>"
	| permissions permissionNodes |

	permissions := OrbeonPermissions new.
	permissionNodes := xmlDocument xPath: '//metadata/permissions/permission'.

	permissionNodes do: [:node |
		node hasContentNodes " -anyone- role does not have content"
		ifTrue: [self addPermissionTo: permissions fromString: (node attributeAt: 'operations') using: node]
		ifFalse: [self addAnyOnePermissionTo: permissions fromString: (node attributeAt: 'operations')] 
	].

	^permissions! !

!OrbeonXPathFormReader methodsFor: 'other' stamp: 'BrunoBB 03/16/2016 12:45'!
getTitle

	^(xmlDocument xPath: '//metadata/title')
		ifEmpty: [OrbeonInvalidXMLException signal: 'Title node missing'] 
		ifNotEmpty: [:collection | 
			collection first strings isEmpty 
				ifTrue: [''] 
				ifFalse: [collection first strings last]]! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/16/2016 12:28'!
hasSubSections: xmlElement
	"Answer whether or not <xmlElement> has sub sections"

	^(self formSubSectionsOf: xmlElement) notEmpty! !

!OrbeonXPathFormReader methodsFor: 'attachments' stamp: 'BrunoBB 03/19/2016 14:24'!
isAttachmentField: fieldNode
	"'fr:attachment' - (regular attachments) the attachment can be removed from form instance.
	'fr:image-attachment' - (image attachments) - the attachment can be removed from form instance.
	'fr:wpaint' - (image annotation) - the attachment is an image to make annotations.
	class= 'fb-attachment' - (fixed image attachments) - attachment can NOT be removed from form instance"

	^((fieldNode xPath: 'name()') = 'fr:attachment')
		or:[((fieldNode xPath: 'name()') = 'fr:image-attachment')
			or:[((fieldNode xPath: 'name()') = 'fr:wpaint')
				or: [(fieldNode xPath: 'element[contains(@class, ''fb-attachment'')]') notEmpty]]]! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 14:16'!
searchFormFieldsIn: xmlSection
	"The receiver answer a collection with the field definitions in Form Section <xmlSection> that are field search"

	^(xmlSection xPath: './/fr:grid/xh:tr/xh:td/*[contains(@class,''fr-search'')]') asOrderedCollection.! !

!OrbeonXPathFormReader methodsFor: 'orbeon sections' stamp: 'BrunoBB 03/17/2016 14:17'!
summaryFormFieldsIn: xmlSection
	"The receiver get the fields of Orbeon Form Definition <xmlDefinition>, components inside -repeat element- are NOT listed "
	
	^(xmlSection xPath: './/fr:grid/xh:tr/xh:td/*[contains(@class,''fr-summary'')]') asOrderedCollection.! !

Object subclass: #OrbeonHandler
	instanceVariableNames: 'mySqlReader formReader instanceDefinitions synchronizations orbeonIP'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonHandler class methodsFor: 'other' stamp: 'BrunoBB 10/31/2014 16:27'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 08:58'!
configuration

	^self getOrbeonDatabaseConfiguration default! !

!OrbeonHandler methodsFor: 'mysql' stamp: 'BrunoBB 10/31/2014 16:27'!
defaultMySqlClass

	^Orbeon46MySQL

	"^OrbeonMySQLReader"! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 02/04/2016 12:42'!
execute: aString
	"Execute the command <aString> in the Linux Server whereas GemStone/S is installed"
	| result strippedResult |

	result := System performOnServer: aString.

	(result includesSubString: 'Warning: Using a password on the command line interface can be insecure.')
	ifFalse: [^result].

	strippedResult := result allButFirst: 72. "we remove this trash string of the new mysql client (5.5)"

	^strippedResult! !

!OrbeonHandler methodsFor: 'attachments' stamp: 'BrunoBB 10/16/2015 19:37'!
fileoutDefinitionAttachmentOn: path defintionId: definitionId fileId: fileId version: version
	| result |

	result := self execute: (mySqlReader sqlDumpFileDefinitionAttachmentOn: path definitionId: definitionId fileId: fileId version: version).

	^result! !

!OrbeonHandler methodsFor: 'attachments' stamp: 'BrunoBB 10/16/2015 20:21'!
fileoutInstanceAttachmentOn: path defintionId: definitionId fileId: fileId version: version
	| result |

	result := self execute: (mySqlReader sqlDumpFileInstanceAttachmentOn: path definitionId: definitionId fileId: fileId version: version).

	^result! !

!OrbeonHandler methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2013 08:39'!
formReader

   "Return the value of the instance variable 'formReader'."
   ^formReader! !

!OrbeonHandler methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2013 08:39'!
formReader: newValue

   "Modify the value of the instance variable 'formReader'."
   formReader := newValue! !

!OrbeonHandler methodsFor: 'mapping' stamp: 'BrunoBB 10/16/2015 12:24'!
generateFormDefinition: formName app: appName from: dbArray
	"Create a new definition of the Form based on <dbArray>"
	| version formDefinition |

	version := Integer fromString: (dbArray at: 7).

	formDefinition := OrbeonFormDefinition app: appName form: formName.

	^formDefinition updateFrom: dbArray;
		xmlString: ((dbArray at: 8) copyReplaceAll: '\n' with: Character lf); "-\n- is inserted by Bash "
		yourself! !

!OrbeonHandler methodsFor: 'mapping' stamp: 'BrunoBB 10/16/2015 12:25'!
generateFormInstanceDefinition: formName app: appName from: aDBString
	"Create a new instance of the Form based on <dbArray>"
	| instance resultArray |

	resultArray := aDBString subStrings: String tab.
	instance := OrbeonFormInstanceDefinition new.
	^instance app: appName;
		form: formName;
		updateFrom: resultArray;
		xmlString: ((resultArray at: 7) copyReplaceAll: '\n' with: Character lf); "-\n- is inserted by Bash "
		"setApplicationAndFormName;"
		setMetadata;
		yourself.! !

!OrbeonHandler methodsFor: 'mapping' stamp: 'BrunoBB 10/16/2015 12:23'!
generateFormInstanceOf: anOrbeonFormDefinition from: dbArray
	"Create a new instance of the Form based on <dbArray>"
	| formId formInstance |

	formId := dbArray at: 6 ifAbsent: [nil]. "the position <6> has the value of ID in the database, check <Orbeon46MySQL>"
	formInstance := anOrbeonFormDefinition "if the instance already exist we use it if NOT --> create a newone"
		getInstanceWithId: formId 
		ifNone: [OrbeonFormInstance app: anOrbeonFormDefinition app form: anOrbeonFormDefinition form].

	^formInstance
			updateFrom: dbArray;
			xmlString: ((dbArray at: 8) copyReplaceAll: '\n' with: Character lf); "-\n- is inserted by Bash "
			yourself! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 03/29/2015 13:40'!
getAllApplicationDefinitionVersionFromDB

	^(self execute: mySqlReader sqlGetAllApplicationWithDefinitionVersions) subStrings: String lf! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 12/20/2013 08:39'!
getAllApplicationsName
	"Answer a collection of string with all application name's of Orbeon Application"

	^self execute: mySqlReader sqlGetAllApplications! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 12/24/2013 12:59'!
getAllDefinitionsInEdition
	"Answer a collection of FormDefinitions that are in edition state"

	^OrbeonFormDefinition cache select: [:e | e isInEdition]! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 10/14/2015 14:23'!
getAllDocumentIdsForDefinition: anOrbeonFormDefinition

	"^self execute: (mySqlReader sqlGetAllDocumentIdsFrom: anOrbeonFormDefinition form of: anOrbeonFormDefinition app)"

	^self execute: (mySqlReader sqlGetAllDocumentIdsFrom: anOrbeonFormDefinition form of: anOrbeonFormDefinition app version: anOrbeonFormDefinition version)! !

!OrbeonHandler methodsFor: 'mysql to gs' stamp: 'BrunoBB 03/10/2014 07:06'!
getAllEditionVersion
	"Get all OrbeonDefinitionForm's that are stored in orbeon_data table but are OrbeonDefinitions.
	When a XForms is being edited inside Orbeon Builder and then saved. A row is added to orbeon_data.
	Only when the form is published an entry to orbeon_definition is added.
	Answer OrbeonDefinitions that are being edited but not published yet (from orbeon_data)"
	| instancesString dbString instDef |

	instDef := OrderedCollection new.
	instancesString := self execute: mySqlReader sqlGetAllInstanceDefinitions.
	instancesString isEmpty ifTrue: [^instanceDefinitions].
	dbString := instancesString subStrings: String lf.
	dbString do: [:eachDbLine |
			instDef add: (self generateFormInstanceDefinition: 'builder' app: 'orbeon' from: eachDbLine).].
	
	"instanceDefinitions do: [:each | each addToCache]."

	^instDef! !

!OrbeonHandler methodsFor: 'mysql to gs' stamp: 'BrunoBB 01/21/2014 05:45'!
getAllFormsDefinitionNameOf: appName
	"Answer a collection of <String> with all forms definition of Orbeon Application <appName> stored in MySQL"

	^self execute: (mySqlReader sqlGetAllFormsDefinitionOf: appName)! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 02/08/2016 12:29'!
getAllOrbeonApplications
	"Answer a collection of string with all application name's of Orbeon Application"
	| dbApplicationsNames |

	dbApplicationsNames := (self getAllApplicationsName subStrings: String lf) "a collection of strings with App names"
												reject: [:each | self getOrbeonApplicationClass hasApplicationNamed: each]. "we filter existing app"

	^(dbApplicationsNames collect: [:eachName | self getOrbeonApplicationClass newNamed: eachName]) "we create a new app for each new row"
					asSortedCollection: [:a :b | a applicationName <= b applicationName]! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 15:01'!
getAllVersionsNumberOf: formName in: app
	"Answer a collection with all version number of form definition named <formName> in application named <app>"

	^((self execute: (mySqlReader selectAllVersionOf: formName in: app)) subStrings: String lf) collect: [:each | Number fromString: each]! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 04/01/2015 08:01'!
getApplicationDefinitionVersionOf: appName

	^(self execute: (mySqlReader sqlGetAllDefinitionVersionsOf: appName)) subStrings: String lf! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 12:34'!
getDBStringForInstanceDefinitionWithId: id

	^self execute: (mySqlReader sqlGetInstanceDefinitionWithId: id)! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 11:24'!
getDBStringForInstanceDefinitionWithId: id version: version

	^self execute: (mySqlReader sqlGetInstanceDefinitionWithId: id version: version)! !

!OrbeonHandler methodsFor: 'attachments' stamp: 'BrunoBB 10/14/2015 17:26'!
getDefinitionAttachmentContentFor: fileId version: version

	^self execute: (mySqlReader sqlGetDefinitionAttachmentContentFor: fileId version: version)! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 11/19/2014 03:27'!
getFormWithId: documentId
	"Answer the last stored version of the form with id <documentId>"

	^self execute: (mySqlReader sqlGetFormWithId: documentId)! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 01/27/2014 09:55'!
getIdForDefinition: anOrbeonFormDefinition
	"falta ver que pasa si trae mas de un registro.
	Habria que procesar el XML y ver cual registro de la DB machea con <anOrbeonFormDefinition>"
	| sqlResult |

	sqlResult := self execute: (mySqlReader sqlGetInstanceDefinitionTimeStamp: anOrbeonFormDefinition modifiedTime).

	sqlResult isEmpty ifTrue: [^nil]. 

	^(sqlResult subStrings: String tab) second! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 04/01/2015 08:07'!
getLastUpdateOf: formName in: appName version: version
	"Answer the last update time for form named <formNamed> in Orbeon applicaiton <appName> in MySql database"
	| sqlResult |

	sqlResult := self execute: (mySqlReader sqlFormDefinitionLastUpdateFor: appName form: formName version: version).
	
	sqlResult isEmpty ifTrue:[^OrbeonSynchronization old mySqlTimeStamp].

	^(sqlResult subStrings: String lf) first! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 10/31/2014 16:27'!
host

	^mySqlReader host! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 10/14/2015 15:06'!
importDataFromScratchOf: anOrbeonFormDefinition
	"The receiver import into Orbeon Application <anOrbeonApplication> a form named <formDefinitionName>.
	This method has NO SENDERS is intented to use manually (programmatically) to import a Form Definition and Instances from the Scratch.
	Optimized for definitions with a lof of form instances."
	| ids gsObjects |

	ids := self getAllDocumentIdsForDefinition: anOrbeonFormDefinition. "answer aString (filter by anOrbeonFormDefinition version)"

	gsObjects := (ids subStrings: String lf) collect: [:eachId | | sqlResult dbArray | 
			sqlResult := self getFormWithId: eachId.
			dbArray := sqlResult subStrings: String tab.
			self generateFormInstanceOf: anOrbeonFormDefinition from: dbArray.].

	gsObjects do: [:each | 
		each definition: anOrbeonFormDefinition;
			addToDefinition;
			processXML "process the XML and map it to a GsObject"].

	^gsObjects! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 07/09/2015 12:50'!
importDataOf: anOrbeonFormDefinition version: version
	"The receiver import into Orbeon Application <anOrbeonApplication> a form named <formDefinitionName>"
	| dbInstance gsObjects |

	dbInstance := self execute: (mySqlReader sqlGetAllFormsData: anOrbeonFormDefinition form version: version of: anOrbeonFormDefinition app after: OrbeonSynchronization old mySqlTimeStamp).

	gsObjects := (dbInstance subStrings: String lf) collect: [:eachDBLine | | dbArray |
			dbArray := eachDBLine subStrings: String tab.
			self generateFormInstanceOf: anOrbeonFormDefinition from: dbArray.].

	gsObjects do: [:each | 
		each 
			definition: anOrbeonFormDefinition;
			addToDefinition;
			processXML "process the XML and map it to a GsObject"].

	^gsObjects! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 02/08/2016 11:16'!
importDataOfFormId: formId form: formName app: app
	"The receiver import into Orbeon Application <anOrbeonApplication> a form named <formDefinitionName> with id <formId>"
	| dbInstanceArray definition |

	dbInstanceArray := (self execute: (mySqlReader sqlFormDataWithId: formId)) subStrings: String tab.
	definition := self getOrbeonApplicationClass formDefinitionNamed: formName in: app.

	definition ifNil:[^OrbeonDefinitionNotFoundException signal: 'Definition named [', formName, '] for app [', app, '] not found'].

	^(self generateFormInstanceOf: definition from: dbInstanceArray)
		definition: definition;
		addToDefinition;
		updateFrom: dbInstanceArray; "update common database values - values common to all type of forms"
		processXML; "update specific form values - change for each type of form "
		yourself! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 02/08/2016 11:16'!
importFormDefinitionNamed: formDefinitionName version: version in: appName addToApp: aBoolean
	"The receiver import into Orbeon Application <anOrbeonApplication> a form named <formDefinitionName>"
	| dbDefnition gsDefinition dbArray application mySqlString |

	mySqlString := mySqlReader sqlGetFormDefinition: formDefinitionName version: version of: appName after: OrbeonSynchronization old mySqlTimeStamp.

	dbDefnition := self execute: mySqlString.
	dbArray := dbDefnition subStrings: String tab.
	gsDefinition := self generateFormDefinition: formDefinitionName app: appName from: dbArray. "generate object from <dbArray>"
	gsDefinition id: (self getIdForDefinition: gsDefinition). "get the db id from the form definition"

	gsDefinition processXMLDefinition. "set the OrbeonFormDefinition with it's values -xml-"

	aBoolean ifTrue: [application := self getOrbeonApplicationClass applicationNamed: appName.
							application addPublishedDefinition: gsDefinition].

	^gsDefinition! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 04/02/2015 14:39'!
importNewApplications
	"The receiver perform the first and initial synchronization with the Orbeon Mysql database.
	Get all applications and synchronize all forms of each application"
	| formsToMigrate newInstances |

	"get all -triplet- (app, form, version) from Orbeon DataBase"
	formsToMigrate := self getAllApplicationDefinitionVersionFromDB.
	newInstances := OrderedCollection new.
	formsToMigrate do: [:eachAppFormVersion | | resultArray app form version |
		resultArray := eachAppFormVersion subStrings: String tab.
		app := resultArray at: 1. "app"
		form := resultArray at: 2. "form"
		version := resultArray at: 3. "version"
		"import and create the OrbeonFormDefinition into OrbeonApplication <application>"
		newInstances addAll: (self importNewDefinitionAndDataOf: form version: version application: app addDefToApp: true excludeExistingApp: true).
	].

	^newInstances! !

!OrbeonHandler methodsFor: 'db import' stamp: 'BrunoBB 07/22/2015 13:25'!
importNewApplicationsButNoData
	"The receiver perform the first and initial synchronization with the Orbeon Mysql database.
	Get all applications and synchronize all forms of each application"
	| formsToMigrate newInstances |

	"get all -triplet- (app, form, version) from Orbeon DataBase"
	formsToMigrate := self getAllApplicationDefinitionVersionFromDB.
	newInstances := OrderedCollection new.
	formsToMigrate do: [:eachAppFormVersion | | resultArray app form version |
		resultArray := eachAppFormVersion subStrings: String tab.
		app := resultArray at: 1. "app"
		form := resultArray at: 2. "form"
		version := resultArray at: 3. "version"
		"import and create the OrbeonFormDefinition into OrbeonApplication <application>"
		newInstances addAll: (self importNewDefinition: form version: version application: app addDefToApp: true excludeExistingApp: true).
	].

	^newInstances! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 02/08/2016 11:17'!
importNewDefinition: form version: version application: appName addDefToApp: addToAppBool excludeExistingApp: excludeBoolean
	"The receiver import new definition and data of OrbeonApplication named <appName> for form definition named <form> with version <version>.
	If <aBoolean> is <true> then exclude existing OrbeonApplication from the process"
	| application |

	(excludeBoolean and: [self getOrbeonApplicationClass hasApplicationNamed: appName]) ifTrue: [^#()].

	application := self getOrbeonApplicationClass 
							applicationNamed: appName 
							ifNone: [(self getOrbeonApplicationClass newNamed: appName) addToCache].
	"create the new OrbeonFormDefinition and add it to the new OrbeonApplication"
	^self importFormDefinitionNamed: form version: version in: appName addToApp: addToAppBool.! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 02/08/2016 11:17'!
importNewDefinitionAndDataOf: form version: version application: appName addDefToApp: addToAppBool excludeExistingApp: excludeBoolean
	"The receiver import new definition and data of OrbeonApplication named <appName> for form definition named <form> with version <version>.
	If <aBoolean> is <true> then exclude existing OrbeonApplication from the process"
	| newDefinition application |

	(excludeBoolean and: [self getOrbeonApplicationClass hasApplicationNamed: appName]) ifTrue: [^#()].

	application := self getOrbeonApplicationClass 
							applicationNamed: appName 
							ifNone: [(self getOrbeonApplicationClass newNamed: appName) addToCache].
	"create the new OrbeonFormDefinition and add it to the new OrbeonApplication"
	newDefinition := self importFormDefinitionNamed: form version: version in: appName addToApp: addToAppBool.

	"importe the new OrbeonFormInstances"
	^self importDataOf: newDefinition version: version.! !

!OrbeonHandler methodsFor: 'other' stamp: 'BrunoBB 03/19/2016 12:08'!
initialize

	super initialize.

	instanceDefinitions := OrderedCollection new.
	synchronizations := Dictionary new.

	mySqlReader := self defaultMySqlClass new.
	formReader := OrbeonXPathFormReader new.! !

!OrbeonHandler methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2013 08:39'!
instanceDefinitions

   "Return the value of the instance variable 'instanceDefinitions'."
   ^instanceDefinitions! !

!OrbeonHandler methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2013 08:39'!
instanceDefinitions: newValue

   "Modify the value of the instance variable 'instanceDefinitions'."
   instanceDefinitions := newValue! !

!OrbeonHandler methodsFor: 'migration script' stamp: 'BrunoBB 04/01/2015 08:30'!
migrateAll
	"Migrate all Definitions and Instances from Orbeon to GemStone/S. This method MUST called only one Time !!!!!!"
	| formsToMigrate |

	"get all -triplet- (app, form, version) from Orbeon DataBase"
	formsToMigrate := self getAllApplicationDefinitionVersionFromDB.

	formsToMigrate do: [:eachAppFormVersion | | resultArray app form version |
		resultArray := eachAppFormVersion subStrings: String tab.
		app := resultArray at: 1. "app"
		form := resultArray at: 2. "form"
		version := resultArray at: 3. "version"
		"import and create the OrbeonFormDefinition into OrbeonApplication <application>"
		self importNewDefinitionAndDataOf: form version: version application: app addDefToApp: true excludeExistingApp: false.
	]! !

!OrbeonHandler methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2013 08:39'!
mySqlReader

   "Return the value of the instance variable 'mySqlReader'."
   ^mySqlReader! !

!OrbeonHandler methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2013 08:39'!
mySqlReader: newValue

   "Modify the value of the instance variable 'mySqlReader'."
   mySqlReader := newValue! !

!OrbeonHandler methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2014 16:28'!
orbeonIP

   "Return the value of the instance variable 'orbeonIP'."
   ^orbeonIP! !

!OrbeonHandler methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2014 16:28'!
orbeonIP: newValue

   "Modify the value of the instance variable 'orbeonIP'."
   orbeonIP := newValue! !

!OrbeonHandler methodsFor: 'mysql' stamp: 'BrunoBB 10/31/2014 17:08'!
setMySQLhost: host user: user password: password

	mySqlReader := self defaultMySqlClass new 
			host: host;
			user: user;
			password: password; 
			yourself.

	^self! !

!OrbeonHandler methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2013 08:39'!
synchronizations

   "Return the value of the instance variable 'synchronizations'."
   ^synchronizations! !

!OrbeonHandler methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2013 08:39'!
synchronizations: newValue

   "Modify the value of the instance variable 'synchronizations'."
   synchronizations := newValue! !

!OrbeonHandler methodsFor: 'update gs objects' stamp: 'BrunoBB 02/08/2016 12:40'!
updateApplication: anOrbeonApplication
	| formsToMigrate instances |

	instances := OrderedCollection new.
	"get all -triplet- (app, form, version) from Orbeon DataBase"
	formsToMigrate := self getApplicationDefinitionVersionOf: anOrbeonApplication applicationName.

	formsToMigrate do: [:eachAppFormVersion | 
		| resultArray app form version currentDefinition newDefinition comparator shouldCreateAnotherVersion dbArray |
		resultArray := eachAppFormVersion subStrings: String tab.
		app := resultArray at: 1. "app"
		form := resultArray at: 2. "form"
		version := resultArray at: 3. "version"
		instances addAll: (self updateFormDefinitionNamed: form app: app version: version).
	].

	^instances! !

!OrbeonHandler methodsFor: 'update gs objects' stamp: 'BrunoBB 02/08/2016 12:41'!
updateApplicationButNotDataOf: anOrbeonApplication
	| formsToMigrate instances |

	instances := OrderedCollection new.
	"get all -triplet- (app, form, version) from Orbeon DataBase"
	formsToMigrate := self getApplicationDefinitionVersionOf: anOrbeonApplication applicationName.

	formsToMigrate do: [:eachAppFormVersion | 
		| resultArray app form version currentDefinition newDefinition comparator shouldCreateAnotherVersion dbArray |
		resultArray := eachAppFormVersion subStrings: String tab.
		app := resultArray at: 1. "app"
		form := resultArray at: 2. "form"
		version := resultArray at: 3. "version"
		instances addAll: (self updateFormDefinitionNamedButNoData: form app: app version: version).
	].

	^instances! !

!OrbeonHandler methodsFor: 'update gs objects' stamp: 'BrunoBB 02/08/2016 11:35'!
updateFormDefinitionNamed: form app: app version: version
	"The receiver update or create the OrbeonFormDefinition named <form> with version <version> in OrbeonApplication named <app>.
	1. Get the current definition named <form>
	2. If NOT exist then it creates a new defnition and store it in OrbeonApplication named <app>
	3. If already exist then compare the current version with the new one and decide whether or not is necesary another definition.
	4. If is necesary then add the new definition to OrbeonApplication named <app>
	5. If NOT necesary then update the existing one"
	| currentDefinition newDefinition comparator shouldCreateAnotherVersion |

	currentDefinition := self getOrbeonApplicationClass getFromApplicationNamed: app definitionNamed: form version: (Integer fromString: version) ifNone: [nil].
	^currentDefinition 
		ifNil: [newDefinition := self importFormDefinitionNamed: form version: version in: app addToApp: true.
			self importDataOf: newDefinition version: version]
		ifNotNil: [newDefinition := self importFormDefinitionNamed: form version: version in: app addToApp: false.
			comparator := FormDefinitionComparator formOne: currentDefinition formTwo: newDefinition.
			shouldCreateAnotherVersion := comparator shouldCreateAnotherVersion.
			shouldCreateAnotherVersion "is a different form"
				ifTrue: [(self getOrbeonApplicationClass applicationNamed: app) addPublishedDefinition: newDefinition.
							self importDataOf: newDefinition version: version] 
				ifFalse: [ | dbDefnition dbArray |
					dbDefnition := self execute: (mySqlReader sqlGetAllFormsDefinition: form of: app version: version after: OrbeonSynchronization old mySqlTimeStamp).
					dbArray := dbDefnition subStrings: String tab.
					currentDefinition updateFrom: dbArray. "the form is almost the same --> we update the existing one"
					currentDefinition processXMLDefinition.
					self importDataOf: currentDefinition version: version].].! !

!OrbeonHandler methodsFor: 'update gs objects' stamp: 'BrunoBB 02/08/2016 11:18'!
updateFormDefinitionNamedButNoData: form app: app version: version
	"The receiver update or create the OrbeonFormDefinition named <form> with version <version> in OrbeonApplication named <app>.
	1. Get the current definition named <form>
	2. If NOT exist then it creates a new defnition and store it in OrbeonApplication named <app>
	3. If already exist then compare the current version with the new one and decide whether or not is necesary another definition.
	4. If is necesary then add the new definition to OrbeonApplication named <app>
	5. If NOT necesary then update the existing one"
	| currentDefinition newDefinition comparator shouldCreateAnotherVersion |

	currentDefinition := self getOrbeonApplicationClass getFromApplicationNamed: app definitionNamed: form version: (Integer fromString: version) ifNone: [nil].
	^currentDefinition 
		ifNil: [newDefinition := self importFormDefinitionNamed: form version: version in: app addToApp: true.
			self importDataOf: newDefinition version: version]
		ifNotNil: [newDefinition := self importFormDefinitionNamed: form version: version in: app addToApp: false.
			comparator := FormDefinitionComparator formOne: currentDefinition formTwo: newDefinition.
			shouldCreateAnotherVersion := comparator shouldCreateAnotherVersion.
			shouldCreateAnotherVersion "is a different form"
				ifTrue: [(self getOrbeonApplicationClass applicationNamed: app) addPublishedDefinition: newDefinition] 
				ifFalse: [ | dbDefnition dbArray |
					dbDefnition := self execute: (mySqlReader sqlGetAllFormsDefinition: form of: app version: version after: OrbeonSynchronization old mySqlTimeStamp).
					dbArray := dbDefnition subStrings: String tab.
					currentDefinition updateFrom: dbArray. "the form is almost the same --> we update the existing one"
					currentDefinition processXMLDefinition.].].! !

Object subclass: #OrbeonManagerRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonManagerRole subclass: #OrbeonManagerAdminRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonManagerAdminRole class methodsFor: 'other' stamp: 'BrunoBB 03/18/2015 16:14'!
roleName

	^'System Administrator'! !

!OrbeonManagerAdminRole methodsFor: 'other' stamp: 'BrunoBB 12/23/2013 06:25'!
isAdmin

	^true! !

!OrbeonManagerRole class methodsFor: 'other' stamp: 'BrunoBB 02/16/2014 13:18'!
allManagerRolNames

	^self subclasses collect: [:each | each roleName]! !

!OrbeonManagerRole class methodsFor: 'other' stamp: 'BrunoBB 02/16/2014 13:29'!
getClassForName: aString

	^self subclasses detect: [:each | each roleName = aString] ifNone: [OrbeonManagerUserRole]! !

!OrbeonManagerRole class methodsFor: 'other' stamp: 'BrunoBB 02/16/2014 13:16'!
roleName

	^self subclassResponsibility! !

!OrbeonManagerRole methodsFor: 'other' stamp: 'BrunoBB 12/23/2013 06:25'!
isAdmin

	^false! !

!OrbeonManagerRole methodsFor: 'other' stamp: 'BrunoBB 02/16/2014 13:21'!
roleName

	^self class roleName! !

OrbeonManagerRole subclass: #OrbeonManagerUserRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonManagerUserRole class methodsFor: 'other' stamp: 'BrunoBB 03/18/2015 16:14'!
roleName

	^'Application Administrator'! !

Object subclass: #OrbeonObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonObject subclass: #FormDefintionRegistry
	instanceVariableNames: 'orbeonApplication currentVersions oldVersions savedDefinitions'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Orbeon'!

!FormDefintionRegistry commentStamp: '' prior: 0!
This class holds all versions of a particular Form Definition <OrboenFormDefinition>.

Each OrbeonApplication has a dictionary where the key is a <form-name> and the value is an instance of this class.

orbeonApplication 	- owner of the receiver
currentVersions 		- anOrderedCollection with current versions (in this collection can be only one definition with number 1,2,3,...)
oldVersions				- anOrderedCollection with old versions (this collection can have more than one definition with number X)
									can have multiple definition of version 4 for example.
savedDefinitions		- anOrderedCollection of <OrbeonFormInstanceDefinition>. Definitions saved before been published.

If in Orbeon a Definition is update without changing the version and has structure change --> we generate another definition that will hold the new instances. This new definition goes to <currentVersions> and the old one is moved to <oldVersions>.!

!FormDefintionRegistry class methodsFor: 'other' stamp: 'BrunoBB 08/26/2015 16:27'!
newFor: anOrbeonApplication

	^super new initialize
		orbeonApplication: anOrbeonApplication;
		yourself! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 10/08/2015 13:44'!
addCurrentVersion: newFormDefinition
	"The receiver set <newFormDefinition> as the current version. 
	First check if a definition with the same version exist. If not <newFormDefinition> is added to <currentVersions>.
	If exist then move the current version to <oldVersion> collection and set <newFormDefinition> as the current version in <currentVersions> collection"
	| oldVersion |

	oldVersion := self getDefinitionWithSameVersionAs: newFormDefinition.
	"there is no registered definition with the same version as <newFormDefinition>"
	oldVersion ifNil: [^currentVersions add: newFormDefinition]. 

	"the current version is removed from <currentVersions> and repleced with <newFormDefinition>"
	currentVersions remove: oldVersion. 
	oldVersions add: oldVersion. 
	^currentVersions add: newFormDefinition! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 10/08/2015 15:35'!
addSavedDefinition: anOrbeonFormInstanceDefinition
	"The receiver add the saved definition (not published yet) <anOrbeonFormInstanceDefinition>.
	If there is a previous -instance definition- then remove it and add the new one <anOrbeonFormInstanceDefinition>"
	| savedCollection oldSavedVersion |

	savedCollection := savedDefinitions at: anOrbeonFormInstanceDefinition id ifAbsentPut: [OrderedCollection new].

	oldSavedVersion := savedCollection detect: [:each | each version = anOrbeonFormInstanceDefinition version] 
														ifNone: [^savedCollection add: anOrbeonFormInstanceDefinition].

	savedCollection remove: oldSavedVersion ifAbsent: [].

	^savedCollection add: anOrbeonFormInstanceDefinition! !

!FormDefintionRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 16:27'!
currentVersions

   "Return the value of the instance variable 'currentVersions'."
   ^currentVersions! !

!FormDefintionRegistry methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 16:27'!
currentVersions: newValue

   "Modify the value of the instance variable 'currentVersions'."
   currentVersions := newValue! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/06/2015 13:25'!
getAllInstances
	""
	| all |

	all := OrderedCollection new.

	self getAllVersion do: [:each | all addAll: each instances asArray].

	^all! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/30/2015 16:20'!
getAllInstancesKeys
	"The receiver answer all keys of all form instances"
	| allKeys |

	allKeys := OrderedCollection new.
	(currentVersions, oldVersions) do: [:each | allKeys addAll: each instances keys].

	^allKeys! !

!FormDefintionRegistry methodsFor: 'published def instances' stamp: 'BrunoBB 08/26/2015 16:27'!
getAllInstancesOf: version
	| currentInstances oldInstances |

	currentInstances := (self getDefinitionWithVersion: version) ifNil: [#()] ifNotNil: [:def | def instances].
	oldInstances := (self getOldDefinitionWithVersion: version) ifNil: [#()] ifNotNil: [:def | def instances].

	^currentInstances asArray, oldInstances asArray! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 10/08/2015 18:45'!
getAllSearchFields
	"The receiver answer a collection with all search fields of all versions"
	| searchFields |

	searchFields := Set new.

	self getAllVersion do: [:each | searchFields addAll: each searchFields].

	^searchFields! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getAllVersion
	"Answer anArray with all OrbeonFormDefinition that the receiver holds (old + current) "

	^(oldVersions, currentVersions) asArray! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/30/2015 16:47'!
getAnyDraftWithId: stringId ifNone: aBlock
	"The receiver answer anOrbeonFormInstance with id <stringId> if none evaluates the block <aBlock>"

	(currentVersions, oldVersions) do: [:each | (each getDraftWithId: stringId) ifNotNil: [:value | ^value]].

	^aBlock value! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/30/2015 15:42'!
getAnyInstanceWithId: stringId ifNone: aBlock
	"The receiver answer anOrbeonFormInstance with id <stringId> if none evaluates the block <aBlock>"

	(currentVersions, oldVersions) do: [:each | (each getInstanceWithId: stringId) ifNotNil: [:value | ^value]].

	^aBlock value! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getCurrentVersionNumbers
	"Answer a collection with current version number (of each OrbeonFormDefinition)"

	^currentVersions collect: [:each | each version]! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/30/2015 13:46'!
getDefinitionVersion: versionNumber
	"Answer the last published version of the receiver <anOrbeonFormDefinition>"

	^self getDefinitionVersion: versionNumber ifNone: [nil]! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/30/2015 13:45'!
getDefinitionVersion: versionNumber ifNone: aBlock
	"Answer the last published version of the receiver <anOrbeonFormDefinition>"

	currentVersions isEmpty ifTrue: [^aBlock valu3].

	^currentVersions detect: [:each | each version = versionNumber] ifNone: aBlock! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 09/01/2015 17:21'!
getDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer <anOrbeonFormInstanceDefinition> with id <stringId> if none evaluate the block <aBlock>"

	^currentVersions detect: [:eachDef | eachDef id = stringId] ifNone: aBlock! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getDefinitionWithSameVersionAs: aFormDefinition
	"The receiver answer anOrbeonFormDefinition with the same version as <aFormDefinition>, checking the <currentVersions> collection"

	^self getDefinitionWithVersion: aFormDefinition version! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getDefinitionWithVersion: version
	"The receiver answer anOrbeonFormDefinition with the same version as <aFormDefinition>, checking the <currentVersions> collection"

	^currentVersions detect: [:each | each version = version] ifNone: [nil]! !

!FormDefintionRegistry methodsFor: 'published def instances' stamp: 'BrunoBB 08/26/2015 16:27'!
getInstancesOfAllVersions
	| instances |

	instances := OrderedCollection new.

	currentVersions do: [:each | instances addAll: each instances].
	oldVersions do: [:each | instances addAll: each instances].

	^instances! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 10/15/2015 12:30'!
getLastSavedDefinition
	"The receiver answer the last saved definition <anOrbeonFormInstanceDefinition>"

	^savedDefinitions isEmpty
		ifFalse: [savedDefinitions values last isEmpty "answer anOrderedCollection with all saved definitions"
					ifFalse: [savedDefinitions values last last] "the last element of the last OrderedCollection"
					ifTrue: [NoOrbeonFormException signal: 'There is no last saved definition']]	
		ifTrue: [NoOrbeonFormException signal: 'There is no last saved definition']! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/30/2015 15:45'!
getLastVersion
	"Answer the last published version of the receiver <anOrbeonFormDefinition>"

	currentVersions isEmpty ifTrue: [^nil].

	^currentVersions last! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/30/2015 15:44'!
getLastVersionNumber
	"Answer the version of the last published definition of the receiver"

	^self getLastVersion 
		ifNotNil: [:lastDef | lastDef version]
		ifNil: [0]! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getOldDefinitionWithVersion: version
	"The receiver answer anOrbeonFormDefinition with the same version as <aFormDefinition>, checking the <oldVersions> collection"

	^oldVersions detect: [:each | each version = version] ifNone: [nil]! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
getOldVersionNumbers

	^oldVersions collect: [:each | each version]! !

!FormDefintionRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 17:32'!
getSavedDefinitions

	^(savedDefinitions collect: [:each | each last]) asOrderedCollection! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 09/30/2015 12:02'!
getSavedDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer <anOrbeonFormInstanceDefinition> with id <stringId> if none evaluate the block <aBlock>"
	| savedCollection |

	savedCollection := savedDefinitions at: stringId ifAbsent: [^aBlock value].

	^savedCollection isEmpty
		ifFalse: [savedCollection last] "the last element of the saved collection"
		ifTrue: aBlock! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
hasVersions

	^currentVersions notEmpty! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 09/30/2015 12:03'!
includesSavedDefinitionWithId: stringId
	"Answer wheter or not the receiver includes a save definition with id <stringId>"
	| savedCollection |

	savedCollection := savedDefinitions at: stringId ifAbsent: [^false].

	^savedCollection notEmpty! !

!FormDefintionRegistry methodsFor: 'other' stamp: 'BrunoBB 08/30/2015 16:11'!
initialize

	super initialize.

	currentVersions := OrderedCollection new.
	oldVersions := OrderedCollection new.
	savedDefinitions := OrderPreservingDictionary new.! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 09/30/2015 13:22'!
migrateSaveDefinitions
	"Migrate the old structure to new one (30/09/2015)"
	| oldDefnitions |

	oldDefnitions := savedDefinitions asOrderedCollection.

	savedDefinitions := OrderPreservingDictionary new.

	oldDefnitions do: [:each | self addSavedDefinition: each]! !

!FormDefintionRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 16:27'!
oldVersions

   "Return the value of the instance variable 'oldVersions'."
   ^oldVersions! !

!FormDefintionRegistry methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 16:27'!
oldVersions: newValue

   "Modify the value of the instance variable 'oldVersions'."
   oldVersions := newValue! !

!FormDefintionRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 16:27'!
orbeonApplication

   "Return the value of the instance variable 'orbeonApplication'."
   ^orbeonApplication! !

!FormDefintionRegistry methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 16:27'!
orbeonApplication: newValue

   "Modify the value of the instance variable 'orbeonApplication'."
   orbeonApplication := newValue! !

!FormDefintionRegistry methodsFor: 'other' stamp: 'BrunoBB 08/26/2015 16:27'!
printAllVersionNumbers
	| printStream |

	printStream := PrintStream on: String new.

	printStream nextPutAll: 'Current: ', String lf.

	self getCurrentVersionNumbers do: [:each | printStream nextPutAll: each printString , ' , '].

	printStream nextPutAll: String lf, 'Old: ', String lf.

	self getOldVersionNumbers do: [:each | printStream nextPutAll: each printString, ' , '].

	^printStream contents! !

!FormDefintionRegistry methodsFor: 'published definition' stamp: 'BrunoBB 08/26/2015 16:27'!
removeDefinition: anOrbeonFormDefinition

	currentVersions remove: anOrbeonFormDefinition ifAbsent: [].

	oldVersions remove: anOrbeonFormDefinition ifAbsent: [].! !

!FormDefintionRegistry methodsFor: 'saved definitions' stamp: 'BrunoBB 09/30/2015 05:58'!
removeInstanceDefinition: anOrbeonFormInstanceDefinition
	| savedCollection |

	savedCollection := savedDefinitions at: anOrbeonFormInstanceDefinition id ifAbsent: [^anOrbeonFormInstanceDefinition].

	^savedCollection remove: anOrbeonFormInstanceDefinition ifAbsent: []! !

!FormDefintionRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 16:27'!
savedDefinitions
	^savedDefinitions! !

!FormDefintionRegistry methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 16:27'!
savedDefinitions: newValue
	savedDefinitions := newValue! !

OrbeonObject subclass: #FormFieldDefinition
	instanceVariableNames: 'name isSummary isSearch label type definition sectionName repeatName isAttachmentField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 06:56'!
name: aString

	^super new initialize
		name: aString;
		yourself! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
definition

   "Return the value of the instance variable 'definition'."
   ^definition! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
definition: newValue

   "Modify the value of the instance variable 'definition'."
   definition := newValue! !

!FormFieldDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 06:56'!
initialize

	super initialize.

	name := ''.
	isSummary := false.
	isSearch := false.
	label := ''.
	type := ''.
	isAttachmentField := false.! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
isAttachmentField
	^isAttachmentField! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
isAttachmentField: newValue
	isAttachmentField := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
isSearch

   "Return the value of the instance variable 'isSearch'."
   ^isSearch! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
isSearch: newValue

   "Modify the value of the instance variable 'isSearch'."
   isSearch := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
isSummary

   "Return the value of the instance variable 'isSummary'."
   ^isSummary! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
isSummary: newValue

   "Modify the value of the instance variable 'isSummary'."
   isSummary := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
label

   "Return the value of the instance variable 'label'."
   ^label! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormFieldDefinition methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:37'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
repeatName

   "Return the value of the instance variable 'repeatName'."
   ^repeatName! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
repeatName: newValue

   "Modify the value of the instance variable 'repeatName'."
   repeatName := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
sectionName

   "Return the value of the instance variable 'sectionName'."
   ^sectionName! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
sectionName: newValue

   "Modify the value of the instance variable 'sectionName'."
   sectionName := newValue! !

!FormFieldDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 06:56'!
type

   "Return the value of the instance variable 'type'."
   ^type! !

!FormFieldDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 06:56'!
type: newValue

   "Modify the value of the instance variable 'type'."
   type := newValue! !

OrbeonObject subclass: #FormFieldValue
	instanceVariableNames: 'name value originalValue form errorString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

FormFieldValue subclass: #FormFieldBooelanValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldBooelanValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:00'!
stType

	^Boolean! !

!FormFieldBooelanValue methodsFor: 'Updating' stamp: 'BrunoBB 02/13/2014 04:36'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	[value := Boolean fromString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!FormFieldBooelanValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:50'!
typeName

	^'boolean'! !

FormFieldValue subclass: #FormFieldDateValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldDateValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:00'!
stType

	^Date! !

!FormFieldDateValue methodsFor: 'other' stamp: 'BrunoBB 02/13/2014 04:35'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	[value := Date fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!FormFieldDateValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:50'!
typeName

	^'date'! !

FormFieldValue subclass: #FormFieldNumberValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldNumberValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:00'!
stType

	^Number! !

!FormFieldNumberValue methodsFor: 'Updating' stamp: 'BrunoBB 02/13/2014 04:36'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	[value := Number readFrom: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!FormFieldNumberValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:50'!
typeName

	^'number'! !

FormFieldValue subclass: #FormFieldStringValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldStringValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:00'!
stType

	^String! !

!FormFieldStringValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 09:16'!
setValue: newValue

   "Modify the value of the instance variable 'value'."
   value := newValue! !

!FormFieldStringValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:50'!
typeName

	^'string'! !

FormFieldValue subclass: #FormFieldTimeStampValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldTimeStampValue class methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:04'!
stType

	^TimeStamp! !

!FormFieldTimeStampValue methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:04'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	[value := TimeStamp fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!FormFieldTimeStampValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 07:21'!
typeName

	^'timestamp'! !

FormFieldValue subclass: #FormFieldTimeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormFieldTimeValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 13:59'!
stType

	^Time! !

!FormFieldTimeValue methodsFor: 'Updating' stamp: 'BrunoBB 02/13/2014 04:36'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	[value := Time fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!FormFieldTimeValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:50'!
typeName

	^'time'! !

!FormFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/12/2014 08:40'!
form: anOrbeonFormInstance

	^super new initialize
		form: anOrbeonFormInstance;
		yourself! !

!FormFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/12/2014 08:40'!
form: anOrbeonFormInstance name: stringName value: stringValue

	^self form: anOrbeonFormInstance name: stringName value: stringValue originalValue: stringValue! !

!FormFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/12/2014 09:13'!
form: anOrbeonFormInstance name: stringName value: stringValue originalValue: originalValue

	^super new initialize
		form: anOrbeonFormInstance;
		name: stringName;
		setValue: stringValue;
		originalValue: originalValue;
		yourself! !

!FormFieldValue class methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:01'!
stType

	^self subclassResponsibility! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:43'!
errorString

   "Return the value of the instance variable 'errorString'."
   ^errorString! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 08:43'!
errorString: newValue

   "Modify the value of the instance variable 'errorString'."
   errorString := newValue! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:40'!
form

   "Return the value of the instance variable 'form'."
   ^form! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 08:40'!
form: newValue

   "Modify the value of the instance variable 'form'."
   form := newValue! !

!FormFieldValue methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 13:02'!
getAssignment

	^form assignment! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:40'!
initialize

	super initialize.

	name := ''.

"name - name of the field.
value - value of the field.
originalValue - original value of the field. 

If a field change it's type (from integer to string for example) and the new type differ from the original then all new values it will be set with -nil- in #value and the actual value (changed in type) it will be stored in #originalValue. 
This is because of the usage of index. It is much better to rename the field instead of change it's type without changing it's name.
"! !

!FormFieldValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:53'!
instanceId

	^form id! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:40'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 08:40'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:40'!
originalValue

   "Return the value of the instance variable 'originalValue'."
   ^originalValue! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 08:40'!
originalValue: newValue

   "Modify the value of the instance variable 'originalValue'."
   originalValue := newValue! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 09:16'!
setValue: newValue

	self subclassResponsibility! !

!FormFieldValue methodsFor: 'other' stamp: 'BrunoBB 07/30/2015 14:01'!
stType

	^self class stType! !

!FormFieldValue methodsFor: 'other' stamp: 'BrunoBB 05/02/2014 06:49'!
typeName

	^self subclassResponsibility! !

!FormFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/12/2014 08:40'!
value

   "Return the value of the instance variable 'value'."
   ^value! !

!FormFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/12/2014 08:40'!
value: newValue

   "Modify the value of the instance variable 'value'."
   value := newValue! !

OrbeonObject subclass: #FormGridDefinition
	instanceVariableNames: 'name sectionDefinition fieldDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormGridDefinition commentStamp: '' prior: 0!
This class represent the GRIDs definition in Orbeon Forms. GRID's fields are repeatable.

name 					- name of the grid definition
sectionDefinition 	- section where the receiver belongs.
fieldDefinitions		- field definitions inside the grid!

!FormGridDefinition class methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:57'!
name: aString

	^super new initialize
		name: aString;
		yourself! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:54'!
addFieldDefinition: aFormFieldDefinition

	^fieldDefinitions at: aFormFieldDefinition name put: aFormFieldDefinition! !

!FormGridDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:10'!
fieldDefinitions

   "Return the value of the instance variable 'fieldDefinitions'."
   ^fieldDefinitions! !

!FormGridDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:10'!
fieldDefinitions: newValue

   "Modify the value of the instance variable 'fieldDefinitions'."
   fieldDefinitions := newValue! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:54'!
includesFieldDefinition: aFormFieldDefinition

	^fieldDefinitions includes: aFormFieldDefinition! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:55'!
initialize

	super initialize.

	name := ''.
	fieldDefinitions := Dictionary new.! !

!FormGridDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:10'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormGridDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:10'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 03:41'!
printStructureOn: aPrintStream count: counter
	"Print the structure of the receiver on stream <aPrintStream>. It use a counter <counter> to ident the resulting stream.
	Print Field Definitions of the receiver."

	1 to: (counter + 1) do: [:each | aPrintStream nextPutAll: String tab].
	aPrintStream nextPutAll: '(', name, ')'.
	aPrintStream nextPutAll: String lf.

	fieldDefinitions do: [:each | 
		1 to: (counter + 2) do: [:each | aPrintStream nextPutAll: String tab].
		aPrintStream nextPutAll: each name.
		aPrintStream nextPutAll: ', ', each type.
		aPrintStream nextPutAll: String lf.].! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:54'!
removeFieldDefinition: aFormFieldDefinition

	^fieldDefinitions removeKey: aFormFieldDefinition name ifAbsent: []! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:55'!
searchFields

	^fieldDefinitions select: [:each | each isSearch]! !

!FormGridDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:10'!
sectionDefinition

   "Return the value of the instance variable 'sectionDefinition'."
   ^sectionDefinition! !

!FormGridDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:10'!
sectionDefinition: newValue

   "Modify the value of the instance variable 'sectionDefinition'."
   sectionDefinition := newValue! !

!FormGridDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:55'!
summaryFields

	^fieldDefinitions select: [:each | each isSummary]! !

OrbeonObject subclass: #FormGridInstance
	instanceVariableNames: 'name section gridDefinition gridIterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormGridInstance commentStamp: '' prior: 0!
This class represent the GRIDs instances in Orbeon Forms. GRID's fields are repeatable.

name 				- name of the grid
section 			- section where the receiver belongs
gridDefinition	- definition of the receiver
gridIterations	- iterations of the grid.

Grid Iterations is a collection of Dictionary, where each Dictionary represent an iteration.

Dictionary's keys are the fieldsName and the each value is an instance of FormFieldValue.!

!FormGridInstance class methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 17:57'!
name: aString

	^super new initialize
		name: aString;
		yourself! !

!FormGridInstance class methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:38'!
name: aString definition: aFormGridDefinition 

	^super new initialize
		name: aString;
		gridDefinition: aFormGridDefinition;
		yourself! !

!FormGridInstance methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 06:46'!
addIteration: aDictionary

	^gridIterations add: aDictionary! !

!FormGridInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:15'!
gridDefinition

   "Return the value of the instance variable 'gridDefinition'."
   ^gridDefinition! !

!FormGridInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:15'!
gridDefinition: newValue

   "Modify the value of the instance variable 'gridDefinition'."
   gridDefinition := newValue! !

!FormGridInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:13'!
gridIterations

   "Return the value of the instance variable 'gridIterations'."
   ^gridIterations! !

!FormGridInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:13'!
gridIterations: newValue

   "Modify the value of the instance variable 'gridIterations'."
   gridIterations := newValue! !

!FormGridInstance methodsFor: 'other' stamp: 'BrunoBB 02/22/2015 11:57'!
initialize

	super initialize.

	name := ''.
	gridIterations := OrderedCollection new. "a collection of Dictionaries. Each dictionary is am iteration"! !

!FormGridInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:13'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormGridInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:13'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormGridInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 03:50'!
printStructureOn: aPrintStream count: counter
	"Print the structure of the receiver on stream <aPrintStream>. It use the counter <counter> to iden the resulting string.
	1- Iterate over each grid iterations (aDictionary) and print each of them."

	| iterationIndex |

	1 to: (counter + 1) do: [:each | aPrintStream nextPutAll: String tab].
	aPrintStream nextPutAll: '(', name, ')'.
	aPrintStream nextPutAll: String lf.

	iterationIndex := 0.
	gridIterations do: [:eachIterationDict | "iterate over grid iteration"
		iterationIndex := iterationIndex + 1.
		1 to: (counter + 2) do: [:each | aPrintStream nextPutAll: String tab].
		aPrintStream nextPutAll: '(iteration-', iterationIndex printString, ')'. "put the number of the current iteration"
		aPrintStream nextPutAll: String lf.
		eachIterationDict keysAndValuesDo: [:key :value | "print the fields values of each iteration"
			1 to: (counter + 3) do: [:each | aPrintStream nextPutAll: String tab].
			aPrintStream nextPutAll: key, ': ', value.
			aPrintStream nextPutAll: String lf.].
		].! !

!FormGridInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 11:15'!
section

   "Return the value of the instance variable 'section'."
   ^section! !

!FormGridInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 11:15'!
section: newValue

   "Modify the value of the instance variable 'section'."
   section := newValue! !

!FormGridInstance methodsFor: 'other' stamp: 'BrunoBB 02/28/2015 09:44'!
sectionName

	section ifNil: [^''].

	^section name! !

OrbeonObject subclass: #FormSectionDefinition
	instanceVariableNames: 'name label fieldDefinitions gridDefinitions isRepeatable formDefinition parentSection subSections iterationName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormSectionDefinition commentStamp: 'BrunoBB 08/06/2014 11:23' prior: 0!
This class represent a definition of a Section in Orbeon Form, the definition is built inside the Orbeon's Form Builder.

name 				- the name of the section definition
label 				- the label of the section
fieldDefinitions	- aDictionary with all field definitions inside this section (fieldName --> aFormFieldDefinition)
gridDefinitions	- aDictionary with all grid defintions of inside this section (gridName --> aFormGridDefinition)
isRepeatable	- whether or not the receiver is repeatable!

!FormSectionDefinition class methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:27'!
name: aString definition: anOrbeonFormDefinition

	^super new initialize
		name: aString;
		formDefinition: anOrbeonFormDefinition;
		yourself! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
addFieldDefinition: aFormFieldDefinition

	^fieldDefinitions at: aFormFieldDefinition name put: aFormFieldDefinition! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
addGridDefinition: aFormGridDefinition

	^gridDefinitions at: aFormGridDefinition name put: aFormGridDefinition! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
addSubSection: aFormSectionDefinition

	aFormSectionDefinition parentSection: self.

	^subSections add: aFormSectionDefinition! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:26'!
fieldDefinitions

   "Return the value of the instance variable 'fieldDefinitions'."
   ^fieldDefinitions! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:26'!
fieldDefinitions: newValue

   "Modify the value of the instance variable 'fieldDefinitions'."
   fieldDefinitions := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
fieldNames

	^(fieldDefinitions collect: [:each | each name]) asOrderedCollection! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:26'!
formDefinition

   "Return the value of the instance variable 'formDefinition'."
   ^formDefinition! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:26'!
formDefinition: newValue

   "Modify the value of the instance variable 'formDefinition'."
   formDefinition := newValue! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/19/2016 10:57'!
getAllFieldDefinitions
	"Answer a collection with all field definitions <FormFieldDefinition> of the receiver.
	Includes fields inside grid definition <FormGridDefinition>"
	| allFields |

	allFields := OrderedCollection new.

	allFields addAll: fieldDefinitions asOrderedCollection.

	gridDefinitions do: [:each | allFields addAll: each fieldDefinitions asOrderedCollection]. 

	^allFields! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
getAllSectionsIn: anOrderedCollection

	anOrderedCollection addAll: subSections.

	subSections do: [:each | 
		each getAllSectionsIn: anOrderedCollection].! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/06/2015 02:39'!
getAllSubSectionsOn: anOrderedCollection

	anOrderedCollection add: self.

	subSections do: [:each | each getAllSubSectionsOn: anOrderedCollection].

	^anOrderedCollection! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/19/2016 11:13'!
getFieldNamed: aString
	"The receiver answer a field definition <FormFieldDefinition> named <aString>.
	NOTE: the receiver does NOT search inside it's grids <FormDefinitionGrid> for the field"

	^fieldDefinitions at: aString ifAbsent: [nil]! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:37'!
getGridDefinitionNamed: aString

	^gridDefinitions at: aString ifAbsent: [nil]! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 18:26'!
getXmlterationName
	"Answer the XML node name for iterations when the receiver is repeatable"
	| customIterationName xPathName |

	"does have a Custom Iteration Name or not ?"
	customIterationName := iterationName 
									ifNotNil: [iterationName] "custome iteration name"
									ifNil: [name]. "does NOT have a Custom Iteration Name"

	xPathName := self isMainSection 
						ifTrue:[isRepeatable 
								ifTrue: [customIterationName, '/',customIterationName, '-iteration'] "it must access the iteration node first then the xml node itself"
								ifFalse:[customIterationName]]"access the xml node directly"
						ifFalse: [self parentSectionIsRepeatable 
								ifTrue: [self parentName, '-iteration/', customIterationName] 
								ifFalse:[customIterationName]].

	^xPathName! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:23'!
gridDefinitions

   "Return the value of the instance variable 'gridDefinitions'."
   ^gridDefinitions! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:23'!
gridDefinitions: newValue

   "Modify the value of the instance variable 'gridDefinitions'."
   gridDefinitions := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
gridNames

	^(gridDefinitions collect: [:each | each name]) asOrderedCollection! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 17:13'!
gridSearchFields
	"The receiver answer a collection of search fields in child grids"
	| searchs |

	searchs := OrderedCollection new.
	gridDefinitions do: [:eachGridDef | searchs addAll: eachGridDef searchFields].

	^searchs! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:41'!
hasCustomIterationName
	"The receiver answer whether or not has a -Custom Iteration Name-"

	^iterationName notNil! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
hasGrids

	^gridDefinitions notEmpty! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
hasSubSections

	subSections ifNil: [subSections := OrderedCollection new.].

	^subSections notEmpty! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
includesFieldDefinition: aFormFieldDefinition

	^fieldDefinitions includes: aFormFieldDefinition! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
includesGridDefinitionNamed: aString

	^gridDefinitions includesKey: aString! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
initialize

	super initialize.

	name := ''.
	label := ''.
	fieldDefinitions := Dictionary new.
	gridDefinitions := Dictionary new.
	isRepeatable := false.
	subSections := OrderedCollection new.! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
isMainSection

	^parentSection isNil! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:23'!
isRepeatable

   "Return the value of the instance variable 'isRepeatable'."
   ^isRepeatable! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:23'!
isRepeatable: newValue

   "Modify the value of the instance variable 'isRepeatable'."
   isRepeatable := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
isSubSection

	^parentSection notNil! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/06/2015 02:40'!
iterationName

   "Return the value of the instance variable 'iterationName'."
   ^iterationName! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 03/06/2015 02:40'!
iterationName: newValue

   "Modify the value of the instance variable 'iterationName'."
   iterationName := newValue! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:23'!
label

   "Return the value of the instance variable 'label'."
   ^label! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:23'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
levelNumber

	parentSection ifNil: [^1].

	^1 + (parentSection levelNumber)! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/06/2014 11:23'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/06/2014 11:23'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
parentName

	parentSection ifNil: [^''].

	^parentSection name! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/06/2015 02:39'!
parentSection

   "Return the value of the instance variable 'parentSection'."
   ^parentSection! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 03/06/2015 02:39'!
parentSection: newValue

   "Modify the value of the instance variable 'parentSection'."
   parentSection := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 17:32'!
parentSectionIsRepeatable
	"Answer whether or not the parent section of the receiver is repeatable"

	parentSection ifNil: [^false].

	^parentSection isRepeatable! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 15:41'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'.! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
printStructureOn: aPrintStream count: counter
	"Print the structure of the receiver on stream <aPrintStream>. As FormSectionDefinition is a recursive structure it use a counter <counter> to ident the resulting stream.
	1- Print Field Definitions of the receiver.
	2- Iterate over Grid Definitions of the receiver and print each of them.
	3- Recursive call. Iterate over Sub Section Defnitions of the receiver and print each of them"

	1 to: counter do: [:each | aPrintStream nextPutAll: String tab].

	aPrintStream nextPutAll: '[', name, ']'.
	isRepeatable ifTrue: [aPrintStream nextPutAll: '(R)'] ifFalse: [aPrintStream nextPutAll: '(N)']. "normal or repeat section"
	aPrintStream nextPutAll: String lf.
	
	fieldDefinitions do: [:each | 
		1 to: (counter + 1) do: [:each | aPrintStream nextPutAll: String tab].
		aPrintStream nextPutAll: each name.
		aPrintStream nextPutAll: ', ', each type.
		aPrintStream nextPutAll: String lf.].

	gridDefinitions do: [:each | each printStructureOn: aPrintStream count: counter].

	subSections do: [:each | each printStructureOn: aPrintStream count: counter + 1]! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
removeFieldDefinition: aFormFieldDefinition

	^fieldDefinitions removeKey: aFormFieldDefinition name ifAbsent: []! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
removeGridDefinition: aFormGridDefinition

	^gridDefinitions removeKey: aFormGridDefinition name ifAbsent: []! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
removeSubSection: aFormSectionDefinition

	aFormSectionDefinition parentSection: nil.

	^subSections remove: aFormSectionDefinition ifAbsent: []! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 17:10'!
searchFields
	"The receiver answer a collection with all search fields. Including direct fields and fields in child grids "

	^(fieldDefinitions select: [:each | each isSearch]) asOrderedCollection, self gridSearchFields asOrderedCollection! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2015 02:39'!
sectionDefinitions

	^subSections! !

!FormSectionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/06/2015 02:39'!
subSections

   "Return the value of the instance variable 'subSections'."
   ^subSections! !

!FormSectionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 03/06/2015 02:39'!
subSections: newValue

   "Modify the value of the instance variable 'subSections'."
   subSections := newValue! !

!FormSectionDefinition methodsFor: 'other' stamp: 'BrunoBB 08/06/2014 11:23'!
summaryFields

	^fieldDefinitions select: [:each | each isSummary]! !

OrbeonObject subclass: #FormSectionInstance
	instanceVariableNames: 'name sectionDefinition formInstance parentSection subSections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!FormSectionInstance commentStamp: 'BrunoBB 02/17/2015 11:23' prior: 0!
This class represent a concrete instance of a Section in Orbeon Forms.

name 					- section name
sectionDefinition 	- section definition aFormSectionDefinition
iterations				- if the section is repeatable then each instance is aDictionary in this collection
grids					- grids inside the Section aDictionary of FormGridInstance
fields					- a dictionary of fields when the receiver is NOT repeatable!

!FormSectionInstance class methodsFor: 'other' stamp: 'BrunoBB 08/05/2014 07:21'!
name: aString

	^super new initialize
		name: aString;
		yourself! !

!FormSectionInstance class methodsFor: 'other' stamp: 'BrunoBB 08/05/2014 07:21'!
name: aString definition: aFormSectionDefinition

	^super new initialize
		name: aString;
		sectionDefinition: aFormSectionDefinition;
		yourself! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/25/2015 15:26'!
addSubSection: aFormSectionInstance

	aFormSectionInstance parentSection: self.

	^subSections add: aFormSectionInstance! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 09:42'!
anySubSectionHasGrids

	^self subclassResponsibility! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/22/2015 11:40'!
fieldNames

	^sectionDefinition fieldNames! !

!FormSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/22/2015 11:40'!
formInstance

   "Return the value of the instance variable 'formInstance'."
   ^formInstance! !

!FormSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/22/2015 11:40'!
formInstance: newValue

   "Modify the value of the instance variable 'formInstance'."
   formInstance := newValue! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/25/2015 15:06'!
getAllSectionsIn: anOrderedCollection

	^self subclassResponsibility! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 14:16'!
hasDefinedGrids

	^sectionDefinition hasGrids! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 14:15'!
hasDefinedSubSections

	^sectionDefinition hasSubSections! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/27/2015 13:30'!
id

	formInstance ifNil: [^parentSection id].

	^formInstance id! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/22/2015 11:41'!
initialize

	super initialize.

	name := ''.
	subSections := OrderedCollection new.! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:31'!
isComplex
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has Sub Sections
		* Has NO Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:32'!
isComplexWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has Sub Sections
		* Has Grids "

	^false! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 14:19'!
isRepeatable

	^self subclassResponsibility! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:36'!
isRepeatableComplex
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has Sub Sections
		* Has NO Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:37'!
isRepeatableComplexWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has Sub Sections
		* Has Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:33'!
isRepeatableSimple
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has NO Sub Sections
		* Has NO Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:34'!
isRepeatableSimpleWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has NO Sub Sections
		* Has Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:28'!
isSimple
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has NO Sub Sections
		* Has NO Grids "

	^false! !

!FormSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:29'!
isSimpleWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has NO Sub Sections
		* Has Grids "

	^false! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/25/2015 15:42'!
levelNumber

	^self subclassResponsibility! !

!FormSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 07:21'!
name

   "Return the value of the instance variable 'name'."
   ^name! !

!FormSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 07:21'!
name: newValue

   "Modify the value of the instance variable 'name'."
   name := newValue! !

!FormSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/22/2015 11:40'!
parentSection

   "Return the value of the instance variable 'parentSection'."
   ^parentSection! !

!FormSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/22/2015 11:40'!
parentSection: newValue

   "Modify the value of the instance variable 'parentSection'."
   parentSection := newValue! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/28/2015 09:26'!
printExportType

	^self subclassResponsibility! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/02/2016 16:51'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'.! !

!FormSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/22/2015 11:40'!
removeSubSection: aFormSectionDefinition

	aFormSectionDefinition parentSection: nil.

	^subSections remove: aFormSectionDefinition ifAbsent: []! !

!FormSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 08/05/2014 07:21'!
sectionDefinition

   "Return the value of the instance variable 'sectionDefinition'."
   ^sectionDefinition! !

!FormSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 08/05/2014 07:21'!
sectionDefinition: newValue

   "Modify the value of the instance variable 'sectionDefinition'."
   sectionDefinition := newValue! !

!FormSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/22/2015 11:40'!
subSections

   "Return the value of the instance variable 'subSections'."
   ^subSections! !

!FormSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/22/2015 11:40'!
subSections: newValue

   "Modify the value of the instance variable 'subSections'."
   subSections := newValue! !

FormSectionInstance subclass: #NormalSectionInstance
	instanceVariableNames: 'fields grids nextIteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!NormalSectionInstance commentStamp: '' prior: 0!
fields 				- aDictionay where each key is the name of the field and the value is the String value of the field.
grids 				- aDictionay where each key is the name of a Grid and the value is an instance of FormGridInstance.
nextIteration	- if the receiver is repeatable then is an instance of NormalSectionInstance if not is nil.!

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
addGrid: aFormGridInstance

	aFormGridInstance section: self.
	^grids at: aFormGridInstance name put: aFormGridInstance! !

!NormalSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 04/03/2016 13:55'!
anySubSectionHasGrids
	"Answer whether or not the receiver or it's subsections has any Grid"

	^subSections anySatisfy: [:each | each hasDefinedGrids or:[each anySubSectionHasGrids]]! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
fieldAt: fieldName put: fieldValue

	^fields at: fieldName put: fieldValue! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
fields

   "Return the value of the instance variable 'fields'."
   ^fields! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
fields: newValue

   "Modify the value of the instance variable 'fields'."
   fields := newValue! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
fieldValueAt: fieldName 

	^fields at: fieldName ifAbsent: nil! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
getAllSectionsIn: anOrderedCollection

	anOrderedCollection add: self.

	subSections do: [:each | 
		each getAllSectionsIn: anOrderedCollection].! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getComplexSections

	^subSections select: [:each | each isComplex]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getComplexSectionsWithGrids

	^subSections select: [:each | each isComplexWithGrids]! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
getGridNamed: aString

	^grids at: aString ifAbsent: [nil]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getRepeatableComplexSections

	^subSections select: [:each | each isRepeatableComplex]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getRepeatableComplexSectionsWithGrids

	^subSections select: [:each | each isRepeatableComplexWithGrids]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getRepeatableSimpleSections

	^subSections select: [:each | each isRepeatableSimple]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getRepeatableSimpleSectionsWithGrids

	^subSections select: [:each | each isRepeatableSimpleWithGrids]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getSectionsToExport

	^self getSimpleSections,
		self getSimpleSectionsWithGrids,
		self getComplexSections,
		self getComplexSectionsWithGrids,
		self getRepeatableSimpleSections,
		self getRepeatableSimpleSectionsWithGrids,
		self getRepeatableComplexSections,
		self getRepeatableComplexSectionsWithGrids! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getSimpleSections

	^subSections select: [:each | each isSimple]! !

!NormalSectionInstance methodsFor: 'get sections' stamp: 'BrunoBB 04/03/2016 13:55'!
getSimpleSectionsWithGrids

	^subSections select: [:each | each isSimpleWithGrids]! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 18:41'!
getSubSectionIndex

	parentSection ifNil: [^formInstance getSubSectionIndexOf: self].

	^((parentSection subSections select: [:each | each name = name]) indexOf: self ifAbsent: [0]) printString! !

!NormalSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 04/03/2016 13:55'!
grids

   "Return the value of the instance variable 'grids'."
   ^grids! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
grids: newValue

   "Modify the value of the instance variable 'grids'."
   grids := newValue! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
includesGridNamed: aString

	^grids includesKey: aString! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
initialize

	super initialize.

	fields := Dictionary new. 
	grids := Dictionary new.! !

!NormalSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 04/03/2016 13:55'!
isComplex
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has Sub Sections
		* Has NO Grids "

	^(self hasDefinedSubSections and: [self hasDefinedGrids not])
		and: [self anySubSectionHasGrids not]! !

!NormalSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 04/03/2016 13:55'!
isComplexWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has Sub Sections
		* Has Grids "

	^self hasDefinedSubSections and: [(self hasDefinedGrids) or: [self anySubSectionHasGrids]]! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
isRepeatable

	^false! !

!NormalSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 04/03/2016 13:55'!
isSimple
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has NO Sub Sections
		* Has NO Grids "

	^self hasDefinedSubSections not and: [self hasDefinedGrids not]! !

!NormalSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 04/03/2016 13:55'!
isSimpleWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is NOT a Repeatable Section
		* Has NO Sub Sections
		* Has Grids "

	^self hasDefinedSubSections not and: [self hasDefinedGrids]! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
levelNumber

	parentSection ifNil: [^1].

	parentSection isRepeatable ifTrue: [^0 + (parentSection levelNumber)].

	^1 + (parentSection levelNumber)! !

!NormalSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 04/03/2016 13:55'!
nextIteration
	^nextIteration! !

!NormalSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 04/03/2016 13:55'!
nextIteration: newValue
	nextIteration := newValue! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 13:55'!
printExportType

	(parentSection notNil and: [parentSection isRepeatable]) ifTrue: [^'(R)'].

	^'(N)'! !

!NormalSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 18:31'!
printStructureOn: aPrintStream count: counter
	"Print the structure of the receiver on stream <aPrintStream>. As FormSectionInstance is a recursive structure it use the counter <counter> to ident the resulting string.
	1- Print Field Instances.
	2- Iterate over Grid Instances and print each of them.
	3- Recursive call. Iterate over Sub Section Instances of the receiver and print each of them"

	1 to: counter do: [:each | aPrintStream nextPutAll: String tab].

	aPrintStream nextPutAll: '[', name, ']'.
	sectionDefinition isRepeatable 
	ifTrue: [aPrintStream nextPutAll: ' - iteration(', self getSubSectionIndex, ')'].
	aPrintStream nextPutAll: String lf.
	
	fields keysAndValuesDo: [:key :value | 
		1 to: (counter + 1) do: [:each | aPrintStream nextPutAll: String tab].
		aPrintStream nextPutAll: key, ': ', (value ifNil: ['nil'] ifNotNil: [:value | value]).
		aPrintStream nextPutAll: String lf.].

	grids do: [:each | each printStructureOn: aPrintStream count: counter].

	subSections do: [:each | 
		each printStructureOn: aPrintStream count: counter + 1]! !

FormSectionInstance subclass: #RepeatSectionInstance
	instanceVariableNames: 'sectionIterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/25/2015 15:38'!
addSectionIteration: aFormSectionInstance

	aFormSectionInstance parentSection: self.

	^sectionIterations add: aFormSectionInstance! !

!RepeatSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 09:39'!
anySubSectionHasGrids
	"Answer whether or not the receiver or it's subsections has any Grid"

	^sectionIterations anySatisfy: [:each | each anySubSectionHasGrids]! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 05/09/2015 13:10'!
getAllSectionsIn: anOrderedCollection

	"we do NOT include the repeatable section itself but rather the section iterations (instances of NormalSectionInstance)"

	"anOrderedCollection add: self." 

	sectionIterations do: [:each | 
		each getAllSectionsIn: anOrderedCollection].! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/20/2015 04:16'!
initialize

	super initialize.

	sectionIterations := OrderedCollection new.! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/24/2015 14:19'!
isRepeatable

	^true! !

!RepeatSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 09:41'!
isRepeatableComplex
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has Sub Sections
		* Has NO Grids "

	^(self hasDefinedSubSections and: [self hasDefinedGrids not])
		and: [self anySubSectionHasGrids not]! !

!RepeatSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 09:41'!
isRepeatableComplexWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has Sub Sections
		* Has Grids "

	^self hasDefinedSubSections and: [(self hasDefinedGrids) or: [self anySubSectionHasGrids]]! !

!RepeatSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:33'!
isRepeatableSimple
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has NO Sub Sections
		* Has NO Grids "

	^self hasDefinedSubSections not and: [self hasDefinedGrids not]! !

!RepeatSectionInstance methodsFor: 'section type' stamp: 'BrunoBB 02/26/2015 03:34'!
isRepeatableSimpleWithGrids
	"Answer whether the receiver has the following characteristics:
		* Is a Repeatable Section
		* Has NO Sub Sections
		* Has Grids "

	^self hasDefinedGrids and: [self hasDefinedSubSections not]! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/27/2015 05:22'!
iterationsDo: aBlock

	^sectionIterations do: aBlock! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/25/2015 15:41'!
levelNumber

	parentSection ifNil: [^1].

	^1 + (parentSection levelNumber)! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/28/2015 09:25'!
printExportType

	^'(R)'! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 04/02/2016 16:04'!
printStructureOn: aPrintStream count: counter
	"Print the structure of the receiver on stream <aPrintStream> and use the counter <counter> to ident the resulting string.
	Iterate over all section iterations (NormalSectionInstances) to print the structure of each of them"

	sectionIterations do: [:each | each printStructureOn: aPrintStream count: counter].

	subSections do: [:each | each printStructureOn: aPrintStream count: counter + 1].! !

!RepeatSectionInstance methodsFor: 'other' stamp: 'BrunoBB 02/22/2015 11:29'!
removeSectionIteration: aFormSectionInstance

	^sectionIterations remove: aFormSectionInstance ifAbsent: []! !

!RepeatSectionInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/20/2015 04:15'!
sectionIterations

   "Return the value of the instance variable 'sectionIterations'."
   ^sectionIterations! !

!RepeatSectionInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/20/2015 04:15'!
sectionIterations: newValue

   "Modify the value of the instance variable 'sectionIterations'."
   sectionIterations := newValue! !

OrbeonObject subclass: #OrbeonForm
	instanceVariableNames: 'id form app createdTime modifiedTime modifiedUser deleted xmlString version properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonForm class
	instanceVariableNames: 'cache'!

!OrbeonForm commentStamp: '' prior: 0!
The basic abstract class to represent Orbeon Form using Smalltalk objects.

id 						- id of the form, is identical to the id in MySQL database (mysql).
form 					- name of the form (mysql).
app						- application's name, where the form belongs (mysql).
createdTime 		- time stamp when created (mysql).
modifiedTime 		- time stamp where last modified (mysql).
modifiedUser 		- last modifier user name (mysql).
deleted				- whether the form is deleted or not (mysql).
fieldNames 			- collection of field's names.
xmlString 			- xml that represent the form (mysql).
xmlDocument 		- DOM document to process the form (usually is nil but when processing some value)
version				- version of the form (mysql).!

!OrbeonForm class methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
app: app form: form

	^super new initialize
		app: app;
		form: form;
		yourself! !

!OrbeonForm class methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
cache

	cache ifNil: [self initializeCache].

	^cache! !

!OrbeonForm class methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
initializeCache
	"self initializeCache"
	cache := OrderedCollection new.! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
app

   "Return the value of the instance variable 'app'."
   ^app! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
app: newValue

   "Modify the value of the instance variable 'app'."
   app := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
applicationName

	^self getApplication name! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
available

	^self getProperty: 'available'! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
available: aBooleanString

	^self setProperty: 'available' with: aBooleanString! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
cloneForAudit
	"The receiver answer a new cloned instance of it's self for audit purpose.
	The section structure is NOT cloned but can be reconstructed from <xmlString>"
	| clone |

	clone := self class new initialize.
	clone id: id;
		form: form;
		app: app;
		createdTime: createdTime;
		modifiedTime: modifiedTime;
		modifiedUser: modifiedUser;
		deleted: deleted;
		xmlString: xmlString;
		version: version.

	^clone! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
createdTime

   "Return the value of the instance variable 'createdTime'."
   ^createdTime! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
createdTime: newValue

   "Modify the value of the instance variable 'createdTime'."
   createdTime := newValue! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
deleted

   "Return the value of the instance variable 'deleted'."
   ^deleted! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
deleted: newValue

   "Modify the value of the instance variable 'deleted'."
   deleted := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
description

	^self getProperty: 'description'! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
description: aString

	^self setProperty: 'description' with: aString! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
form

   "Return the value of the instance variable 'form'."
   ^form! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
form: newValue

   "Modify the value of the instance variable 'form'."
   form := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
getApplication

	^self getOrbeonApplicationClass applicationNamed: app ifNone: [nil]! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
getId

	id ifNil: [^'nil'].

	^id! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
getObjectName
	"Answer the name of the receiver to be used as a key to store fields values"

	^self form! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
getProperty: propertieName

	^self getProperty: propertieName ifNone: [nil]! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
getProperty: propertieName ifNone: aBlock

	^properties at: propertieName ifAbsent: aBlock! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
id

   "Return the value of the instance variable 'id'."
   ^id! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
id: newValue

   "Modify the value of the instance variable 'id'."
   id := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
includesProperty: propertieName

	^properties includesKey: propertieName! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
initialize

	super initialize.

	createdTime := TimeStamp now.
	deleted := 'N'.
	modifiedTime := TimeStamp now.
	modifiedUser := ''.
	properties := Dictionary new.
	version := 1.! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
logicalDelete

	deleted := 'Y'! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
modifiedTime

   "Return the value of the instance variable 'modifiedTime'."
   ^modifiedTime! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
modifiedTime: newValue

   "Modify the value of the instance variable 'modifiedTime'."
   modifiedTime := newValue! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
modifiedUser

   "Return the value of the instance variable 'modifiedUser'."
   ^modifiedUser! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
modifiedUser: newValue

   "Modify the value of the instance variable 'modifiedUser'."
   modifiedUser := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 08:13'!
newFormReader
	"Answer <anOrbeonFormReader> to get values from the XML document of the receiver"


	^self subclassResponsibility! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
properties
	^properties! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
properties: newValue
	properties := newValue! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
registry
	| application |

	application := self getApplication.
	application ifNil: [^nil].

	^application registryForFormNamed: form ifNone: [nil]! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
setProperty: propertieName with: value

	^properties at: propertieName put: value! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
shortId

	^id size > 10 ifTrue: [id first: 10] ifFalse: [id]! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
title

	^self getProperty: 'title'! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
title: aString

	^self setProperty: 'title' with: aString! !

!OrbeonForm methodsFor: 'other' stamp: 'BrunoBB 03/18/2016 09:16'!
updateLastModifiedTime

	modifiedTime := TimeStamp now.! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
version

   "Return the value of the instance variable 'version'."
   ^version! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
version: newValue

   "Modify the value of the instance variable 'version'."
   version := newValue! !

!OrbeonForm methodsFor: 'Accessing' stamp: 'BrunoBB 03/18/2016 09:16'!
xmlString

   "Return the value of the instance variable 'xmlString'."
   ^xmlString! !

!OrbeonForm methodsFor: 'Updating' stamp: 'BrunoBB 03/18/2016 09:16'!
xmlString: newValue

   "Modify the value of the instance variable 'xmlString'."
   xmlString := newValue! !

OrbeonForm subclass: #OrbeonFormDefinition
	instanceVariableNames: 'formMetadata instances instanceDefinition fieldInstances labels synchronizations permissions fieldsType sectionDefinitions isPublished drafts customAttachment attachments'
	classVariableNames: 'OrbeonMapDictionary'
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonFormDefinition commentStamp: 'BrunoBB 08/02/2014 12:17' prior: 0!
This class represent instances of a Orbeon Form Definition. Orbeon Form Definitions are always created inside the Form Builder.
Instances of this class represent definitions created inside the Form Builder.

instances 				- aDictionary with instances of this Definitions (OrbeonFormInstances).
instanceDefinition 	- not used.
fieldInstances			- aDictionary of UnorderedCollections where each key is anUnorderedCollection with instances of FormFieldValue.
labels 						- aDictionary mapping field's name with the label to be displayed.
synchronizations 	- a collection of synchronization with MySQL database.
permissions 			- permisions of the role over the form definition.
fieldsType  				- aDictionary mapping field's name with field's type.
isPublished 				- whether the receiver is published (accesible from web) or not
sectionDefinitions	- aDictionary with all sections of the form definition.!

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 07:19'!
defaultXmlDefinition: formName app: app

	^'<xh:html xmlns:xh="http://www.w3.org/1999/xhtml" xmlns:xf="http://www.w3.org/2002/xforms"
         xmlns:xs="http://www.w3.org/2001/XMLSchema"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:ev="http://www.w3.org/2001/xml-events"
         xmlns:xi="http://www.w3.org/2001/XInclude"
         xmlns:xxi="http://orbeon.org/oxf/xml/xinclude"
         xmlns:xxf="http://orbeon.org/oxf/xml/xforms"
         xmlns:exf="http://www.exforms.org/exf/1-0"
         xmlns:fr="http://orbeon.org/oxf/xml/form-runner"
         xmlns:saxon="http://saxon.sf.net/"
         xmlns:sql="http://orbeon.org/oxf/xml/sql"
         xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"
         xmlns:fb="http://orbeon.org/oxf/xml/form-builder">
    <xh:head>
        <xh:title>Untitled Form</xh:title>
        <xf:model id="fr-form-model" xxf:expose-xpath-types="true">
            <!!-- Main instance -->
            <xf:instance id="fr-form-instance" xxf:exclude-result-prefixes="#all">
                <form>
                    <section-1>
                        <control-1/>
                    </section-1>
                </form>
            </xf:instance>
            <!!-- Bindings -->
            <xf:bind id="fr-form-binds" ref="instance(''fr-form-instance'')">
                <xf:bind id="section-1-bind" name="section-1" ref="section-1">
                    <xf:bind id="control-1-bind" name="control-1" ref="control-1"/>
                </xf:bind>
            </xf:bind>
            <!!-- Metadata -->
            <xf:instance xxf:readonly="true" id="fr-form-metadata" xxf:exclude-result-prefixes="#all">
                <metadata>
                    <application-name>', app,'</application-name>
                    <form-name>', formName, '</form-name>
                    <title xml:lang="en">Untitled Form</title>
                    <description xml:lang="en"/>
                </metadata>
            </xf:instance>
            <!!-- Attachments -->
            <xf:instance id="fr-form-attachments" xxf:exclude-result-prefixes="#all">
                <attachments>
                    <css mediatype="text/css" filename="" size=""/>
                    <pdf mediatype="application/pdf" filename="" size=""/>
                </attachments>
            </xf:instance>
            <!!-- All form resources -->
            <!!-- Don not make readonly by default in case a service modifies the resources -->
            <xf:instance id="fr-form-resources" xxf:readonly="false" xxf:exclude-result-prefixes="#all">
                <resources>
                    <resource xml:lang="en">
                        <section-1>
                            <label>Untitled Section</label>
                        </section-1>
                        <control-1>
                            <label/>
                            <hint/>
                            <alert/>
                        </control-1>
                    </resource>
                </resources>
            </xf:instance>
            <!!-- Utility instances for services -->
            <xf:instance id="fr-service-request-instance" xxf:exclude-result-prefixes="#all">
                <request/>
            </xf:instance>
            <xf:instance id="fr-service-response-instance" xxf:exclude-result-prefixes="#all">
                <response/>
            </xf:instance>
        </xf:model>
    </xh:head>
    <xh:body>
        <fr:view>
            <fr:body xmlns:xbl="http://www.w3.org/ns/xbl" xmlns:p="http://www.orbeon.com/oxf/pipeline"
                     xmlns:oxf="http://www.orbeon.com/oxf/processors">
                <fr:section id="section-1-control" bind="section-1-bind">
                    <xf:label ref="$form-resources/section-1/label"/>
                    <fr:grid>
                        <xh:tr>
                            <xh:td>
                                <xf:input id="control-1-control" bind="control-1-bind">
                                    <xf:label ref="$form-resources/control-1/label"/>
                                    <xf:hint ref="$form-resources/control-1/hint"/>
                                    <xf:alert ref="$fr-resources/detail/labels/alert"/>
                                </xf:input>
                            </xh:td>
                            <xh:td/>
                        </xh:tr>
                    </fr:grid>
                </fr:section>
            </fr:body>
        </fr:view>
    </xh:body>
</xh:html>'! !

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 06:04'!
fileOutForm: xmlString to: aPathFile
	| gsFile |

	gsFile := GsFile open: aPathFile mode: 'wb' onClient: false.

	gsFile
		nextPutAll: xmlString;
		flush;
		close.! !

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
formNamed: aString in: appName 

	^self formNamed: aString in: appName ifNone: []! !

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:28'!
formNamed: aString in: appName ifNone: aBlock

	^self cache detect: [:each | each form = aString and:[each applicationName = appName]] ifNone: aBlock! !

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 08:50'!
initializeMapDictionary

	OrbeonMapDictionary := Dictionary new.
	OrbeonMapDictionary at: 'xf:string' put: AppFieldStringValue;
		at: 'xf:boolean' put: AppFieldBooelanValue;
		at: 'xf:integer' put: AppFieldNumberValue;
		at: 'xs:integer' put: AppFieldNumberValue;
		at: 'xf:decimal' put: AppFieldNumberValue;
		at: 'xf:double' put: AppFieldNumberValue;
		at: 'xf:positiveInteger' put: AppFieldNumberValue;
		at: 'xf:nonPositiveInteger' put: AppFieldNumberValue;
		at: 'xf:negativeInteger' put: AppFieldNumberValue;
		at: 'xf:nonNegativeInteger' put: AppFieldNumberValue;
		at: 'xf:dateTime' put: AppFieldTimeStampValue;
		at: 'xf:date' put: AppFieldDateValue;
		at: 'xf:time' put: AppFieldTimeValue.! !

!OrbeonFormDefinition class methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
mapDictionary

	OrbeonMapDictionary ifNil: [self initializeMapDictionary].

	^OrbeonMapDictionary! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
addDraft: anOrbeonFormInstance

	anOrbeonFormInstance definition: self.

	(drafts includesKey: anOrbeonFormInstance id) ifFalse: [drafts at: anOrbeonFormInstance id put: OrderedCollection new].

	^(drafts at: anOrbeonFormInstance id) add: anOrbeonFormInstance! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/13/2015 17:41'!
addFieldInstance: aFormFieldValue
	"Add <aFormFieldValue> to the receiver. Ask for the key <aFormFieldValue name> to get the IdentitySet for that field name.
	#fieldInstances at: fieldName -  answer anIdentitySet with all FormFieldValue for that field name.
	This IdentitySet has an index to sort fields"

	(fieldInstances includesKey: aFormFieldValue name) 
	ifFalse: [| indexedCollection |
		indexedCollection := RcIdentityBag new.
		fieldInstances at: aFormFieldValue name put: indexedCollection.
		indexedCollection add: aFormFieldValue.
		"indexes can NOT be create on empty collections so we add the element first"
		self createFieldIndexFor: aFormFieldValue on: indexedCollection.
		^aFormFieldValue.
		].

	^(fieldInstances at: aFormFieldValue name) add: aFormFieldValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
addInstance: anOrbeonFormInstance

	anOrbeonFormInstance definition: self.
	^instances at: anOrbeonFormInstance id put: anOrbeonFormInstance! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
addPermission: permissionName to: roleName
	"The receiver add the permission <permissionName> to the role <roleName>"

	^permissions add: permissionName to: roleName! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/04/2015 13:34'!
addSectionDefinition: aFormSectionDefinition

	^sectionDefinitions at: aFormSectionDefinition name put: aFormSectionDefinition! !

!OrbeonFormDefinition methodsFor: 'synchronize' stamp: 'BrunoBB 09/04/2015 13:34'!
addSynchronizationAt: timeStamp count: anInteger
	"The receiver add a synchronization with Orbeon database. The application named <appName> for the form <formName> at time <timeStamp> and it has affected <anInteger> objects. Each time a synchronization is executed this method register the synchronization"
	| synchro |

	synchro := OrbeonSynchronization count: anInteger.
	synchro timeStamp: timeStamp.
	synchronizations add: synchro.
	^synchro! !

!OrbeonFormDefinition methodsFor: 'synchronize' stamp: 'BrunoBB 09/04/2015 13:34'!
addSynchronizationAt: timeStamp insertCount: insertCount updateCount: updateCount
	"The receiver add a synchronization with Orbeon database. The application named <appName> for the form <formName> at time <timeStamp> and it has affected <anInteger> objects. Each time a synchronization is executed this method register the synchronization"
	| synchro |

	synchro := OrbeonSynchronization insertCount: insertCount updateCount: updateCount.
	synchro timeStamp: timeStamp.

	synchronizations add: synchro.
	^synchro! !

!OrbeonFormDefinition methodsFor: 'synchronize' stamp: 'BrunoBB 09/04/2015 13:34'!
addSynchronizationWithCount: anInteger
	"The receiver add a synchronization with Orbeon database. The application named <appName> for the form <formName> at time <timeStamp> and it has affected <anInteger> objects. Each time a synchronization is executed this method register the synchronization"

	^self addSynchronizationAt: TimeStamp now count: anInteger! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
addTestPermissions
	| adminUser superUser user |

	adminUser :=  'orbeon-', app, '-admin'.
	superUser := 'orbeon-', app, '-super'.
	user :=  'orbeon-', app, '-user'.

	permissions := Dictionary new.
	self addPermission: 'create' to: 'all'.
	self addPermission: 'read' to: superUser.
	self addPermission: 'read' to: adminUser.
	self addPermission: 'read' to: user.
	self addPermission: 'update' to: adminUser.
	self addPermission: 'update' to: superUser.
	self addPermission: 'delete' to: adminUser.
	self addPermission: 'export' to: adminUser.
	self addPermission: 'sync' to: adminUser.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 03/19/2016 14:53'!
attachments
	^attachments asOrderedCollection! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 03/19/2016 14:35'!
attachments: newValue

	attachments := newValue! !

!OrbeonFormDefinition methodsFor: 'type-mapping' stamp: 'BrunoBB 02/17/2016 12:54'!
classOf: attributeName
	"Answer a subclass of <AppFieldValue> that represent the Orbeon type of the field named <attributeName>."

	^self mapOrbeonType: (self typeOf: attributeName)! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/04/2015 11:44'!
createFieldDefinitionFor: aFormSectionDefinition reader: anOrbeonFormReader with: xmlSection
	"Populate receiver's section definition <aFormSectionDefinition> with Field Definition using <anOrbeonFormReader> on anXML element <xmlSection>"
	| search summary |

	summary := anOrbeonFormReader summaryFormFieldsNameIn: xmlSection.
	search := anOrbeonFormReader searchFormFieldsNameIn: xmlSection.	
	(anOrbeonFormReader formFieldsIn: xmlSection) do: [:fieldNode | | fieldDefinition fieldName |
		fieldName := anOrbeonFormReader getNameFrom: fieldNode.
		fieldDefinition := FormFieldDefinition name: fieldName.
		fieldDefinition label: (labels at: fieldName ifAbsent: ['']);
			type: (fieldsType at: fieldName ifAbsent: ['']);
			isSummary: (summary includes: fieldName);
			isSearch: (search includes: fieldName);
			isAttachmentField: (anOrbeonFormReader isAttachmentField: fieldNode).
		aFormSectionDefinition addFieldDefinition: fieldDefinition.
	]! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/28/2015 16:21'!
createFieldIndexFor: aFormFieldValue on: aRcIdentityBag
	"The receiver create (initialization - executed only once) an Index for the field named <aFormFieldValue> name.
	The index is created if the field is a search field if not only answer the holder collection <aRcIdentityBag>"

	(self isSearchField: aFormFieldValue name)
	ifTrue: [GsIndexSpec new
				equalityIndex: 'each.value' lastElementClass: (self stTypeOf: aFormFieldValue name);
				createIndexesOn: aRcIdentityBag].

	^aRcIdentityBag! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 03/17/2016 12:18'!
createGridDefinitionFor: aFormSectionDefinition reader: anOrbeonFormReader with: xmlSection
	"Populate receiver's section definition <aFormSectionDefinition> with Field Definition using <anOrbeonFormReader> on anXML element <xmlSection>.
	Only get Repeatable Grids"


	(anOrbeonFormReader formGridComponentsIn: xmlSection) do: [:eachGrid | | gridDefinition gridName |
		((eachGrid attributeAt: 'id') size <= 5) ifTrue: [^OrbeonControlSizeException signal: 'No "-grid" word found in grid''s name'].
		gridName := (eachGrid attributeAt: 'id') allButLast: 5. "remove: -grid"
		gridDefinition := FormGridDefinition name: gridName.
		self createGridFieldDefinitionFor: gridDefinition reader: anOrbeonFormReader with: eachGrid.
		aFormSectionDefinition addGridDefinition: gridDefinition.
	]! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/13/2015 16:51'!
createGridFieldDefinitionFor: aFormSectionDefinition reader: anOrbeonFormReader with: xmlGrid
	"Populate receiver's section definition <aFormSectionDefinition> with Field Definition using <anOrbeonFormReader> on anXML element <xmlGrid>"
	| search summary |

	summary := anOrbeonFormReader summaryFormFieldsNameIn: xmlGrid.
	search := anOrbeonFormReader searchFormFieldsNameIn: xmlGrid.	
	(anOrbeonFormReader formGridFieldsNameIn: xmlGrid) do: [:fieldName | | fieldDefinition |
		fieldDefinition := FormFieldDefinition name: fieldName.
		fieldDefinition label: (labels at: fieldName ifAbsent: ['']);
			type: (fieldsType at: fieldName ifAbsent: ['']);
			isSummary: (summary includes: fieldName);
			isSearch: (search includes: fieldName).
		aFormSectionDefinition addFieldDefinition: fieldDefinition.
	]! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/04/2015 11:44'!
createSectionDefinitionNamed: sectionName repeatable: aBoolean basedOn: xmlSection with: anOrbeonFormReader
	"Create the receiver FormSectionDefinition using the form reader <anOrbeonFormReader> "
	| section |

	section := FormSectionDefinition name: sectionName definition: self.
	section isRepeatable: aBoolean.
	self createFieldDefinitionFor: section reader: anOrbeonFormReader with: xmlSection.
	self createGridDefinitionFor: section reader: anOrbeonFormReader with: xmlSection.

	^section! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/04/2015 11:20'!
createSectionsDefinitionWith: anOrbeonFormReader
	"Create the receiver FormSectionDefinition using the form reader <anOrbeonFormReader> "

	"Normal Sections"
	(anOrbeonFormReader formMainSectionsRepeatable: false) do: [:xmlSection | | sectionName section |

		sectionName := anOrbeonFormReader getNameFrom: xmlSection.
		section := self createSectionDefinitionNamed: sectionName repeatable: false basedOn: xmlSection with: anOrbeonFormReader.
		self addSectionDefinition: section.
		self createSubSectionsFor: section node: xmlSection with: anOrbeonFormReader].

	"Repeatable Sections"
	(anOrbeonFormReader formMainSectionsRepeatable: true) do: [:xmlSection  | | sectionName section | 

		sectionName := anOrbeonFormReader getNameFrom: xmlSection.
		section := self createSectionDefinitionNamed: sectionName repeatable: true basedOn: xmlSection with: anOrbeonFormReader.
		self addSectionDefinition: section.
		self createSubSectionsFor: section node: xmlSection with: anOrbeonFormReader].! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 03/17/2016 15:02'!
createSubSectionsFor: aFormSectionDefinition node: xmlSection with: anOrbeonFormReader
	"The receiver creates subsection of <aFormSectionDefinition> inside xml segment <xmlSection> using the xml reader <anOrbeonFormReader>"

	(anOrbeonFormReader formSubSectionsOf: xmlSection) do: [:xmlSubSection | | sectionName section isRepeatable |
		sectionName := anOrbeonFormReader getNameFrom: xmlSubSection.
		isRepeatable := xmlSubSection includesAttribute: 'repeat'. "set if the sub section is repeatable"
		section := self createSectionDefinitionNamed: sectionName repeatable: isRepeatable basedOn: xmlSubSection with: anOrbeonFormReader.
		aFormSectionDefinition addSubSection: section.
		self createSubSectionsFor: section node: xmlSubSection with: anOrbeonFormReader.]. "recursive call"! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
customAttachment
	^customAttachment! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
customAttachment: newValue
	customAttachment := newValue! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
drafts
	^drafts! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
drafts: newValue
	drafts := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldDefinitionDo: aBlock

	^self fieldDefinitions do: aBlock! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldDefinitions
	"The receiver answer a collection of field definitions. Iterate over embedded sections"
	| sections fields |

	fields := OrderedCollection new.

	sections := self getAllSectionsIn: OrderedCollection new.

	sections do: [:each | fields addAll: (each getAllFieldDefinitions)].

	^fields! !

!OrbeonFormDefinition methodsFor: 'test' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldDefinitionSelect: aBlock

	^self fieldDefinitions select: aBlock! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldInstances

   "Return the value of the instance variable 'fieldInstances'."
   ^fieldInstances! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldInstances: newValue

   "Modify the value of the instance variable 'fieldInstances'."
   fieldInstances := newValue! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/15/2015 12:56'!
fieldInstancesOf: fieldName
	"The receiver answer the set collection that contains the FormFieldValue's of the field named <fieldName>"

	^fieldInstances at: fieldName ifAbsent: [IdentitySet new]! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldsType

   "Return the value of the instance variable 'fieldsType'."
   ^fieldsType! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
fieldsType: newValue

   "Modify the value of the instance variable 'fieldsType'."
   fieldsType := newValue! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
formMetadata
	^formMetadata! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
formMetadata: newValue
	formMetadata := newValue! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 03/19/2016 11:48'!
formReader
	"Answer <anOrbeonFormReader> to get values from the XML document of the receiver"

	"^OrbeonFormReader for: xmlString."

	^OrbeonXPathFormReader for: xmlString.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/16/2015 13:57'!
getAllDraftsFor: user orGroup: group
	"The receiver answer all current saved drafts of with username <user> or groupname <group>"
	| allDrafts |

	allDrafts := OrderedCollection new.

	drafts do: [:collection | allDrafts addAll: (collection select: [:each | each username = user or: [each groupname = group]])].

	^allDrafts! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getAllDraftWithId: aString ifNone: aBlock

	^drafts at: aString ifAbsent: [^aBlock value]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getAllSectionsIn: anOrderedCollection

	anOrderedCollection addAll: sectionDefinitions.

	sectionDefinitions do: [:each | 
		each getAllSectionsIn: anOrderedCollection].

	^anOrderedCollection! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/05/2015 09:01'!
getAttachmentFieldNames
	"The receiver answer a collection of <Strings> where each string is the name of a attachment field"

	^self getAttachmentFields collect: [:each | each name]! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:51'!
getAttachmentFields
	"The receiver answer a collection of <FormFieldDefinition> where each field is an attachment component"

	^self fieldDefinitions select: [:each | each isAttachmentField]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 03/20/2016 15:57'!
getAttachmentIdFor: fieldName

	^attachments at: fieldName ifAbsent: [nil]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getDraftWithId: aString

	^(drafts at: aString ifAbsent: [^nil]) last! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/06/2015 16:15'!
getDraftWithId: aString ifNone: aBlock
	| currentDrafts |

	currentDrafts := drafts at: aString ifAbsent: [^aBlock value].

	currentDrafts isEmpty ifTrue: [^aBlock value].

	^currentDrafts last! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:15'!
getFieldNamed: fieldName

	^self getFieldNamed: fieldName ifNone: [nil]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getFieldNamed: aString ifNone: aBlock

	^self fieldDefinitions detect: [:each | each name = aString] ifNone: aBlock! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
getFieldsNames
	"The receiver answer a collection of field definitions. Iterate over embedded sections"

	^self fieldDefinitions collect: [:each | each name]! !

!OrbeonFormDefinition methodsFor: 'test' stamp: 'BrunoBB 09/04/2015 13:34'!
getFieldsWithHyphen
	"Answer a collection with field that it's name includes '-' (Hyphen character).
	This is used for the Form Workflow when evaluating a expression. 
	If the form name includes '-' (Hyphen character) the evaluation will fail.

	Example (without hyphen): [:form | form age > 20]
	
	Example (with hyphen): [:form | form person-age > 20] - this will fail because '-' is a unary message, the correct is:

	[:form | (form perform: 'person-age') > 20]

	When importing Form Definitions from Orbeon if any field name has a hyphen --> we must show a warning to the user"


	^self fieldDefinitionSelect: [:each | each name includes: $-]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getFirstInstance

	instances isEmpty ifTrue: [^nil].

	^self getInstanceWithId: instances keys asOrderedCollection first! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/04/2015 13:34'!
getInstancesSatisfying: aBlock in: fieldName

	^((fieldInstances at: fieldName ifAbsent: [^OrderedCollection new]) select: aBlock) asOrderedCollection collect: [:each | each form]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getInstanceWithId: aString

	^instances at: aString ifAbsent: [nil]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getInstanceWithId: aString ifNone: aBlock

	^instances at: aString ifAbsent: aBlock! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
getMandatoryFieldsMissing
	"Answer a collection of mandatory fields missing needed to use Orbeon Form Processes.
	All these fields must be included in the Orbeon Form Definition in order the Form Worflow work correctly"
	| missingManFields |

	missingManFields := OrderedCollection new.

	self getFieldNamed: 's' ifNone: [missingManFields add: 's'].
	self getFieldNamed: 'k' ifNone: [missingManFields add: 'k'].
	self getFieldNamed: 'oop' ifNone: [missingManFields add: 'oop'].
	self getFieldNamed: 'uuid' ifNone: [missingManFields add: 'uuid'].
	self getFieldNamed: 'assignmentOop' ifNone: [missingManFields add: 'assignmentOop'].
	self getFieldNamed: 'username' ifNone: [missingManFields add: 'username'].
	self getFieldNamed: 'rol' ifNone: [missingManFields add: 'rol'].
	self getFieldNamed: 'formId' ifNone: [missingManFields add: 'formId'].

	^missingManFields! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
gridDefinitions
	"Answer a collection with all grid definitions <FormGridDefinition> of the receiver. It collect all grids from Section Definitions"
	| grids |

	grids := OrderedCollection new.

	sectionDefinitions do: [:each | grids addAll: each gridDefinitions].

	^grids! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
gridDefinitionsNames
	"Answer a collection with all grid definitions names of the receiver."

	^self gridDefinitions collect: [:each | each name]! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
hasCreatePermission: roleName

	^self hasPermission: 'create' for: roleName! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
hasDeletePermission: roleName

	^self hasPermission: 'delete' for: roleName! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
hasInstances

	^true! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
hasPermission: permissionName for: roleName
	"Answer whether or not the role named <roleName> has the permission named <permissionName> in the receiver"
	
	^permissions has: roleName permission: permissionName! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
hasRangeSearch: attributeName
	| type |

	type := fieldsType at: attributeName ifAbsent: [^false].

	(type = 'xf:string') ifTrue: [^false].
	(type = 'xf:email') ifTrue: [^false].
	(type = 'xf:boolean') ifTrue: [^false].

	^true! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
hasReadPermission: roleName

	^self hasPermission: 'read' for: roleName! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
hasUpdatePermission: roleName

	^self hasPermission: 'update' for: roleName! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
includesSectionDefinition: aFormSectionDefinition

	^sectionDefinitions includes: aFormSectionDefinition! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 03/20/2016 15:55'!
initialize

	super initialize.

	isPublished := false.
	instances := RcKeyValueDictionary new. "hold instances by <id>, more easy to perform the synchronization"
	drafts := RcKeyValueDictionary new. 
	fieldInstances := RcKeyValueDictionary new. "a rc dictionary (by field name) of RcIdentityBag"
	synchronizations := OrderedCollection new.
	fieldsType := Dictionary new.
	permissions := Dictionary new.
	sectionDefinitions := Dictionary new.
	attachments := Dictionary new.! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
instanceDefinition

   "Return the value of the instance variable 'instanceDefinition'."
   ^instanceDefinition! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
instanceDefinition: newValue

   "Modify the value of the instance variable 'instanceDefinition'."
   instanceDefinition := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
instanceDefinitionId

	^id! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
instances

   "Return the value of the instance variable 'instances'."
   ^instances! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
instances: newValue

   "Modify the value of the instance variable 'instances'."
   instances := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
isInEdition

	^(modifiedTime time subtractTime: instanceDefinition  modifiedTime time) asSeconds > 12! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
isOutdatedOn: aTimeStamp
	"Answer whether or not the receiver is out of date on date <aTimeStamp>.
	<aTimeStamp> is obtained from the database and is the last version."

	synchronizations isEmpty ifTrue: [^true].

	^aTimeStamp ~= modifiedTime "modifiedTime - is set with db values, generally modifiedTime is equal to db def last version "! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
isPublished
	^isPublished! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
isPublished: newValue
	isPublished := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/28/2015 16:20'!
isSearchField: fieldName
	"Answer whether or not the field named <fieldName> is a search field"

	^self searchFields includes: fieldName! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
labelAt: key
	"The receiver answer the label associated with field name <key>"

	^labels at: key ifAbsent: [^'No Label'].! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
labels

   "Return the value of the instance variable 'labels'."
   ^labels! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
labels: newValue

   "Modify the value of the instance variable 'labels'."
   labels := newValue! !

!OrbeonFormDefinition methodsFor: 'synchronize' stamp: 'BrunoBB 09/04/2015 13:34'!
lastSynchronizationIfNone: aBlock
	"The receiver answer the last synchronization object for the application <appName> and the form <formName> if none evaluates <aBlock>"

	synchronizations isEmpty ifTrue: [^aBlock value].
	^synchronizations last! !

!OrbeonFormDefinition methodsFor: 'type-mapping' stamp: 'BrunoBB 12/26/2015 15:36'!
mapOrbeonType: typeString
	"The receiver map the Orbeon type string <typeString> to a GemStone class subclass of <FormFieldValue>"

	^self class mapDictionary at: typeString ifAbsent: [AppFieldStringValue]! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
migratePermissions
	"This method was used to migrate the old permission structure to the new permissions structure (class OrbeonPermissions)"
	| newPermissions |

	newPermissions := OrbeonPermissions new.

	permissions keysAndValuesDo: [:keyStringPermission :arrayRole | 
		newPermissions addAll: (keyStringPermission subStrings: ' ') toAll: arrayRole.
	].

	"permissions := newPermissions. "

	^newPermissions! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 08:12'!
newFormReader
	"Answer <anOrbeonFormReader> to get values from the XML document of the receiver"

	"^OrbeonFormReader for: xmlString."

	^OrbeonXPathFormReader for: xmlString.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
normalSections

	^sectionDefinitions reject: [:each | each isRepeatable]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
normalSectionsNames

	^self normalSections collect: [:each | each name]! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/04/2015 13:34'!
numberOfFieldInstances

	^fieldInstances inject: 0 into: [:sum :each | sum + each size]! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/04/2015 13:34'!
numberOfInstances

	^instances size! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
permissions

   "Return the value of the instance variable 'permissions'."
   ^permissions! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
permissions: newValue

   "Modify the value of the instance variable 'permissions'."
   permissions := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
permissionsCollection
	| permissionCollection |

	permissionCollection  := OrderedCollection new.
	permissions keysAndValuesDo: [:key :value | | grantString |
		grantString := key, ' >> '.
		value do: [:each | grantString := grantString, each, ', '].
		permissionCollection add: (grantString allButLast: 2).
	].

	^permissionCollection! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 17:30'!
printCompleteCustomAttachmentId

		^id, '-', self printCustomAttachmentId! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 10/14/2015 17:29'!
printCustomAttachmentId

		^(customAttachment subStrings: '/') last! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
printStructure
	| stream |

	stream := PrintStream on: String new.

	self printStructureOn: stream.

	^stream contents! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
printStructureOn: aPrintStream
	"Print the structure of the receiver on stream <aPrintStream>. Iterate over receiver's section definitions"

	aPrintStream nextPutAll: '<', app, '.', form,'>'.
	aPrintStream nextPutAll: String lf.

	sectionDefinitions do: [:eachSection | 	eachSection printStructureOn: aPrintStream count: 1].! !

!OrbeonFormDefinition methodsFor: 'process xml' stamp: 'BrunoBB 09/05/2015 16:32'!
processXMLDefinition
	"This is a time consuming operation. Uses a XML Parser to get data from <xmlString> variable"
	| reader |

	reader := self newFormReader.
	labels := reader formFieldsLabels. 						"answer: aDictionary (key: field name value: label)"
	permissions := reader getPermissions. 						"answer: aDictionary (key: permission name value: collection of rols)"
	fieldsType := reader getFieldTypes.						"answer: aDictionary (key: field name value: field type)"

	customAttachment := reader getCustomAttachmentId. "set the id of the custom pdf of the receiver"
	self createSectionsDefinitionWith: reader.

	self attachments: (reader getAttachmentIdsFrom: self).
	^self! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 10/06/2015 15:32'!
publish

	self available: 'true'.
	isPublished := true.

	instanceDefinition draft: 'N'.
	instanceDefinition isPublished: true.
	instanceDefinition version: version.
	instanceDefinition xmlString: xmlString.
	instanceDefinition definition: self.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 02/10/2016 10:56'!
rawExport
"
|fs |
fs := FileStream write: '/tmp/export.csv'.

instances asArray first getAllFields keysAndValuesDo: [:key :v |  | lab |
	lab := self labelAt: key.
	lab := lab copyWithoutAll: String lf.
	fs nextPutAll: lab.
	fs nextPutAll: String tab].
fs nextPutAll: String lf.
instances asArray first getAllFields keysAndValuesDo: [:key :v | 
	fs nextPutAll: key.
	fs nextPutAll: String tab].
fs nextPutAll: String lf.
instances do: [:e | 
	e getAllFields keysAndValuesDo: [:fieldName :col |
		fs nextPutAll: col last.
		fs nextPutAll: String tab.
	].
	fs nextPutAll: String lf.
].
fs flush; close."! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:13'!
removeDraft: anOrbeonFormInstance

	"anOrbeonFormInstance definition: nil."

	(drafts includesKey: anOrbeonFormInstance id) ifFalse: [^anOrbeonFormInstance].

	(drafts at: anOrbeonFormInstance id) remove: anOrbeonFormInstance ifAbsent: [].

	(drafts at: anOrbeonFormInstance id) isEmpty ifTrue: [drafts removeKey: anOrbeonFormInstance id].

	^anOrbeonFormInstance! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/04/2015 13:34'!
removeFieldInstance: aFormFieldValue

	(fieldInstances includesKey: aFormFieldValue name) ifFalse: [^aFormFieldValue].

	^(fieldInstances at: aFormFieldValue name) remove: aFormFieldValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
removeInstance: anOrbeonFormInstance

	anOrbeonFormInstance definition: nil.
	^instances removeKey: anOrbeonFormInstance id! !

!OrbeonFormDefinition methodsFor: 'permissions' stamp: 'BrunoBB 09/04/2015 13:34'!
removePermission: permissionName to: roleName
	"The receiver removes the permission <permissionName> from the role <roleName>"

	^permissions remove: permissionName from: roleName! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
removeSectionDefinition: aFormSectionDefinition

	^sectionDefinitions remove: aFormSectionDefinition ifAbsent: []! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
renameFieldNamed: fieldName to: newName
	"Change the name of the field named <fieldName> to a new name <newName>
	1. Change the field name of the Definition (check summary and search field)
	2. Change the field name of all Instances of the definition
	"! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
repeatSections

	^sectionDefinitions select: [:each | each isRepeatable]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
resetDrafts

	drafts := RcKeyValueDictionary new.! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/04/2015 13:34'!
resetInstances

		instances := RcKeyValueDictionary new.
		fieldInstances := Dictionary new.! !

!OrbeonFormDefinition methodsFor: 'synchronize' stamp: 'BrunoBB 09/04/2015 13:34'!
resetSynchronizations
	"Reset all synchronization of the receiver. Used at the initial fase of the synchronization"

	synchronizations := OrderedCollection new.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 17:11'!
searchFields
	| searchs |

	searchs := OrderedCollection new.
	sectionDefinitions do: [:eachDef | searchs addAll: (eachDef searchFields collect: [:each | each name])].

	^searchs! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 09/04/2015 13:34'!
searchFormWithAttribute: attrName value: attrValue
	| collection |

	collection := fieldInstances at: attrName ifAbsent: [^OrderedCollection new].

	^(collection select: [:each | each value = attrValue]) asOrderedCollection! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
sectionDefinitions

   "Return the value of the instance variable 'sectionDefinitions'."
   ^sectionDefinitions! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
sectionDefinitions: newValue

   "Modify the value of the instance variable 'sectionDefinitions'."
   sectionDefinitions := newValue! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
sectionNamed: aString

	^sectionDefinitions at: aString ifAbsent: [nil]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
sectionsNames

	^(self sectionDefinitions collect: [:each | each name]) asSortedCollection! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
selectFieldDefinition: aBlock

	^self fieldDefinitions select: aBlock! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
setAvailableNodeWith: aBooleanString
	| xmlDoc metadata available newXML |

	xmlDoc := XMLDOMParser parse: xmlString.
	metadata := xmlDoc allElementsNamed: 'metadata'.
	metadata isEmpty ifTrue: [^self].
	metadata := metadata last.

	metadata removeNodes: (metadata allElementsNamed: 'available').

	available := XMLElement named: 'available'.
	available addContent: aBooleanString.
	metadata addNode: available.

	newXML := String new.
	xmlDoc printOn: (PrintStream on: newXML).
	xmlString := newXML.! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:24'!
setMetadata
	| reader |

	reader := self newFormReader.
	app := reader getApplicationName.
	form := reader getFormName.
	self setProperty: 'title' with: reader getTitle.
	self setProperty: 'description' with: reader getDescription.! !

!OrbeonFormDefinition methodsFor: 'type-mapping' stamp: 'BrunoBB 02/17/2016 12:55'!
stTypeOf: attributeName
	"Answer the type (Smalltalk class) of the for the field named <attributeName> if field name is absent answer nil"

	^(self classOf: attributeName) stType! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
summaryFields
	"Answer a collection with all field names that are the summary of the receiver"
	| summaries |

	summaries := OrderedCollection new.
	sectionDefinitions do: [:eachDef | summaries addAll: (eachDef summaryFields collect: [:each | each name])].

	^summaries! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
switchAvailable

	(self available = 'true') 
	ifTrue: [self unpublish.
		^self available: 'false'].

	self setAvailableNodeWith: 'true'.
	^self available: 'true'! !

!OrbeonFormDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 09/04/2015 13:34'!
synchronizations

   "Return the value of the instance variable 'synchronizations'."
   ^synchronizations! !

!OrbeonFormDefinition methodsFor: 'Updating' stamp: 'BrunoBB 09/04/2015 13:34'!
synchronizations: newValue

   "Modify the value of the instance variable 'synchronizations'."
   synchronizations := newValue! !

!OrbeonFormDefinition methodsFor: 'type-mapping' stamp: 'BrunoBB 09/04/2015 13:34'!
typeOf: attributeName
	"Answer the type of the for the field named <attributeName> if field name is absent answer nil"

	^fieldsType at: attributeName ifAbsent: [nil]! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 09/04/2015 13:34'!
unpublish

	^self setAvailableNodeWith: 'false'! !

!OrbeonFormDefinition methodsFor: 'field instances' stamp: 'BrunoBB 02/11/2016 11:46'!
updateFieldInstancesFrom: aFieldValueHolder
	"The receiver update the field's values <FormFieldValue> in the holder <aFieldValueHolder> and mark it as processed.
	The collections <aFieldValueHolder toAdd> and <aFieldValueHolder toRemove> are complemtary, so if one has elements then the other is empty and viceversa. 
	<aFieldValueHolder> is used for repeatable fields with indexes. If a value is removed from the repeatable field --> must be removed from the index collection. <FieldValueHolder> class track these changes"

	aFieldValueHolder alreadyAddedToFormDefinition 
	ifFalse: [aFieldValueHolder alreadyAddedToFormDefinition: true.
		^aFieldValueHolder currentValues do: [:each | self addFieldInstance: each]]. "executed only once"

	"values has been added to the field after a edit operation"
	aFieldValueHolder toAdd do: [:each | self addFieldInstance: each].

	"values has been removed to the field after a edit operation"
	aFieldValueHolder toRemove do: [:each | self removeFieldInstance: each]. 

"	aFieldValueHolder alreadyAddedToFormDefinition: true."! !

!OrbeonFormDefinition methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 14:04'!
updateFrom: dbArray
	"The receiver update it's self using an update row <dbArray> of the database "

	createdTime := TimeStamp fromMySqlString: dbArray first.
	modifiedTime := TimeStamp fromMySqlString: dbArray second.
	modifiedUser := dbArray third.
	deleted := dbArray at: 6.
	version := Integer fromString: (dbArray at: 7).
	xmlString := dbArray at: 8.

	^self! !

OrbeonForm subclass: #OrbeonFormInstance
	instanceVariableNames: 'draft username groupname fields definition fieldsValues repeatFieldsValues sections externalOwner isValid assignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonFormInstance commentStamp: 'BrunoBB 11/24/2014 05:12' prior: 0!
This class has Orbeon Form Instance. Orbeon Form Instances are always created in the NEW link of Orbeon Form.

Instances of this class represent Forms being filled by users and sent to be processed.

username 				- username of the user that filled the form (mysql).
groupname 				- groupname of the user (mysql).
fields              			- aDictionary where each key is a field name and each value is a string value of the field.
definition 				- the OrbeonFormDefinition of the receiver.
fieldsValues 			- aDictionary where each key is the field name and each value is a AppFieldValueHolder.
repeatFieldsValues 	- aDictionary with the repeats components of the form and it's values.
sections					- aDictionary with the section components of the form and it's values.
externalOwner		- an external owner to be used by third parties packages as Orbeon Form Processes where the <externalOwner> is an OrbeonFormTransition. 

externalOwner:
Using this variable third party packages can use the service layer of Orbeon Form to query forms with some values and after the result (collection of OrbeonFormInstance) collect <externalOwner> variable to access to the specific domain object.!

!OrbeonFormInstance class methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
app: app form: form id: formId

	^(super app: app form: form)
		id: formId;
		yourself! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
addToDefinition

	^definition addInstance: self! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
assignment
	^assignment! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
assignment: newValue
	assignment := newValue! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/17/2016 12:41'!
classOf: attributeName
	"Answer a Smalltalk class that represent the Orbeon type of the field named <attributeName>.
	1. Get the type of the attribute named <attributeName>
	2. Map the type of 1 with a Smalltalk class"

	^definition classOf: attributeName! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
cloneForAudit
	"The receiver answer a new cloned instance of it's self for audit purpose.
	The section structure is NOT cloned but can be reconstructed from <xmlString>"
	| clone |

	clone := self cloneForAudit.
	clone username: username;
		groupname: groupname;
		draft: draft;
		isValid: isValid.

	^clone! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
definition

   "Return the value of the instance variable 'definition'."
   ^definition! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
definition: newValue

   "Modify the value of the instance variable 'definition'."
   definition := newValue! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
definitionId
	"Answer the id of the form definition"

	^definition id! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
doesNotUnderstand: aMessageDescriptor
	"The receiver overide this method in order to respond to messages that are equal in name to any of it's field name"

	^(self hasFieldNamed: aMessageDescriptor selector)
	ifTrue: [(self valueAt: aMessageDescriptor selector asString) value]
	ifFalse: [super doesNotUnderstand: aMessageDescriptor]! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
draft
	^draft! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
draft: newValue
	draft := newValue! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
externalOwner

   "Return the value of the instance variable 'externalOwner'."
   ^externalOwner! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
externalOwner: newValue

   "Modify the value of the instance variable 'externalOwner'."
   externalOwner := newValue! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
fields

   "Return the value of the instance variable 'fields'."
   ^fields! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
fields: newValue

   "Modify the value of the instance variable 'fields'."
   fields := newValue! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
fieldsValues

   "Return the value of the instance variable 'fieldsValues'."
   ^fieldsValues! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
fieldsValues: newValue

   "Modify the value of the instance variable 'fieldsValues'."
   fieldsValues := newValue! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/14/2016 13:13'!
fieldValueAt: fieldName

	^fieldsValues at: fieldName ifAbsent: [nil]! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
fieldValuesDo: aBlock
	"The receivet iterate over the fields collection <fieldsValues> and apply the one argument <aBlock> in each iteration"

	^fieldsValues do: aBlock! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
generateFormFieldValueSet
	"The receiver create an IdentitySet <fieldsValues> of form field values <FormFieldValue>. 
	It creates one element <instance subclass of FormFieldValue> per field in the original XML form."

	"#getAllFields answer aDictionary where each key is the name of the field and each value is a collection of string values"
	self getAllFields keysAndValuesDo: [:key :valuesCollection | | valueHolder |
			valueHolder := (fieldsValues includesKey: key) "<fieldsValues at:> answer aFieldValueHolder"
								ifFalse: [fieldsValues at: key put: (OrbeonFieldValueHolder forFieldNamed: key)]
								ifTrue: [fieldsValues at: key].
			"convert string values to real type values or update added/removed values"
			valueHolder processFieldValueCollection: valuesCollection withFieldClass: (self classOf: key) in: self.
			definition updateFieldInstancesFrom: valueHolder. "update general index collection of the OrbeonFormDefinition"

	].
"	self getAllGrids do: [:gridIteration | 
		gridIteration keysAndValuesDo: [:key :value | | formFieldValue |
			(fieldsValues includesKey: key)
				ifTrue: [(fieldsValues at: key) form: self; originalValue: value; setValue: value.]
				ifFalse: [formFieldValue := (self classOf: key) form: self name: key value: value.
					fieldsValues at: key put: formFieldValue.
					definition addFieldInstance: formFieldValue].
		]]."
	^fieldsValues! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
getAllFields
	"The receiver answer a Dictionary with ALL fields (including nested sections) where the key is the field name and the value is the collection of fields value. 
	If collection size = 0 --> empty collection, 
	if the collection size = 1 --> simple field, 
	otherwise a field inside a repeat component"
	| allFields |

	allFields := Dictionary new.

	self getAllSections do: [:eachSection | 
		eachSection fields keysAndValuesDo: [:fieldName :fieldValue |
			(allFields includesKey: fieldName)
			ifTrue: [(allFields at: fieldName) add: fieldValue]
			ifFalse: [allFields at: fieldName put: (OrderedCollection with: fieldValue)]].
		eachSection grids do: [:eachGrid | 
			eachGrid gridIterations do: [:dictIteration | 
				dictIteration keysAndValuesDo: [:fieldName :fieldValue |
					(allFields includesKey: fieldName)
					ifTrue: [(allFields at: fieldName) add: fieldValue]
					ifFalse: [allFields at: fieldName put: (OrderedCollection with: fieldValue)]
					]]]].
	^allFields! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
getAllGrids
	"The receiver answer an OrderedCollection with ALL Grids (including nested sections) where each element is a Dictionary.
	Each Dictionary represent a Grid Iteration, where the key is the field name and the value is the field value"
	| allGrids |

	allGrids := OrderedCollection new.

	self getAllSections do: [:eachSection | 
		eachSection grids do: [:eachGrid | allGrids addAll: eachGrid gridIterations].].

	^allGrids! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
getAllSections
	"Answer all sections <FormSectionInstance> of the receiver "

	^self getAllSectionsIn: OrderedCollection new! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
getAllSectionsIn: anOrderedCollection
	"Answer all sections of the receiver in parameter <anOrderedCollection>"

	sections do: [:each | 
		each getAllSectionsIn: anOrderedCollection].

	^anOrderedCollection! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
getAttachmentFieldNames
	"Answer a collection of names where each name is a <FormFieldDefinition> that represent an attachment component"

	^definition getAttachmentFieldNames! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
getAttachmentIds
	"Answer a collection with all IDs of receiver's attachments.
	The attachment's names: <instanceId>-<fileId> "

	^((self getAttachmentFieldNames collect: [:each | self valueAt: each]) reject: [:each | each isNil])
			collect: [:each | id, '-', (each subStrings: '/') last] "<instanceId>-<fileId> "! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getComplexSections

	^sections select: [:each | each isComplex]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getComplexSectionsWithGrids

	^sections select: [:each | each isComplexWithGrids]! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
getFields
	"This method does NOT includes repeat values and repeat sections, for that see #getAllFields in this class
	The receiver answer a Dictionary with fields (including nested sections) where the key is the field name and the value is the field value."
	| allFields |

	allFields := Dictionary new.

	self getAllSections do: [:each | allFields addAll: each fields].

	^allFields! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
getPermissionsForUser: user inGroup: group with: formDefinition
	"The receiver answer a collection of permissions (a string separated by blanks) for the user <username> and group <group> using the form definition <formDefinition> to get the current permissions to apply.
	To calculate permissions we use the last version of OrbeonFormDefinition and NOT the <formInstance definition>.
	If not --> is not possible to change permission of a given instance if the definition version is higher that the instance version.
	Using the last version of OrbeonFormDefinition to calculate permissions --> all instance are affected by the change"
	| printStream |

	printStream := PrintStream on: String new.

	((self hasUser: user createAccessUsing: formDefinition permissions) 
	or: [self hasRole: group createAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'create '].

	((self hasUser: user readAccessUsing: formDefinition permissions) 
	or: [self hasRole: group readAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'read '].

	((self hasUser: user updateAccessUsing: formDefinition permissions) 
	or: [self hasRole: group updateAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'update '].

	((self hasUser: user deleteAccessUsing: formDefinition permissions) 
	or: [self hasRole: group deleteAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'delete '].

	^printStream contents! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getRepeatableComplexSections

	^sections select: [:each | each isRepeatableComplex]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getRepeatableComplexSectionsWithGrids

	^sections select: [:each | each isRepeatableComplexWithGrids]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getRepeatableSimpleSections

	^sections select: [:each | each isRepeatableSimple]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getRepeatableSimpleSectionsWithGrids

	^sections select: [:each | each isRepeatableSimpleWithGrids]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getSectionsToExport

	^self getSimpleSections,
		self getSimpleSectionsWithGrids,
		self getComplexSections,
		self getComplexSectionsWithGrids,
		self getRepeatableSimpleSections,
		self getRepeatableSimpleSectionsWithGrids,
		self getRepeatableComplexSections,
		self getRepeatableComplexSectionsWithGrids! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getSimpleSections

	^sections select: [:each | each isSimple]! !

!OrbeonFormInstance methodsFor: 'get sections' stamp: 'BrunoBB 02/11/2016 11:56'!
getSimpleSectionsWithGrids

	^sections select: [:each | each isSimpleWithGrids]! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 04/03/2016 18:42'!
getSubSectionIndexOf: aFormSectionInstance

	^((sections select: [:each | each name = aFormSectionInstance name]) indexOf: aFormSectionInstance ifAbsent: [0]) printString! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
getValueOfFields: collectionOfFieldNames

	^collectionOfFieldNames collect: [:each | self valueAt: each]! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
groupname

   "Return the value of the instance variable 'groupname'."
   ^groupname! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
groupname: newValue

   "Modify the value of the instance variable 'groupname'."
   groupname := newValue! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasExternalOwner

	^externalOwner notNil! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasFieldNamed: aSymbol
	"Answer whether or not the receiver has a field named <aSymbol>"

	^(self getFields includesKey: aSymbol asString) 
		or: [self getAllGrids anySatisfy: [:each | each includesKey: aSymbol asString] ]! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasRole: aRoleName createAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	(groupname = aRoleName) ifFalse: [^anOrbeonPermissions hasCreateAccess: aRoleName].

	^anOrbeonPermissions hasCreateAccess: 'group-member'! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasRole: aRoleName deleteAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	(groupname = aRoleName) ifFalse: [^anOrbeonPermissions hasDeleteAccess: aRoleName].

	^anOrbeonPermissions hasDeleteAccess: 'group-member'! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasRole: aRoleName readAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	(groupname = aRoleName) ifFalse: [^anOrbeonPermissions hasReadAccess: aRoleName].

	^anOrbeonPermissions hasReadAccess: 'group-member'! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasRole: aRoleName updateAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	(groupname = aRoleName) ifFalse: [^anOrbeonPermissions hasUpdateAccess: aRoleName].

	^anOrbeonPermissions hasUpdateAccess: 'group-member'! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasUser: aUserName createAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	^(aUserName = username) and: [anOrbeonPermissions hasCreateAccess: 'owner']! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasUser: aUserName deleteAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	^(aUserName = username) and: [anOrbeonPermissions hasDeleteAccess: 'owner']! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasUser: aUserName readAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	^(aUserName = username) and: [anOrbeonPermissions hasReadAccess: 'owner']! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
hasUser: aUserName updateAccessUsing: anOrbeonPermissions

	anOrbeonPermissions isEnabled ifFalse: [^true]. "if permissions are NOT enabled then it has ALL permissions"

	^(aUserName = username) and: [anOrbeonPermissions hasUpdateAccess: 'owner']! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
initialize

	super initialize.

	draft  := 'N'.
	username := ''.
	groupname := ''.
	fields := Dictionary new.
	fieldsValues := Dictionary new.
	repeatFieldsValues := IdentitySet new. 
"<repeatFieldsValues> is an IdentitySet of where each key is the name of the repeat component and the value is anOrderedCollection of Dictionaries. Where each Dictonary holds the data of each individual repeat "
	sections := Dictionary new.
	isValid := false.! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
isAttachmentField: fieldName
	"Answer whether or not the field named <fieldName> is an attachment field"

	^(definition getFieldNamed: fieldName) isAttachmentField! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
isValid

   "Return the value of the instance variable 'isValid'."
   ^isValid! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
isValid: newValue

   "Modify the value of the instance variable 'isValid'."
	newValue isString ifTrue: [^isValid := self evaluate: newValue].
 
	isValid := newValue! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
labelAt: key
	"Answer the label of field named <key> if none answer 'No Label' "

	^definition labelAt: key! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 08:14'!
newFormReader
	"Answer <anOrbeonFormReader> to get values from the XML document of the receiver"

	^OrbeonXPathFormReader for: definition xmlString with: xmlString! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
printDraft

	(draft = 'N') ifTrue: [^'false'].

	^'true'! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
printStructure
	| stream |

	stream := PrintStream on: String new.

	self printStructureOn: stream.

	^stream contents! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
printStructureOn: aPrintStream
	"Print the structure of the receiver on stream <aPrintStream>. Iterate over receiver's section instances"

	aPrintStream nextPutAll: '<', app, '.', form,'>'.
	aPrintStream nextPutAll: String lf.

	sections do: [:eachSection | eachSection printStructureOn: aPrintStream count: 1].! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
process

	^externalOwner process! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/23/2016 08:34'!
processXML
	"Set the values of receiver field's from <xmlString> using an orbeon form reader.
	The receiver has a dictionary (fieldName>value) to hold fields."

	self processXMLSections. "Create the GS Sections from the XML string"

	definition addInstance: self.

	self generateFormFieldValueSet. "store field values as instance of <FormFieldValue>"

	^fields! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 04/02/2016 10:06'!
processXMLSections
	"Set the values of receiver field's from <xmlString> using an orbeon form reader."

	sections := self newFormReader createSectionsInstancesWith: definition.
	
	sections do: [:each | each formInstance: self].! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
repeatFieldsValues

   "Return the value of the instance variable 'repeatFieldsValues'."
   ^repeatFieldsValues! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
repeatFieldsValues: newValue

   "Modify the value of the instance variable 'repeatFieldsValues'."
   repeatFieldsValues := newValue! !

!OrbeonFormInstance methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:56'!
satisfyQuery: collectionOfOrbeonQueryNode
	"Answer whether or not the receiver satisfy the query node <OrbeonQueryNode> in collection <collectionOfOrbeonQueryNode>.
	The search is AND"
	| queryFields |

	"collect the values of each field contained in <collectionOfOrbeonQueryNode>"
	queryFields := self getValueOfFields: (collectionOfOrbeonQueryNode collect: [:each | each name]).

	"all satisfy node value = field value (AND)"
	collectionOfOrbeonQueryNode keysAndValuesDo: [:index :node |
		(node value = (queryFields at: index)) ifFalse: [^false]].


	^true! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
sections

   "Return the value of the instance variable 'sections'."
   ^sections! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
sections: newValue

   "Modify the value of the instance variable 'sections'."
   sections := newValue! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
typeOf: attributeName
	"Answer the type of the field named <attributeName> if field name is absent answer nil"

	^definition typeOf: attributeName! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
updateFrom: dbArray
	"The receiver update it's self using an update row <dbArray> of the database "

	createdTime := TimeStamp fromMySqlString: dbArray first.
	modifiedTime := TimeStamp fromMySqlString: dbArray second.
	modifiedUser := dbArray third.
	id := dbArray at: 6.
	deleted := dbArray at: 7.
	xmlString :=  dbArray at: 8.
	username :=  dbArray at: 9.
	groupname :=  dbArray at: 10.
	version := Integer fromString: (dbArray at: 11).
	^self! !

!OrbeonFormInstance methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:56'!
username

   "Return the value of the instance variable 'username'."
   ^username! !

!OrbeonFormInstance methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:56'!
username: newValue

   "Modify the value of the instance variable 'username'."
   username := newValue! !

!OrbeonFormInstance methodsFor: 'form-field-value' stamp: 'BrunoBB 02/11/2016 11:56'!
valueAt: fieldName
	"The receiver answer the value of the field named <fieldName> if none answer nil"
	| value |

	self getAllSections do: [:each | value := each fieldValueAt: fieldName.
		value ifNotNil: [^value]].

	^nil! !

OrbeonForm subclass: #OrbeonFormInstanceDefinition
	instanceVariableNames: 'definition draft username groupname isPublished'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 09/05/2015 16:47'!
attachments

	definition ifNil: [^#()].

	^definition attachments! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:39'!
cloneForAudit
	"The receiver answer a new cloned instance of it's self for audit purpose.
	The section structure is NOT cloned but can be reconstructed from <xmlString>"
	| clone |

	clone := self cloneForAudit.
	clone username: username;
		groupname: groupname;
		isPublished: isPublished;
		draft: draft.

	^clone! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 08/30/2015 14:22'!
createOrbeonFormDefinition

	^OrbeonFormDefinition new
		id: id;
		app: app;
		form: form;
		xmlString: xmlString;
		isPublished: false;
		yourself! !

!OrbeonFormInstanceDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/27/2015 11:35'!
definition
	^definition! !

!OrbeonFormInstanceDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/27/2015 11:35'!
definition: newValue
	definition := newValue! !

!OrbeonFormInstanceDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/27/2015 11:35'!
draft
	^draft! !

!OrbeonFormInstanceDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/27/2015 11:35'!
draft: newValue
	draft := newValue! !

!OrbeonFormInstanceDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/27/2015 11:35'!
groupname
	^groupname! !

!OrbeonFormInstanceDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/27/2015 11:35'!
groupname: newValue
	groupname := newValue! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 08/27/2015 11:35'!
hasInstances

	^false! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 09/02/2015 14:12'!
initialize

	super initialize.

	isPublished := false.
	draft := 'N'.! !

!OrbeonFormInstanceDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/27/2015 11:35'!
isPublished
	^isPublished! !

!OrbeonFormInstanceDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/27/2015 11:35'!
isPublished: newValue
	isPublished := newValue! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 08:14'!
newFormReader
	"Answer <anOrbeonFormReader> to get values from the XML document of the receiver"

	^OrbeonXPathFormReader for: definition xmlString with: xmlString! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 08/30/2015 16:29'!
printDraft

	(draft = 'N') ifTrue: [^'false'].

	^'true'! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 08/30/2015 14:26'!
processXMLDefinition

	definition ifNil: [^self].

	definition processXMLDefinition! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 13:24'!
setMetadata
	| reader |

	reader := self newFormReader.
	app := reader getApplicationName.
	form := reader getFormName.
	self setProperty: 'title' with: reader getTitle.
	self setProperty: 'description' with: reader getDescription.! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 09/05/2015 16:40'!
setXmlString: aString

	xmlString := aString.

	definition 
		ifNil: [definition := self createOrbeonFormDefinition.
				definition instanceDefinition: self].

	definition xmlString: xmlString.! !

!OrbeonFormInstanceDefinition methodsFor: 'other' stamp: 'BrunoBB 10/16/2015 12:24'!
updateFrom: dbArray
	"The receiver update it's self using an update row <dbArray> of the database "

	createdTime := TimeStamp fromMySqlString: dbArray first.
	modifiedTime := TimeStamp fromMySqlString: dbArray second.
	id := dbArray third.
	modifiedUser := dbArray fourth notEmpty ifTrue:[dbArray fourth allButFirst] ifFalse: [''].
	username := dbArray fifth notEmpty ifTrue:[dbArray fifth allButFirst] ifFalse: [''].
	groupname := (dbArray at: 6) notEmpty ifTrue:[(dbArray at: 6) allButFirst] ifFalse: [''].
	xmlString := dbArray at: 7.

	^self! !

!OrbeonFormInstanceDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 08/27/2015 11:35'!
username
	^username! !

!OrbeonFormInstanceDefinition methodsFor: 'Updating' stamp: 'BrunoBB 08/27/2015 11:35'!
username: newValue
	username := newValue! !

OrbeonObject subclass: #OrbeonFormUserOptions
	instanceVariableNames: 'orbeonWebIsLinked languageName initialTransitionDisplayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
initialize

	super initialize.

	"true - WALinkedAssignmentManager, false - WAEmbeddedAssignmentManager"
	orbeonWebIsLinked := true.
	languageName := #english.
	initialTransitionDisplayMode := #expanded.! !

!OrbeonFormUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 12:23'!
languageName
	^languageName! !

!OrbeonFormUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 12:23'!
languageName: newValue
	languageName := newValue! !

!OrbeonFormUserOptions methodsFor: 'Accessing' stamp: 'BrunoBB 11/05/2014 03:48'!
orbeonWebIsLinked

   "Return the value of the instance variable 'orbeonWebIsLinked'."
   ^orbeonWebIsLinked! !

!OrbeonFormUserOptions methodsFor: 'Updating' stamp: 'BrunoBB 11/05/2014 03:48'!
orbeonWebIsLinked: newValue

   "Modify the value of the instance variable 'orbeonWebIsLinked'."
   orbeonWebIsLinked := newValue! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/23/2015 11:43'!
setTransitionsDisplayMode: aBoolean

	aBoolean ifTrue: [^initialTransitionDisplayMode := #expanded].

	initialTransitionDisplayMode := #collapsed.! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
switchTransitionDisplayMode

	initialTransitionDisplayMode := (initialTransitionDisplayMode = #expanded) ifTrue: [#collapsed] ifFalse: [#expanded].! !

!OrbeonFormUserOptions methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:46'!
transitionDisplayModeIsExpanded

	^initialTransitionDisplayMode = #expanded! !

!OrbeonObject class methodsFor: 'other' stamp: 'BrunoBB 12/02/2013 09:16'!
new

	^super new initialize! !

!OrbeonObject methodsFor: 'other' stamp: 'BrunoBB 11/30/2013 13:55'!
addToCache

	^self class cache add: self! !

!OrbeonObject methodsFor: 'other' stamp: 'BrunoBB 04/16/2015 06:28'!
isGateway

	^false! !

!OrbeonObject methodsFor: 'other' stamp: 'BrunoBB 08/08/2014 07:41'!
removeFromCache

	^self class cache remove: self ifAbsent: []! !

Object subclass: #OrbeonPermissions
	instanceVariableNames: 'isEnabled permissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/14/2015 13:13'!
add: permissionName to: role

	^(permissions at: role ifAbsentPut: [OrderedCollection new]) add: permissionName! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 14:13'!
add: permissionName toAll: arrayRole

	arrayRole do: [:eachRole | self add: permissionName to: eachRole]! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 14:22'!
addAll: permissionNameArray toAll: arrayRole

	permissionNameArray do: [:eachPermission | 
		arrayRole do: [:eachRole | | newRoleName |
			newRoleName := (eachRole = 'all') ifTrue: ['anyone'] ifFalse: [eachRole].
			self add: eachPermission to: newRoleName]]! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/14/2015 14:48'!
has: roleName permission: permissionName
	"Answer whether or not the receiver has the permission <permissionName> for the role <roleName>.
	First check for the permission collection of -anyone- then check in the specific collection of the role <roleName>"

	^permissions at: 'anyone' ifPresent: [:permissionsCollection | 
		(permissionsCollection includes: permissionName) 	
		ifFalse: [(permissions at: roleName ifAbsent: [^false]) includes: permissionName]
		ifTrue: [true]].! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/15/2015 13:48'!
hasCreateAccess: roleName

	^self has: roleName permission: 'create'! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/15/2015 13:48'!
hasDeleteAccess: roleName

	^self has: roleName permission: 'delete'! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/15/2015 13:47'!
hasReadAccess: roleName

	^self has: roleName permission: 'read'! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/15/2015 13:48'!
hasUpdateAccess: roleName

	^self has: roleName permission: 'update'! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/14/2015 13:11'!
initialize

	super initialize.

	isEnabled := false.
	permissions := Dictionary new.! !

!OrbeonPermissions methodsFor: 'Accessing' stamp: 'BrunoBB 08/14/2015 13:10'!
isEnabled
	^isEnabled! !

!OrbeonPermissions methodsFor: 'Updating' stamp: 'BrunoBB 08/14/2015 13:10'!
isEnabled: newValue
	isEnabled := newValue! !

!OrbeonPermissions methodsFor: 'Accessing' stamp: 'BrunoBB 08/14/2015 13:10'!
permissions
	^permissions! !

!OrbeonPermissions methodsFor: 'Updating' stamp: 'BrunoBB 08/14/2015 13:10'!
permissions: newValue
	permissions := newValue! !

!OrbeonPermissions methodsFor: 'other' stamp: 'BrunoBB 08/14/2015 13:14'!
remove: permissionName from: role

	^(permissions at: role ifAbsent: [^nil]) remove: permissionName ifAbsent: [nil]! !

Object subclass: #OrbeonSynchronization
	instanceVariableNames: 'timeStamp count defUpdated insertCount updateCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonSynchronization class methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:00'!
count: anInteger

	^super new initialize
		count: anInteger;
		yourself! !

!OrbeonSynchronization class methodsFor: 'other' stamp: 'BrunoBB 11/18/2014 05:25'!
current

	^super new initialize
		timeStamp: (TimeStamp date: Date current time: Time now);
		yourself! !

!OrbeonSynchronization class methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:17'!
insertCount: insertCount updateCount: updateCount
 
	^super new initialize
		insertCount: insertCount;
		updateCount: updateCount;
		yourself! !

!OrbeonSynchronization class methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:00'!
old

	^super new initialize
		timeStamp: (TimeStamp date: (Date fromString: '01/01/1900') time: Time now);
		yourself! !

!OrbeonSynchronization methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:33'!
beDefinitionUpdate

	defUpdated := true! !

!OrbeonSynchronization methodsFor: 'Accessing' stamp: 'BrunoBB 01/22/2014 09:00'!
count

   "Return the value of the instance variable 'count'."
   ^count! !

!OrbeonSynchronization methodsFor: 'Updating' stamp: 'BrunoBB 01/22/2014 09:00'!
count: newValue

   "Modify the value of the instance variable 'count'."
   count := newValue! !

!OrbeonSynchronization methodsFor: 'Accessing' stamp: 'BrunoBB 01/22/2014 09:02'!
defUpdated

   "Return the value of the instance variable 'defUpdated'."
   ^defUpdated! !

!OrbeonSynchronization methodsFor: 'Updating' stamp: 'BrunoBB 01/22/2014 09:02'!
defUpdated: newValue

   "Modify the value of the instance variable 'defUpdated'."
   defUpdated := newValue! !

!OrbeonSynchronization methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:03'!
initialize

	super initialize.

	timeStamp := TimeStamp now.
	count := 0.
	defUpdated := false.
	insertCount := 0.
	updateCount := 0.! !

!OrbeonSynchronization methodsFor: 'Accessing' stamp: 'BrunoBB 01/22/2014 09:02'!
insertCount

   "Return the value of the instance variable 'insertCount'."
   ^insertCount! !

!OrbeonSynchronization methodsFor: 'Updating' stamp: 'BrunoBB 01/22/2014 09:02'!
insertCount: newValue

   "Modify the value of the instance variable 'insertCount'."
   insertCount := newValue! !

!OrbeonSynchronization methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:00'!
mySqlTimeStamp
	"The receiver answer aString of the time stamp in MySql format"
	| dateString timeString gsDateString |

	dateString := (timeStamp printString subStrings: ' ') first.
	timeString := (timeStamp printString subStrings: ' ') second.

	gsDateString := dateString subStrings: '/'.
	^gsDateString third, '-', gsDateString first, '-', gsDateString second, ' ', timeString! !

!OrbeonSynchronization methodsFor: 'other' stamp: 'BrunoBB 01/22/2014 09:00'!
setTimeStamp

	timeStamp := TimeStamp now.! !

!OrbeonSynchronization methodsFor: 'Accessing' stamp: 'BrunoBB 01/22/2014 09:00'!
timeStamp

   "Return the value of the instance variable 'timeStamp'."
   ^timeStamp! !

!OrbeonSynchronization methodsFor: 'Updating' stamp: 'BrunoBB 01/22/2014 09:00'!
timeStamp: newValue

   "Modify the value of the instance variable 'timeStamp'."
   timeStamp := newValue! !

!OrbeonSynchronization methodsFor: 'Accessing' stamp: 'BrunoBB 01/22/2014 09:02'!
updateCount

   "Return the value of the instance variable 'updateCount'."
   ^updateCount! !

!OrbeonSynchronization methodsFor: 'Updating' stamp: 'BrunoBB 01/22/2014 09:02'!
updateCount: newValue

   "Modify the value of the instance variable 'updateCount'."
   updateCount := newValue! !

Object subclass: #OrbeonUser
	instanceVariableNames: 'centralUser name password rols managerRole languageName'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 02/04/2016 10:11'!
addAdminUser

	^self newManagerNamed: 'admin' password: 'admin'! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
allRols

	^(self cache inject: OrderedCollection new into: [:all :each | all addAll: each rols. all]) asSet asSortedCollection! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
cache

	Cache ifNil: [self initializeCache].

	^Cache! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
cache: aCollection

	^Cache := aCollection! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
initializeCache
	"self initializeCache"
	Cache := Dictionary new.

	self addAdminUser.! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:44'!
migrateToApplicationUser

	self cache do: [:eachUser | 
		eachUser class migrateTo: OrbeonUser.
		eachUser migrate]! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
named: aString

	^self cache detect: [:each | each name = aString] ifNone: [nil]! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 02/04/2016 10:11'!
newManagerNamed: aString password: password

	^(self newNamed: aString password: password)
			managerRole: OrbeonManagerUserRole new;
			yourself! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 02/04/2016 10:11'!
newNamed: aString password: password
	| user centralUser |

	centralUser := ApplicationUser getExistingOrNewUserNamed: aString.
	centralUser password: password.

	user := self new initialize.
	user centralUser: centralUser.

	user addToCache.

	^user! !

!OrbeonUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
transformCache
	| newCache |

	newCache := Dictionary new.

	self cache do: [:each | newCache at: each name put: each].

	^newCache! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
addRol: rolName

	^rols add: rolName! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:46'!
addToCache

	^self class cache at: self name put: self! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:23'!
centralUser
	^centralUser! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:23'!
centralUser: newValue
	centralUser := newValue! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasCreatePermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'create' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasDeletePermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'delete' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasExportPermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'export' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasPermission: permissionName on: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^true
	"^rols anySatisfy: [:each | anObeonFormDefinition hasPermission: permissionName for: each]"! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasReadPermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'read' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasRol: rolName

	^rols includes: rolName! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasSynchronizePermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'sync' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
hasUpdatePermissionOn: anObeonFormDefinition
	"Answer whether the receiver has permission <permissionName> on Orbeon Form Definition <anObeonFormDefinition>"

	^self hasPermission: 'update' on: anObeonFormDefinition! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
initialize

	super initialize.

	rols := OrderedCollection new.
	managerRole := OrbeonManagerUserRole new.
	languageName := #english! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
isAdmin

	^managerRole isAdmin! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:23'!
languageName
	^languageName! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:23'!
languageName: newValue
	languageName := newValue! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:23'!
managerRole

   "Return the value of the instance variable 'managerRole'."
   ^managerRole! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:23'!
managerRole: newValue

   "Modify the value of the instance variable 'managerRole'."
   managerRole := newValue! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
managerRolName

	^managerRole roleName! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:35'!
migrateFrom: oldUser instVarMap: aMap

	super migrateFrom: oldUser instVarMap: aMap.

	centralUser := ApplicationUser getExistingOrNewUserNamed: name.
	centralUser password: password.! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:46'!
name

   "Return the value of the instance variable 'name'."
   ^centralUser username! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:46'!
name: newValue
   "Modify the value of the instance variable 'name'."

   centralUser username: newValue! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:47'!
password

   "Return the value of the instance variable 'password'."
   ^centralUser password! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:47'!
password: newValue

   "Modify the value of the instance variable 'password'."
   centralUser password: newValue! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:46'!
removeFromCache

	^self class cache removeKey: self name ifAbsent: [nil]! !

!OrbeonUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:23'!
removeRol: rolName

	^rols remove: rolName ifAbsent: []! !

!OrbeonUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:23'!
rols

   "Return the value of the instance variable 'rols'."
   ^rols! !

!OrbeonUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:23'!
rols: newValue

   "Modify the value of the instance variable 'rols'."
   rols := newValue! !

AbstractApplication subclass: #OrbeonApplication
	instanceVariableNames: 'formDefinitions instances definitionRegistry formProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
applicationNamed: aString ifNone: aBlock
	"Answer an OrbeonApplication or BpmApplication named <aString> if none evaluates the zero block argument <aBlock>"

	^self getOrbeonCache detect: [:each | each applicationName = aString] ifNone: aBlock! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 11:14'!
exampleRegistry
	| form app reg |

	app := self getOrbeonApplicationClass applicationNamed: 'asse'.
	reg := app registryForFormNamed: 'relevamiento_prestaciones_2015'.
	form := reg getLastVersion.

	^(SinglelineSimpleFormExport definition: form formsCollection: form instances) generatePrintArray.! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 09:19'!
formDefinitionNamed: aString in: appName
	"The receiver answer an <OrbeonFormDefinition> named <aString> in OrbeonApplication named <appName>.
	If the form definition does not exist then answer <nil>"
	| app |

	app := self applicationNamed: appName ifNone: [^nil].

	^app definitionNamed: aString! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
formsDefinitionNamed: aString
	| forms |

	forms := OrderedCollection new.
	self getOrbeonCache do:[:each | | form |
		form := each definitionNamed: aString.
		form ifNotNil: [forms add: form].].
	^forms! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:51'!
getAllDefinitionsWithId: stringId ifNone: aBlock
	| definitions |

	definitions := OrderedCollection new.

	(self getDefinitionWithId: stringId ifNone: [nil]) ifNotNil: [:def | definitions add: def].

	(self getSavedDefinitionWithId: stringId ifNone: [nil]) ifNotNil: [:def | definitions add: def].

	definitions isEmpty ifTrue: [^aBlock value].

	^definitions! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
getAllFormDefinitions
	| definitions |

	definitions := OrderedCollection new.
	self getOrbeonCache do: [:each | definitions addAll: each getAllDefinitions].

	^definitions! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
getAllInstances
	| instances |

	instances := OrderedCollection new.
	self getOrbeonCache do: [:each | instances addAll: each getAllInstances].

	^instances! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 11:16'!
getAllInstancesOf: appName definitionNamed: defName
	""
	| application registry |

	application := self getOrbeonApplicationClass applicationNamed: appName ifNone: [^#()].
	registry := application registryForFormNamed: defName ifNone: [^#()].

	^registry getInstancesOfAllVersions! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
getAllSavedDefinitions
	| all |

	all := OrderedCollection new.
	self getOrbeonCache do: [:each | all addAll: each getAllSavedDefinitions].

	^all! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:51'!
getAnyDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer any form definition with id <stringId> if none evaluate the block <aBlock>.
	1- Search in all Published Forms.
	2- If there is no published form search in saved forms"

	^self getDefinitionWithId: stringId ifNone: [self getSavedDefinitionWithId: stringId ifNone: aBlock]! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAnyDraftWith: id formName: formNamed in: appName ifNone: aBlock
	| application definitions |

	application := self applicationNamed: appName ifNone: [^aBlock value].
	definitions := application getAllDefinitionsNamed: formNamed ifNone: [^aBlock value].

	definitions do: [:each | (each getDraftWithId: id) ifNotNil: [:form | ^form]].

	^aBlock value! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAnyInstanceWith: id formName: formNamed in: appName ifNone: aBlock
	| application definitions |

	application := self applicationNamed: appName ifNone: [^aBlock value].
	definitions := application getAllDefinitionsNamed: formNamed ifNone: [^aBlock value].

	definitions do: [:each | (each getInstanceWithId: id) ifNotNil: [:form | ^form]].

	^aBlock value! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
getDefinitionWithId: stringId ifNone: aBlock
	| application |

	application := self getOrbeonCache detect: [:eachApp | (eachApp getDefinitionWithId: stringId ifNone: [nil]) notNil] ifNone: [^aBlock value].

	^application getDefinitionWithId: stringId ifNone: aBlock! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:51'!
getFromApplicationNamed: appName definitionNamed: defName version: version ifNone: aBlock
	"Answer the OrbeonFormDefinition named <defName> and version equal to <version> from the OrbeonApplication named <appName> if none evaluate <aBlock>"
	| app |

	app := self applicationNamed: appName ifNone: [^aBlock value].

	(app hasDefinitionNamed: defName) ifFalse: [^aBlock value].

	^(app getAllDefinitionsNamed: defName) detect: [:each | each version = version] ifNone: [aBlock value]! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:19'!
getLastDefinitions
	| lasts |

	lasts := OrderedCollection new.
	self getOrbeonCache do: [:each | lasts addAll: each getLastDefinitions].

	^lasts! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getLatestSavedDefinition: formName app: app 
	"Answer the lastest saved definition named <formName> in orbeon application named <app>.
	If any search fail then rise an exception"
	| application |

	application := self applicationNamed: app ifNone: [^NoApplicationException signal: 'No application named [', app,'] was found'].

	^application getLatestSavedDefinition: formName! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getSavedDefinition: formName app: app withId: id
	"Answer the saved definition named <formName> with id <id> in orbeon application named <app>.
	If any search fail then rise an exception"
	| application |

	application := self applicationNamed: app ifNone: [^NoApplicationException signal: 'No application named [', app,'] was found'].

	^application 
		getSavedDefinitionFor: formName 
		withId: id 
		ifNone: [^NoOrbeonFormException signal: 'Fo form named [', formName, '] was found'].! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:20'!
getSavedDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer anOrbeonInstanceDefinition with id <stringId> if none evaluate the block <aBlock> "
	| appCollection |

	appCollection := (self getOrbeonCache select: [:eachApp | (eachApp getSavedDefinitionWithId: stringId ifNone: [nil]) notNil]) asArray.

	^appCollection isEmpty
		ifFalse: [appCollection last getSavedDefinitionWithId: stringId ifNone: aBlock]
		ifTrue: aBlock! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:51'!
hasFormDefinitionNamed: aString


	^(self definitionNamed: aString) notEmpty! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
includesDefinitionNamed: aString in: appName
	| forms app |

	app := self applicationNamed: appName ifNone: [^false].

	^(app definitionNamed: aString) ifNil: [false] ifNotNil: [true]! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 11:36'!
initializeAllCache
	"self initializeCache"

	self initializeCache.
	OrbeonFormDefinition initializeCache.
	OrbeonFormInstance initializeCache.
	OrbeonFormInstanceDefinition initializeCache.! !

!OrbeonApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
logicalRemoveDefinitionWithId: stringId ifNone: aBlock
	| instanceDefinition |

	instanceDefinition := self getSavedDefinitionWithId: stringId ifNone: [^aBlock value].

	instanceDefinition logicalDelete. "delete the OrbeonFormInstanceDefinition"

	instanceDefinition definition logicalDelete.  "delete the OrbeonFormDefinition"! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
addInstance: anOrbeonFormInstance

	^instances at: anOrbeonFormInstance id put: anOrbeonFormInstance! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
addPublishedDefinition: anOrbeonFormDefinition
	"Add a new form definition <anOrbeonFormDefinition> to receiver's registry"

	(self hasRegistryFor: anOrbeonFormDefinition) "check if the registry already exist, if not it creates it"
	ifFalse: [self createRegistryFor: anOrbeonFormDefinition].

	"add the definition to the registry"
	^(self registryFor: anOrbeonFormDefinition) addCurrentVersion: anOrbeonFormDefinition! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
addSavedDefinition: anOrbeonFormInstanceDefinition
	"Add a new saved definition <anOrbeonFormInstanceDefinition> to receiver's registry"

	(self hasRegistryFor: anOrbeonFormInstanceDefinition) "check if the registry already exist, if not it creates it"
	ifFalse: [self createRegistryFor: anOrbeonFormInstanceDefinition].

	"add the definition to the registry"
	^(self registryFor: anOrbeonFormInstanceDefinition) addSavedDefinition: anOrbeonFormInstanceDefinition! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
addTestPermissions

	self getLastDefinitions do: [:each | each addTestPermissions].! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 09:53'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	Smalltalk at: #BpmApplication ifAbsent: [^definitionRegistry isEmpty]. "the BPM application is NOT installed in the system"

	^definitionRegistry isEmpty and: [super canDelete] "the BPM application is installed in the system --> check BPM dependencies"! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
createDefinitionRegistry
	"Update the receiver from the old structure to the new one <definitionRegistry>"

	formDefinitions keysAndValuesDo: [:key :defCollection |  | registry |
		registry := definitionRegistry at: key put: (FormDefintionRegistry newFor: self).
		defCollection do: [:eachDef | registry addCurrentVersion: eachDef].
	].! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
createRegistryFor: anOrbeonFormDefinition
	"The receiver creates a definition registry for <anOrbeonFormDefinition>"

	^definitionRegistry 
		at: anOrbeonFormDefinition form 
		put: (FormDefintionRegistry newFor: self)! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
definitionNamed: aString
	"Answer anOrbeonFormDefinition named <aString> if none answer <nil>"

	^self definitionNamed: aString ifNone: [nil]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
definitionNamed: aString ifNone: aBlock
	"Answer the latest version of anOrbeonFormDefinition named <aString> if none evaluate <aBlock>."

	^(self registryForFormNamed: aString ifNone: [^aBlock value]) getLastVersion! !

!OrbeonApplication methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 13:52'!
definitionRegistry

   "Return the value of the instance variable 'definitionRegistry'."
   ^definitionRegistry! !

!OrbeonApplication methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 13:52'!
definitionRegistry: newValue

   "Modify the value of the instance variable 'definitionRegistry'."
   definitionRegistry := newValue! !

!OrbeonApplication methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 13:52'!
formDefinitions

   "Return the value of the instance variable 'formDefinitions'."
   ^formDefinitions! !

!OrbeonApplication methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 13:52'!
formDefinitions: newValue

   "Modify the value of the instance variable 'formDefinitions'."
   formDefinitions := newValue! !

!OrbeonApplication methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 13:52'!
formProcesses

   "Return the value of the instance variable 'formProcesses'."
   ^formProcesses! !

!OrbeonApplication methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 13:52'!
formProcesses: newValue

   "Modify the value of the instance variable 'formProcesses'."
   formProcesses := newValue! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllDefinitions
	"The receiver answer anOrderedCollection with all OrbeonFormDefinition.
	Iterate over all definition registry asking all versions"
	| all |

	all := OrderedCollection new.
	(definitionRegistry select: [:each | each hasVersions]) do: [:each | all addAll: each getAllVersion].

	^all! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllDefinitionsNamed: aString
	"Answer a collection with all latest versions of OrbeonFormDefinition named <aString> if none answer an empty collection.
	It can be more than one definition with version 1 --> answer the latest version 1"

	^self getAllDefinitionsNamed: aString ifNone: [OrderedCollection new].! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllDefinitionsNamed: aString ifNone: aBlock
	"Answer a collection with all latest versions of OrbeonFormDefinition named <aString> if none then evaluate <aBlock>.
	It can be more than one definition with version 1 --> answer the latest version 1"
	| registry |

	(self hasRegistryForFormNamed: aString) ifFalse: [^aBlock value].

	registry := self registryForFormNamed: aString.

	^registry hasVersions 
		ifTrue: [registry oldVersions, registry currentVersions] 
		ifFalse: [aBlock value]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllInstances
	"Answer a collection with all form instances <OrbeonFormInstance> of the receiver.
	Collect instances from all receiver's registries <FormDefinitionRegistry>"
	| all |

	all := OrderedCollection new.
	definitionRegistry do: [:each | all addAll: each getAllInstances].

	^all! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllInstancesKeysOfFormNamed: formName
	"The receiver answer all keys of form instances of form definition named <formName>"

	^(self registryForFormNamed: formName ifNone: [^#()]) getAllInstancesKeys! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllSavedDefinitions
	| all |

	all := OrderedCollection new.
	definitionRegistry do: [:each | all addAll: each getSavedDefinitions].

	^all! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAllSearchFieldsOf: formName
	"The receiver answer a collection with all search fields of the form definition named <formName>"

	^(self registryForFormNamed: formName ifNone: [^#()]) getAllSearchFields! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAnyDraftWithId: stringId of: formName
	"The receiver answer anOrbeonFormInstance with id <stringId> if none evaluates the block <aBlock>"

	^(self registryForFormNamed: formName ifNone: [^nil]) getAnyDraftWithId: stringId ifNone: [nil]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAnyInstanceWithId: stringId of: formName
	"The receiver answer anOrbeonFormInstance with id <stringId> if none evaluates the block <aBlock>"

	^self getAnyInstanceWithId: stringId of: formName ifNone: [nil]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getAnyInstanceWithId: stringId of: formName ifNone: aBlock
	"The receiver answer anOrbeonFormInstance with id <stringId> if none evaluates the block <aBlock>"

	^(self registryForFormNamed: formName ifNone: [^aBlock value]) getAnyInstanceWithId: stringId ifNone: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 16:32'!
getApplicationNameForCombo

	^applicationName , ' [Orbeon]'! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getDefinitionNamed: aString withVersion: version ifNone: aBlock
	"Answer the latest version of anOrbeonFormDefinition named <aString> with version <version> if none evaluate <aBlock>."

	^(self registryForFormNamed: aString ifNone: [^aBlock value]) getDefinitionVersion: version ifNone: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer anOrbeonFormDefinition with id <stringId> if none evaluates the block <aBlock>.
	1- Goes over all FormDefinitionRegistry of the receiver asking if contains the id <stringId>.
	2- Use the registry the get the form definition"
	| registry |

	registry := definitionRegistry detect: [:eachReg | (eachReg getDefinitionWithId: stringId ifNone: [nil]) notNil] ifNone: [^aBlock value].

	^registry getDefinitionWithId: stringId ifNone: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getLastDefinitions
	"The receiver answer a collection with the latest version of all registered form definitions"

	^((definitionRegistry select: [:each | each hasVersions]) collect: [:each | each getLastVersion]) select: [:each | each deleted = 'N']! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getLastFormDefinitionVersionOf: formName
	"The receiver answer the last version number of the form definition named <formName>"

	^(self registryForFormNamed: formName ifNone: [^0]) getLastVersionNumber! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getLatestSavedDefinition: formName
	"The receiver answer <anOrbeonFormInstanceDefinition> with id <stringId> if none evaluate the block <aBlock>"
	| registry |

	registry := (self registryForFormNamed: formName 
						ifNone: [^NoOrbeonFormException signal: 'No form saved definition named [' formName, '] was found']).

	^registry getLastSavedDefinition! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getSavedDefinitionFor: formName withId: stringId ifNone: aBlock
	"The receiver answer <anOrbeonFormInstanceDefinition> with id <stringId> if none evaluate the block <aBlock>"

	^(self registryForFormNamed: formName ifNone: [^aBlock value]) getSavedDefinitionWithId: stringId ifNone: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
getSavedDefinitionWithId: stringId ifNone: aBlock
	"The receiver answer <anOrbeonFormInstanceDefinition> with id <stringId> if none evaluate the block <aBlock>"
	| registry |

	registry := definitionRegistry detect: [:eachReg | eachReg includesSavedDefinitionWithId: stringId] ifNone: [^aBlock value].

	^registry getSavedDefinitionWithId: stringId ifNone: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
hasDefinitionNamed: aString
	"Answer whether or not the receiver has a form definiton named <aString>"

	^(self hasRegistryForFormNamed: aString) and:[(self registryForFormNamed: aString) hasVersions]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
hasReadAccess: anOrbeonUser
	"Answer whether or not the user <anOrbeonUser> has read permission over the receiver.
	If an user has read permission over a definition then has read access over the application (the receiver)"

	^self getLastDefinitions anySatisfy: [:each | anOrbeonUser hasReadPermissionOn: each]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
hasRegistryFor: anOrbeonFormDefinition
	"Answer whether or not the receiver has a registry for form definition <anOrbeonFormDefinition>"

	^self hasRegistryForFormNamed: anOrbeonFormDefinition form! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
hasRegistryForFormNamed: aString
	"Answer whether or not the receiver has a registry for form definition named <aString>"

	^definitionRegistry includesKey: aString! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
initialize

	super initialize.

	applicationName := ''.
	formDefinitions := Dictionary new.
	instances := RcKeyValueDictionary new. "to hold instances by <id>, more easy to syncrhonize instance's update"
	definitionRegistry := RcKeyValueDictionary new. "aDictionary of Collections (each Collection with OrbeonFormDefinition objects)"! !

!OrbeonApplication methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 13:52'!
instances

   "Return the value of the instance variable 'instances'."
   ^instances! !

!OrbeonApplication methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 13:52'!
instances: newValue

   "Modify the value of the instance variable 'instances'."
   instances := newValue! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:18'!
isObeonApplication

	^true! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
numberOfInstances
	"Answer the number of instances of all form definitions combined"

	^self getAllDefinitions inject: 0 into: [:sum :each | sum + each numberOfInstances]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' (', applicationName, ')'.! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
registryFor: anOrbeonFormDefinition
	"Answer the registry <FormDefinitionRegistry> for the form definition <anOrbeonFormDefinition> if none raise an Exception"

	^self registryForFormNamed: anOrbeonFormDefinition form
			ifNone: [FormRegistryNotExistException signal: 'No registry available for :', anOrbeonFormDefinition form]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
registryForFormNamed: aString
	"Answer the registry <FormDefinitionRegistry> for the form definition named <aString> if none the raise an Exception"

	^self registryForFormNamed: aString ifNone: [FormRegistryNotExistException signal: 'No registry available for :', aString]! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
registryForFormNamed: aString ifNone: aBlock
	"Answer the registry <FormDefinitionRegistry> for the definition named <aString> if none then evaluate <aBlock>"

	^definitionRegistry at: aString ifAbsent: aBlock! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
removeDefinition: anOrbeonFormDefinition
	"The receiver remove the form definition <anOrbeonFormDefinition> from the registry"

	(self hasRegistryFor: anOrbeonFormDefinition) ifFalse: [^anOrbeonFormDefinition].

	^(self registryFor: anOrbeonFormDefinition) removeDefinition: anOrbeonFormDefinition! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
removeInstance: anOrbeonFormInstance

	^instances removeKey: anOrbeonFormInstance id! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
removeInstanceDefinition: anOrbeonFormInstanceDefinition
	"The receiver remove the form definition <anOrbeonFormInstanceDefinition> from the registry"

	(self hasRegistryFor: anOrbeonFormInstanceDefinition) ifFalse: [^anOrbeonFormInstanceDefinition].

	^(self registryFor: anOrbeonFormInstanceDefinition) removeInstanceDefinition: anOrbeonFormInstanceDefinition! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
unregisterDefinition: anOrbeonFormDefinition
	"Unregister from registry <FormDefinitionRegistry> the definition <anOrbeonFormDefinition> if absent answer nil"

	^self unregisterDefinitionNamed: anOrbeonFormDefinition name! !

!OrbeonApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:52'!
unregisterDefinitionNamed: aString
	"Unregister from registry <FormDefinitionRegistry> the definition named <aString> if absent answer nil"

	^definitionRegistry removeKey: aString ifAbsent: [nil]! !

Exception subclass: #OrbeonException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #FormIdNotExistException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #FormRegistryNotExistException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #NoOrbeonAppException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!NoOrbeonAppException commentStamp: 'BrunoBB 10/26/2014 16:50' prior: 0!
When OrbeonFormProcessDefinition has NO OrbeonApplication this exception arise.!

OrbeonException subclass: #NoOrbeonFormException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #NoSuchObjectInCacheException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #OrbeonControlSizeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #OrbeonDefinitionNotFoundException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

OrbeonException subclass: #OrbeonInvalidXMLException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon'!

!UndefinedObject methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:16'!
printMySqlString

	^'nil'! !

!String methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:15'!
printMySqlString

	^self! !

!Time class methodsFor: '*orbeon' stamp: 'BrunoBB 02/12/2014 09:25'!
fromMySqlString: aString

	^Time fromString: aString! !

!Time methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:16'!
printMySqlString

	^self hours printString, ':', self minutes printString! !

!Number methodsFor: '*orbeon' stamp: 'BrunoBB 07/02/2014 18:14'!
printMySqlString

	^self printString! !

!OrbeonWebLocalLogin methodsFor: '*orbeon' stamp: 'BrunoBB 12/21/2015 08:52'!
validateUser: username password: password

	^OrbeonUser cache anySatisfy: [:each | each name = username and:[each password = password]]! !
